-- start of an animation

--[[
-- Possible parameters:
GH.anim.run()
GH.anim.run(client)
GH.anim.run(client, scene)
GH.anim.run(nil, scene)
GH.anim.run(client, "name", scene)
GH.anim.run("name", scene) --> GH.anim.run("", scene)
GH.anim.run("name")
--]]

GH = GH or {}
GH.anim = GH.anim or {}

GH.Modifier = getClass("Modifier")
GH.ModifierRoot = getClass("ModifierRoot")
GH.ModifierGroup = getClass("ModifierGroup")
GH.ModifierFraction = getClass("ModifierFraction")
GH.ModifierAlpha = getClass("ModifierAlpha")
GH.ModifierDelay = getClass("ModifierDelay")

GH.Modifier.kInitialized = GH.bit1
GH.Modifier.kIsDone = GH.bit2

function GH.anim.run(...)
	local argc = 1

	local lClient = nil
	local lName = ""
	local lScene = scene

	local args = {...}
    if type(args[argc]) == "table" then
		lClient = args[argc]
		argc = argc + 1
    end

    if isString(args[argc]) then
		lName = args[argc]
		argc = argc + 1
    end

    if isTable(args[argc]) then
		lScene = args[argc]
    end

    local group = GH.anim.animation(lScene, lName)
    if (lClient) then
		group.client = lClient
    end

	return group
end

-- setup for the shortcut functions
function GH.anim.setup(t, modClass)
    local t = table.copy(t)
    t.class = modClass
    return t
end

-- alpha shortcut
function GH.anim.alpha(t)
    return GH.anim.setup(t, "ModifierAlpha")
end
