manifestURL = "http://downloadserver.herokuapp.com/packages/query"

languageId =
{
	["Dutch"] = "4",
	["English"] = "2",
	["French"] = "16",
	["German"] = "8",
	["Italian"] = "12",
	["Portuguese"] = "6",
	["Spanish"] = "14",
	["Swedish"] = "10",
	["Russian"] = "18",
}

defaultMusicVolume = 1.0
defaultSoundVolume = 1.0
dialogFadeTime = 200
storyFadeDuration = 800
storyBarsDuration = 900
guiHudMoveHeight = 0
musicFadeOut_quick = 600
musicFadeDelay_quick = 300
musicFadeIn_quick = 600
musicFadeOut_slow = 1600
musicFadeDelay_slow = 1200
musicFadeIn_slow = 1600
sparkles_per_pixel = 1/40
--pixelsPerMeter = (2048 / 40) / 7 -- 1 screen = 1024 pix / 20 m (3.5 is for gameplay)
pixelsPerMeter = 2048 / 16
defaultMessageBalloonWidth = 550

-- HintArrow
hintArrowAnimation = "hint_arrow:gamescene"
hintArrowAnimationGlow = "hint_arrow_glow:gamescene"


pathSettings = {
	-- Slanting
	doSlanting = true,
	maxAxisDelta = 10,
	maxPointDelta = 12,
	maxSlope = 1/12,
	-- Rounding
	doRounding = true,
	roundingRadius = 25,
	anglePerArcPoint = math.pi*2 / 16,
}
doMagnifyTooltipSprite = true
defaultMagnifyTooltipItemScale = 1.5
globalThrowDuration = 420
globalMouseScore = 100
-- inAppPurchaseIds must be a GLOBAL.
inAppPurchaseIds = {}

function getBuyId(id)
	return inAppPurchaseIds[id] or id
end

-- Set the Firebase RemoteConfig defaults here
GH = GH or {}
GH.remoteConfig = GH.remoteConfig or {
	"test1",
	"AdsEnabled",
	"AdsKeywords",
	"AdsAbTest_AdLocation",
	"AdsAbTest_MapBuyButton"
}

GH.ABTest = GH.ABTest or {}
GH.ABTest["test1"] = "test1_userproperty"


if (isKindle) then
	inAppPurchaseIds =
	{
		EPISODES_TEST  = "pl2amazontest",
		EPISODES_ALL   = "pl2amazonfullgame",
		EPISODES_PACK1 = "pl2amazonrest1_2",
		EPISODES_PACK2 = "pl2amazonrest3_4",
		EPISODES_PACK3 = "pl2amazonrest5_6",
	}
elseif (isAndroidStore or isClean) then
	inAppPurchaseIds =
	{
		--EPISODES_TEST  = "com.pl2gp.test",
		EPISODES_ALL   = "pl2.gp.fullgame.999",
		EPISODES_PACK1 = "pl2.gp.partial.1.199",
		EPISODES_PACK2 = "pl2.gp.partial.2.499",
		EPISODES_PACK3 = "pl2.gp.partial.3.499",
	}
elseif (isiPhone) then
	inAppPurchaseIds =
	{
		--EPISODES_TEST  = "pl2.ios.consumable.test",
        EPISODES_ALL   	= "pl2.ios.fullgame.999",
		EPISODES_ALL_EUR   = "pl2.ios.fullgame.999.eur",
        EPISODES_PACK1 = "pl2.ios.partial.1.199",
        EPISODES_PACK2 = "pl2.ios.partial.2.499",
        EPISODES_PACK3 = "pl2.ios.partial.3.499",
	}
elseif (isiPad) then
	inAppPurchaseIds =
	{
		--EPISODES_TEST  = "pl2.ios.consumable.test",
         EPISODES_ALL   	= "pl2.ios.fullgame.999",
		EPISODES_ALL_EUR   = "pl2.ios.fullgame.999.eur",
        EPISODES_PACK1 = "pl2.ios.partial.1.199",
        EPISODES_PACK2 = "pl2.ios.partial.2.499",
        EPISODES_PACK3 = "pl2.ios.partial.3.499",
	}
elseif (isiOSUniversal) then
    inAppPurchaseIds =
	{
		--EPISODES_TEST  = "pl2.ios.consumable.test",
        EPISODES_ALL   	= "pl2.ios.fullgame.999",
		EPISODES_ALL_EUR   = "pl2.ios.fullgame.999.eur",
        EPISODES_PACK1 = "pl2.ios.partial.1.199",
        EPISODES_PACK2 = "pl2.ios.partial.2.499",
        EPISODES_PACK3 = "pl2.ios.partial.3.499",
	}
end

achievementIds = {}
function getAchievementId(id)
	return achievementIds[id] or id
end

if (isKindle) then
	achievementIds =
	{
		["TROPHY_1"]  = "pl2_kindle_collect1",
		["TROPHY_2"]  = "pl2_kindle_collect2",
		["TROPHY_3"]  = "pl2_kindle_collect3",
		["TROPHY_4"]  = "pl2_kindle_collect4",
		["TROPHY_5"]  = "pl2_kindle_collect5",
		["TROPHY_6"]  = "pl2_kindle_collect6",
		["TROPHY_7"]  = "pl2_kindle_collect7",
		["TROPHY_8"]  = "pl2_kindle_collect8",
		["TROPHY_9"]  = "pl2_kindle_collect9",
		["TROPHY_10"] = "pl2_kindle_collect10",
		["TROPHY_11"] = "pl2_kindle_collect11",
		["TROPHY_12"] = "pl2_kindle_collect12",
		["TROPHY_13"] = "pl2_kindle_collect13",
		["TROPHY_14"] = "pl2_kindle_collect14",
		["TROPHY_15"] = "pl2_kindle_collect15",
		["TROPHY_16"] = "pl2_kindle_collect16",
	}
elseif (isAndroidStore) then
	achievementIds =
	{
		["TROPHY_1"]  = "CgkIvqyd_K4KEAIQAA",
		["TROPHY_2"]  = "CgkIvqyd_K4KEAIQAQ",
		["TROPHY_3"]  = "CgkIvqyd_K4KEAIQAg",
		["TROPHY_4"]  = "CgkIvqyd_K4KEAIQAw",
		["TROPHY_5"]  = "CgkIvqyd_K4KEAIQBA",
		["TROPHY_6"]  = "CgkIvqyd_K4KEAIQBQ",
		["TROPHY_7"]  = "CgkIvqyd_K4KEAIQBg",
		["TROPHY_8"]  = "CgkIvqyd_K4KEAIQBw",
		["TROPHY_9"]  = "CgkIvqyd_K4KEAIQCA",
		["TROPHY_10"] = "CgkIvqyd_K4KEAIQCQ",
		["TROPHY_11"] = "CgkIvqyd_K4KEAIQCg",
		["TROPHY_12"] = "CgkIvqyd_K4KEAIQCw",
		["TROPHY_13"] = "CgkIvqyd_K4KEAIQDA",
		["TROPHY_14"] = "CgkIvqyd_K4KEAIQDQ",
		["TROPHY_15"] = "CgkIvqyd_K4KEAIQDg",
		["TROPHY_16"] = "CgkIvqyd_K4KEAIQDw",
	}
elseif (isiPhone) then
	achievementIds =
	{
        ["TROPHY_1"]  = "com.gamehouse.pl1.ACHIEVEMENT_1",
        ["TROPHY_2"]  = "com.gamehouse.pl1.ACHIEVEMENT_2",
        ["TROPHY_3"]  = "com.gamehouse.pl1.ACHIEVEMENT_3",
        ["TROPHY_4"]  = "com.gamehouse.pl1.ACHIEVEMENT_4",
        ["TROPHY_5"]  = "com.gamehouse.pl1.ACHIEVEMENT_5",
        ["TROPHY_6"]  = "com.gamehouse.pl1.ACHIEVEMENT_6",
        ["TROPHY_7"]  = "com.gamehouse.pl1.ACHIEVEMENT_7",
        ["TROPHY_8"]  = "com.gamehouse.pl1.ACHIEVEMENT_8",
        ["TROPHY_9"]  = "com.gamehouse.pl1.ACHIEVEMENT_9",
        ["TROPHY_10"] = "com.gamehouse.pl1.ACHIEVEMENT_10",
        ["TROPHY_11"] = "com.gamehouse.pl1.ACHIEVEMENT_11",
        ["TROPHY_12"] = "com.gamehouse.pl1.ACHIEVEMENT_12",
        ["TROPHY_13"] = "com.gamehouse.pl1.ACHIEVEMENT_13",
        ["TROPHY_14"] = "com.gamehouse.pl1.ACHIEVEMENT_14",
		["TROPHY_15"] = "com.gamehouse.pl1.ACHIEVEMENT_15",
		["TROPHY_16"] = "com.gamehouse.pl1.ACHIEVEMENT_16",
	}
elseif (isiOSUniversal) then
    achievementIds =
    {
        ["TROPHY_1"]  = "com.gamehouse.pl1.ACHIEVEMENT_1",
        ["TROPHY_2"]  = "com.gamehouse.pl1.ACHIEVEMENT_2",
        ["TROPHY_3"]  = "com.gamehouse.pl1.ACHIEVEMENT_3",
        ["TROPHY_4"]  = "com.gamehouse.pl1.ACHIEVEMENT_4",
        ["TROPHY_5"]  = "com.gamehouse.pl1.ACHIEVEMENT_5",
        ["TROPHY_6"]  = "com.gamehouse.pl1.ACHIEVEMENT_6",
        ["TROPHY_7"]  = "com.gamehouse.pl1.ACHIEVEMENT_7",
        ["TROPHY_8"]  = "com.gamehouse.pl1.ACHIEVEMENT_8",
        ["TROPHY_9"]  = "com.gamehouse.pl1.ACHIEVEMENT_9",
        ["TROPHY_10"] = "com.gamehouse.pl1.ACHIEVEMENT_10",
        ["TROPHY_11"] = "com.gamehouse.pl1.ACHIEVEMENT_11",
        ["TROPHY_12"] = "com.gamehouse.pl1.ACHIEVEMENT_12",
        ["TROPHY_13"] = "com.gamehouse.pl1.ACHIEVEMENT_13",
        ["TROPHY_14"] = "com.gamehouse.pl1.ACHIEVEMENT_14",
		["TROPHY_15"] = "com.gamehouse.pl1.ACHIEVEMENT_15",
		["TROPHY_16"] = "com.gamehouse.pl1.ACHIEVEMENT_16",
    }
elseif (isiPad) then
	achievementIds =
	{
         ["TROPHY_1"]  = "com.gamehouse.pl1.ACHIEVEMENT_1",
        ["TROPHY_2"]  = "com.gamehouse.pl1.ACHIEVEMENT_2",
        ["TROPHY_3"]  = "com.gamehouse.pl1.ACHIEVEMENT_3",
        ["TROPHY_4"]  = "com.gamehouse.pl1.ACHIEVEMENT_4",
        ["TROPHY_5"]  = "com.gamehouse.pl1.ACHIEVEMENT_5",
        ["TROPHY_6"]  = "com.gamehouse.pl1.ACHIEVEMENT_6",
        ["TROPHY_7"]  = "com.gamehouse.pl1.ACHIEVEMENT_7",
        ["TROPHY_8"]  = "com.gamehouse.pl1.ACHIEVEMENT_8",
        ["TROPHY_9"]  = "com.gamehouse.pl1.ACHIEVEMENT_9",
        ["TROPHY_10"] = "com.gamehouse.pl1.ACHIEVEMENT_10",
        ["TROPHY_11"] = "com.gamehouse.pl1.ACHIEVEMENT_11",
        ["TROPHY_12"] = "com.gamehouse.pl1.ACHIEVEMENT_12",
        ["TROPHY_13"] = "com.gamehouse.pl1.ACHIEVEMENT_13",
        ["TROPHY_14"] = "com.gamehouse.pl1.ACHIEVEMENT_14",
		["TROPHY_15"] = "com.gamehouse.pl1.ACHIEVEMENT_15",
		["TROPHY_16"] = "com.gamehouse.pl1.ACHIEVEMENT_16",
	}
else
	achievementIds =
	{
		 ["TROPHY_1"]  = "com.gamehouse.pl1.ACHIEVEMENT_1",
        ["TROPHY_2"]  = "com.gamehouse.pl1.ACHIEVEMENT_2",
        ["TROPHY_3"]  = "com.gamehouse.pl1.ACHIEVEMENT_3",
        ["TROPHY_4"]  = "com.gamehouse.pl1.ACHIEVEMENT_4",
        ["TROPHY_5"]  = "com.gamehouse.pl1.ACHIEVEMENT_5",
        ["TROPHY_6"]  = "com.gamehouse.pl1.ACHIEVEMENT_6",
        ["TROPHY_7"]  = "com.gamehouse.pl1.ACHIEVEMENT_7",
        ["TROPHY_8"]  = "com.gamehouse.pl1.ACHIEVEMENT_8",
        ["TROPHY_9"]  = "com.gamehouse.pl1.ACHIEVEMENT_9",
        ["TROPHY_10"] = "com.gamehouse.pl1.ACHIEVEMENT_10",
        ["TROPHY_11"] = "com.gamehouse.pl1.ACHIEVEMENT_11",
        ["TROPHY_12"] = "com.gamehouse.pl1.ACHIEVEMENT_12",
        ["TROPHY_13"] = "com.gamehouse.pl1.ACHIEVEMENT_13",
        ["TROPHY_14"] = "com.gamehouse.pl1.ACHIEVEMENT_14",
		["TROPHY_15"] = "com.gamehouse.pl1.ACHIEVEMENT_15",
		["TROPHY_16"] = "com.gamehouse.pl1.ACHIEVEMENT_16",
	}
end
