local coinJump = {

	image = "rotating_coin:ui",

	minHeight = 600*2,

	maxHeight = 800*2,

	duration = 1000,

	scaleUpDuration = 120,

	scaleDownDuration = 400,

	startScale = 0.0,

	midScale = 1.5*2,

	endScale = 0.3*2,

	theFrameTime = 10,

}



local deliveryCountingSounds = {

	"count1:sound",

}



local deliveryCoinJumpSounds = {

	"coin1:sound",

}



local checkoutCoinJumpSounds = {

	"coin1:sound",

	"coin2:sound",

	"coin3:sound",

	"coin4:sound",

	"coin5:sound",

	"coin6:sound",

	"coin7:sound",

	"coin8:sound",

	"coin9:sound",

}



floaters = floaters or {}



floaters.zeroFloaterColor = {

	{r=255/255, g=128/255, b=128/255},

	{r=255/255, g=0/255, b=0/255},

}



floaters.generic = {
	font = "main_stroke_font:fonts",
	textSize = 70,
	sounds = deliveryCoinJumpSounds,
	fontColor = {
		-- Green
		{r=161/255, g=255/255, b=0/255},
		{r=38/255, g=92/255, b=6/255},
	},
	bonus = {
		textId = "EVENT_SCORE_ALL_DONE_FMT",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		tailEffect = "deliver_full_order",
	},
}



floaters.eventItemDone = floaters.generic

floaters.eventDone = floaters.generic

floaters.mouse = floaters.generic


floaters.fullOrder =
{
	font = "main_stroke_font:fonts",
	textSize = 60,
	lineHeight = 50,
	textId = "DELIVER_FULL_ORDER",
	sounds = deliveryCoinJumpSounds,
	fontColor = {
		-- Blue
		{r=58/255, g=234/255, b=255/255}, -- Inner
		{r=15/255, g=80/255, b=129/255}, -- Border
	},
	bonus = {
		textId = "DELIVER_FULL_ORDER_FMT",
		fontColor =  {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "deliver_full_order",
	},
}

floaters.deliverCombo =
{
	font = "main_stroke_font:fonts",
	textSize = 70,
	lineHeight = 50,
	textId = "DELIVER_COMBO",
	sounds = deliveryCoinJumpSounds,
	fontColor = {
		-- Purple
		{r=237/255, g=167/255, b=254/255}, -- Inner
		{r=109/255, g=23/255, b=6/255}, -- Border
	},
	bonus = {
		textId = "DELIVER_COMBO_FMT",
		fontColor =
		{
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	extraText = {
		location = {10, 0},
		textSize = 140,
		textId = "DELIVER_COMBO_EXTRA_FMT",
		fontColor = {
			-- Purple
			{r=237/255, g=167/255, b=254/255}, -- Inner
			{r=109/255, g=23/255, b=6/255}, -- Border
		},

	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "deliver_combo",
	},
}



floaters.quickBonus =

{
	font = "main_stroke_font:fonts",
	textSize = 70,
	textId = "QUICK_BONUS",
	sounds = deliveryCoinJumpSounds,
	fontColor = {
		-- Purple
		{r=237/255, g=167/255, b=254/255}, -- Inner
		{r=109/255, g=23/255, b=6/255}, -- Border
	},

	bonus = {
		textId = "QUICK_BONUS_FMT",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},

	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "heart_trail",
	},
}



floaters.checkout = {
	font = "main_stroke_font:fonts",
	textSizes = {
		[10] = 60,
		[80] = 100,
	},
	textId = "CHECKOUT_FMT",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Green
		{r=161/255, g=255/255, b=0/255},
		{r=38/255, g=92/255, b=6/255},
	},
	bonus = {
		textId = "CHECKOUT_TIP_FMT",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffects = {
			"deliver_full_order",--"pay1", -- 1: Angry
			"deliver_full_order",--"pay2", -- 2: Annoyed
			"deliver_full_order",--"pay3", -- 3: Normal
			"deliver_full_order",--"pay4", -- 4: Happy
			"deliver_full_order",--"pay5", -- 5: Extatic
		},
	},
}

floaters.checkoutChoiceTip = {
	font = "main_stroke_font:fonts",
	textSize = 50,
	lineHeight = 40,
	textId = "CHECKOUT_CHOICE_TIP",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Purple
		{r=237/255, g=167/255, b=254/255}, -- Inner
		{r=109/255, g=23/255, b=6/255}, -- Border
	},
	bonus = {
		textId = "CHECKOUT_CHOICE_TIP_BONUS_FMT",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "deliver_full_order",
	},
}



floaters.register = {
	font = "main_stroke_font:fonts",
	textSize = 70,
	lineHeight = 60,
	textId = "CHECKOUT_COMBO",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Green
		{r=161/255, g=255/255, b=0/255},
		{r=38/255, g=92/255, b=6/255},
	},
	bonus = {
		textId = "CHECKOUT_COMBO_FMT",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffects = {
			"deliver_full_order",--"combo1",
			"deliver_full_order",--"combo2",
			"deliver_full_order",--"combo3",
		},
	},
}

floaters.moodTip = {
	font = "main_stroke_font:fonts",
	textSizes = {
		[2] = 50,
		[40] = 100,
	},
	textId = "CHECKOUT_MOOD",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Green
		{r=161/255, g=255/255, b=0/255},
		{r=38/255, g=92/255, b=6/255},
	},
	bonus = {
		textId = "CHECKOUT_MOOD_TIP",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffects = {
			"deliver_full_order",--"combo1",
			"deliver_full_order",--"combo2",
			"deliver_full_order",--"combo3",
		},
	},
}

floaters.cleanTip = {
	font = "main_stroke_font:fonts",
	textSize = 60,
	lineHeight = 50,
	textId = "CLEAN_BONUS",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Blue
		{r=58/255, g=234/255, b=255/255}, -- Inner
		{r=15/255, g=80/255, b=129/255}, -- Border
	},
	bonus = {
		textId = "CLEAN_BONUS_TIP",
		textSize = 60,
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "deliver_full_order",
	},
}

floaters.cleanAllTableBonusTip = {
	font = "main_stroke_font:fonts",
	textSize = 80,
	textId = "CLEAN_All_TABLES_BONUS",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Blue
		{r=58/255, g=234/255, b=255/255}, -- Inner
		{r=15/255, g=80/255, b=129/255}, -- Border
	},
	bonus = {
		textId = "CLEAN_All_TABLES_BONUS_TIP",
		textSize = 80,
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "deliver_full_order",
	},
}

floaters.fullStockBonusTip = {
	font = "main_stroke_font:fonts",
	textSize = 80,
	textId = "FULL_STOCKED_BONUS",
	sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Blue
		{r=58/255, g=234/255, b=255/255}, -- Inner
		{r=15/255, g=80/255, b=129/255}, -- Border
	},
	bonus = {
		textId = "FULL_STOCKED_BONUS_TIP",
		textSize = 80,
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},
	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "deliver_full_order",
	},
}

floaters.wishFountainCoin = {
	sounds = {
		"coin_tossing_fail:sound", -- Too far sound
		"coin_tossing_success:sound", -- Correct sound
		"coin_tossing_fail:sound" -- Too short sound
	},
	texts = {
		"WISHFOUNTAIN_MISS_FAR", -- too far
		"WISHFOUNTAIN_SUCCESS",
		"WISHFOUNTAIN_MISS_SHORT" -- too short
	},
	floaterXDisplacement = 0,
	floaterYDisplacement = 0,
	coinJump = {
		setup = {
			image = "wishfountain_rotating_coin:ui",
			theFrameTime = 10,
		},
		tailEffect = "deliver_full_order",
	},
}

floaters.addHearts = {
	font = "main_stroke_font:fonts",
	textSize = 50,
	textId = "BONUS_HEARTS",
	--sounds = checkoutCoinJumpSounds,
	fontColor = {
		-- Red
		{r=265/255, g=67/255, b=67/255},
		{r=253/255, g=253/255, b=253/255},
	},
	extraText = {
		location = {0, 0},
		textSize = 50,
		textId = "BONUS_HEART_VAL",
		fontColor = {
			-- Red
			{r=265/255, g=67/255, b=67/255},
			{r=253/255, g=253/255, b=253/255},
		},
		rightDisplacement = true,
	},
}

floaters.gestureComplete = {
	font = "main_stroke_font:fonts",
	textSize = 60,
	textId = "GESTURE_COMPLETE",
	fontColor = {
		-- Green
		{r=161/255, g=255/255, b=0/255},
		{r=38/255, g=92/255, b=6/255},
	},
}



floaters.minigame =

{
	font = "main_stroke_font:fonts",
	textSize = 70,
	textId = "MINIGAME_BONUS",
	sounds = deliveryCoinJumpSounds,
	fontColor = {
		-- Purple
		{r=237/255, g=167/255, b=254/255}, -- Inner
		{r=109/255, g=23/255, b=6/255}, -- Border
	},

	extraText = {
		textId = "MINIGAME_BONUS_FMT",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},

	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "heart_trail",
	},
}


floaters.parker_request =

{
	font = "main_stroke_font:fonts",
	textSize = 70,
	textId = "PARKER_REQUEST",
	sounds = deliveryCoinJumpSounds,
	fontColor = {
		-- Purple
		{r=237/255, g=167/255, b=254/255}, -- Inner
		{r=109/255, g=23/255, b=6/255}, -- Border
	},

	extraText = {
		textId = "PARKER_REQUEST_BONUS",
		fontColor = {
			-- Yellow
			{r=255/255, g=225/255, b=15/255}, -- Inner
			{r=170/255, g=80/255, b=0/255}, -- Border
		},
	},

	coinJump = {
		setup = coinJump,
		delay = 0,
		tailEffect = "heart_trail",
	},
}
