dofile("script/Main.lua")

MomentTask = deriveLuaClass("MomentTask", "LuaTask")

function MomentTask:start()
	 if (self.dummy) then
	 	--player:missedMoment(self.momentId)
	 	return false
	 end
	 if (self.momentType == "MemorableMoment") then
	 	GH.assert(self.momentId > 0, "self.momentId not set")
	end
	--print("momentId: "..self.momentId)
	 if (self.momentType == "MemorableMoment" and player:hasMemorableMoment(self.momentId)) then
	 	return true
	 end

	self.startDuration = self.startDuration or 500
	self.momentDuration = self.momentDuration or 4000
	self.endDuration = self.endDuration or 1000
	if (self.duration == 0) then
		self.duration = self.startDuration + self.momentDuration + self.endDuration
	end

	local momentDesc = {
		class = "Moment",

		momentDuration = self.momentDuration,

		circleTarget = self.circleTarget,
		circleOffset = self.circleOffset,
		floatingThingPos = self.floatingThingPos,

		numStars = self.numStars or 5,
		circleRadius = self.circleRadius or 200,

		startDuration = self.startDuration,
		circleDuration = self.circleDuration or 1500,
		endDuration = self.endDuration,
		momentId = self.momentId,
		momentType = self.momentType or ""
	}

	if (level) then
		self.moment = level.topLayer:newChild(momentDesc)
	else
		self.moment = scene:newChild(momentDesc)
	end

	return self.moment ~= nil
end

function MomentTask:update(time)
	return
--		player:hasMoment(self.momentId) or
		not self.moment or
		self.moment.finished or
		self.moment.__deleted
end

function MomentTask:skip()
	if (self.dummy or not isTable(self.moment) or not self.moment.hasBeenClicked) then
		--player:missedMoment(self.momentId)
	end
	if (isTable(self.moment) and self.moment.remove and not self.moment.__deleted) then
		self.moment:remove()
	end
end

-- ************************************ Moment Object ************************************ --
Moment = getClass("Moment")

function Moment:initFloatingThing(floatingThing)
	floatingThing:doEvery(0, function()
		floatingThing:newChild({class="ParticleEffect", name="flashing", x=0, y=-60, library="effects:particles", emitter="flashing", scale=0.4, start=true})
		return 1000
	end)
end

function Moment:allowWork(character)
	return false
end
