-- ************************************ Player ************************************ --
Player = getClass("Player")

function Player:getMetaDifficultyValue(t)
	-- The original value of the 0.5 was self.difficultyFrac which value was
	-- difficulty / (difficultyCount - 1)
	return getInterpolatedEmbedValue(t, 0.5, self.metaDifficultyFrac)
end

function math.getRandomItemFromWeightedList(list, reditribute)
	local totalWeight = 0
	for _,v in ipairs(list) do
		totalWeight = totalWeight + v.weight
	end

	local selectedWeight = math.Random(totalWeight)
	if (selectedWeight < 1) then
		error("selectedWeight = "..tostring(selectedWeight).." totalWeight = "..tostring(totalWeight))
	end
	GH.assert(selectedWeight <= totalWeight)

	local chosen
	for _,v in ipairs(list) do
		selectedWeight = selectedWeight - v.weight
		if (selectedWeight <= 0) then
			chosen = v
			break
		end
	end

	if (chosen and reditribute) then
		local num = #list - 1
		if (num > 0) then
			num = chosen.weight / num
			for _,v in ipairs(list) do
				if (v ~= chosen) then v.weight = v.weight + num end
			end
		end
		chosen.weight = 0
	end
	return chosen
end

-- ************************************ Delicious Player ************************************ --
DelPlayer = getClass("DelPlayer")
