﻿-- Refer to:
-- General upgrades https://confluence.gamehouse.com/display/GAM/D15+Shop+Upgrades
-- Room 1 https://confluence.gamehouse.com/display/GHOS/D16+Chapter+1+-+Shop+Upgrades
-- Room 2 https://confluence.gamehouse.com/display/GHOS/D16+Chapter+2+-+Shop+Upgrades
-- Room 2 https://confluence.gamehouse.com/display/GHOS/D16+Chapter+3+-+Shop+Upgrades
-- Room 2 https://confluence.gamehouse.com/display/GHOS/D16+Chapter+4+-+Shop+Upgrades
-- Room 2 https://confluence.gamehouse.com/display/GHOS/D16+Chapter+5+-+Shop+Upgrades
-- Room 2 https://confluence.gamehouse.com/display/GHOS/D16+Chapter+6+-+Shop+Upgrades

--levelDesc = levelDesc or {}

upgrades =
{
	-- General
	moodDurationTable 		= {id="tableMoodDurationMultiplier", value=1.25}, 				-- mood multiplier
	moodStartTable			= {id="tableStartMoodDropTimeMultiplier", value=2.5}, 			-- mood multiplier
	--moodDurationCounter 	= {id="counterMoodDurationMultiplier", value=1.25},				-- mood multiplier
	entertainDuration 		= {id="entertainDuration", value=0.5}, 							-- entertaining multiplier
	heroWorkDuration 		= {object="hero", id="actorWorkDurationMultiplier", value=0.75},-- characters multiplier
	heroWalkSpeed 			= {object="hero", id="walkSpeed", value=1.25}, 					-- characters multiplier
	cleanerWalkSpeed 		= {object="cleaner", id="walkSpeed", value=1.2},  				-- characters multiplier
	restockerWalkSpeed 		= {object="restocker", id="walkSpeed", value=2}, 				-- characters multiplier
	tipTable				= {id="tableTipMultiplier", value=1.1}, 						-- tip multiplier
	tipCounter 				= {id="counterTipMultiplier", value=1.1}, 						-- tip multiplier
	tipStool 				= {id="stoolTipMultiplier", value=1.1}, 						-- tip multiplier
	cleanDuration			= {id="cleanDuration", value=1000}, 							-- cleaning value
	checkoutCombo2			= {id="comboCheckout2", value=25}, 								-- combos value
	checkoutCombo3			= {id="comboCheckout3", value=50}, 								-- combos value
	checkoutCombo4			= {id="comboCheckout4", value=75}, 								-- combos value
	cleanCombo2				= {id="cleanBonus2", value=15}, 								-- combos value
	cleanCombo3				= {id="cleanBonus3", value=30}, 								-- combos value
	cleanCombo4				= {id="cleanBonus4", value=45}, 								-- combos value
	chainCombo2				= {id="moneyCustomerChain2", value=15}, 						-- combos value
	chainCombo3				= {id="moneyCustomerChain3", value=20}, 						-- combos value
	chainCombo4				= {id="moneyCustomerChain4", value=25}, 						-- combos value
	chainCombo5				= {id="moneyCustomerChain5", value=35}, 						-- combos value
	quickBonus				= {id="quickBonus", value=10}, 									-- combos value
	quickDuration			= {id="quickBonusDuration", value=10000}, 						-- combos value
	fullOrder		 		= {id="moneyFullOrderAtOncePerProduct", value=6},				-- combos value
	mouseShowTime			= {id="mouseShowTime", object={"mouse1", "mouse2", "mouse3", "mouse4", "mouse5", "mouse6", "mouse7", "mouse8", "mouse9", "mouse10"}, value=7500}, 	-- mouse value
	mouseShowRate			= {id="delayMultiplier", object={"mouse1", "mouse2", "mouse3", "mouse4", "mouse5", "mouse6", "mouse7", "mouse8", "mouse9", "mouse10"}, value=0.75}, -- mouse value
	customerExtra 			= {id="extraCustomer", value=false},								-- other value

	-- D16
	room1_emilyWalkSpeed = {object="emily", id="walkSpeed", value=1.25}, 					-- characters multiplier
	room2_moodDurationBath	= {id="bathMoodDurationMultiplier", value=1.25}, 					-- mood multiplier
	room2_moodStartBath		= {id="bathStartMoodDropTimeMultiplier", value=2.5}, 				-- mood multiplier
	room2_washerStock 		= {object="timer4_cooker_button", id="initialMaxStock", value=6},	-- products value
	room3_raccoonMinDelay 	= {object="raccoon_selector", id="minSpawnTime", value=1.25},	-- object value
	room3_raccoonMaxDelay 	= {object="raccoon_selector", id="maxSpawnTime", value=1.25},	-- object value
	room3_stacyWalkSpeed 	= {object="stacy", id="walkSpeed", value=1.25}, 					-- characters multiplier
	room6_ovendecay 		= {object="timer1_ready", id="decayDelay", value=8000},				-- products value
	room4_sharonWalkSpeed 	= {object="sharon_helper", id="walkSpeed", value=1.25}, 			-- characters multiplier

	-- For other upgrades not used here, go back to Shop.lua of D15
}

shopDesc =
{
	room1 = {
		{upgradeGroup = "shop_room1_entertainer", 	price = 450},																											-- Unlocks the entertainer
		{upgradeGroup = "shop_room1_cleanduration", price = 375, 	values 				= {upgrades.cleanDuration}}, 														-- Decreases cleaning duration
		{upgradeGroup = "shop_room1_walkspeed", 	price = 675, 	valueMultipliers 	= {upgrades.heroWalkSpeed, upgrades.room1_emilyWalkSpeed}}, -- Hero and helper walk faster
		{upgradeGroup = "shop_room1_moodtable", 	price = 500, 	valueMultipliers 	= {upgrades.moodDurationTable, upgrades.moodStartTable}},							-- Increases mood at tables
		{upgradeGroup = "shop_room1_fullorder", 	price = 300, 	values 				= {upgrades.fullOrder}}, 															-- Increases full order bonus
		{upgradeGroup = "shop_room1_checkoutcombo", price = 0, 		values 				= {upgrades.checkoutCombo2, upgrades.checkoutCombo3, upgrades.checkoutCombo4}},		-- Increases checkout combo bonus
		{upgradeGroup = "shop_room1_cleancombo", 	price = 250, 	values 				= {upgrades.cleanCombo2, upgrades.cleanCombo3, upgrades.cleanCombo4}},				-- Reward for cleaning in a row
		{upgradeGroup = "shop_room1_mouseshowtime", price = 450, 	values 				= {upgrades.mouseShowTime}} 														-- Increases mouse show time
	},

	room2 = {
		{upgradeGroup = "shop_room2_washerstock", 	price = 380, 	values			 	= {upgrades.room2_washerStock}},
		{upgradeGroup = "shop_room2_cleaner", 		price = 755},																														-- Unlocks the cleaner
		{upgradeGroup = "shop_room2_walkspeed", 	price = 660, 	valueMultipliers 	= {upgrades.heroWalkSpeed}}, 																	-- Hero walks faster
		{upgradeGroup = "shop_room2_moodtable", 	price = 565, 	valueMultipliers 	= {upgrades.moodDurationTable, upgrades.moodStartTable}},										-- Increases mood at tables
		{upgradeGroup = "shop_room2_moodbath", 		price = 380, 	valueMultipliers 	= {upgrades.room2_moodDurationBath, upgrades.room2_moodStartBath}},								-- Increases mood in the bath stations
		--{upgradeGroup = "shop_room2_chaincombo",	price = 285, 	values 				= {upgrades.chainCombo2, upgrades.chainCombo3, upgrades.chainCombo4, upgrades.chainCombo5}}, 	-- Increases chain combo bonus
		{upgradeGroup = "shop_room2_quickcombo", 	price = 190, 	values 			 	= {upgrades.quickBonus}}, 																		-- Increases quick combo bonus
		{upgradeGroup = "shop_room2_mouseshowrate", price = 565, 	valueMultipliers 	= {upgrades.mouseShowRate}} 																	-- Increase mouse show rate
	},

	room3 = {
		{upgradeGroup = "shop_room3_raccoonfreq", 	price = 450,	valueMultipliers 	= {upgrades.room3_raccoonMinDelay, upgrades.room3_raccoonMaxDelay}},
		{upgradeGroup = "shop_room3_cleanduration", price = 670, 	values 				= {upgrades.cleanDuration}}, 													-- Decreases cleaning duration
		{upgradeGroup = "shop_room3_walkspeed", 	price = 650, 	valueMultipliers 	= {upgrades.heroWalkSpeed, upgrades.room3_stacyWalkSpeed}}, 													-- Hero walks faster
		{upgradeGroup = "shop_room3_moodtable", 	price = 880, 	valueMultipliers 	= {upgrades.moodDurationTable, upgrades.moodStartTable}},						-- Increases mood at tables
		{upgradeGroup = "shop_room3_checkoutcombo", price = 320, 	values 				= {upgrades.checkoutCombo2, upgrades.checkoutCombo3, upgrades.checkoutCombo4}}, -- Increases checkout combo bonus
		{upgradeGroup = "shop_room3_cleancombo",	price = 220, 	values 				= {upgrades.cleanCombo2, upgrades.cleanCombo3, upgrades.cleanCombo4}},			-- Reward for cleaning in a row
		{upgradeGroup = "shop_room3_cookerslot", 	price = 550},																										-- Unlocks the second slot for the cooker
		{upgradeGroup = "shop_room3_mouseshowtime", price = 660, 	values 				= {upgrades.mouseShowTime}}														-- Increases mouse show time
	},

	room4 = {
		{upgradeGroup = "shop_room4_entertainer", 	price = 650},																					-- Unlocks the entertainer
		{upgradeGroup = "shop_room4_cleaner", 		price = 530},																					-- Unlocks the cleaner
		{upgradeGroup = "shop_room4_walkspeed", 	price = 800, 	valueMultipliers 	= {upgrades.heroWalkSpeed, upgrades.room4_sharonWalkSpeed}}, 								-- Hero walks faster
		{upgradeGroup = "shop_room4_moodtable", 	price = 1055, 	valueMultipliers 	= {upgrades.moodDurationTable, upgrades.moodStartTable}},	-- Increases mood at tables
		{upgradeGroup = "shop_room4_customerextra", price = 925, 	values 				= {upgrades.customerExtra}},								-- Extra customer at the end of the level
		{upgradeGroup = "shop_room4_fullorder",		price = 395, 	values 				= {upgrades.fullOrder}}, 									-- Increases full order bonus
		{upgradeGroup = "shop_room4_quickduration", price = 275, 	values 				= {upgrades.quickDuration}}, 								-- Increase quick bonus time
		{upgradeGroup = "shop_room4_mouseshowrate", price = 660, 	valueMultipliers 	= {upgrades.mouseShowRate}} 								-- Increase mouse show rate
	},

	room5 = {
		{upgradeGroup = "shop_room5_cookerslot", 	price = 890},																													-- Unlocks the second slot for the cooker
		{upgradeGroup = "shop_room5_cleanduration", price = 745, 	values  		 	= {upgrades.cleanDuration}}, 																-- Decreases cleaning duration
		{upgradeGroup = "shop_room5_walkspeed", 	price = 1040,	valueMultipliers 	= {upgrades.heroWalkSpeed} }, 																-- Hero walks faster
		--{upgradeGroup = "shop_room5_moodtable", 	price = 1190, 	valueMultipliers 	= {upgrades.moodDurationTable, upgrades.moodStartTable}},									-- Increases mood at tables
		--{upgradeGroup = "shop_room5_chaincombo", 	price = 295, 	values 				= {upgrades.chainCombo2, upgrades.chainCombo3, upgrades.chainCombo4, upgrades.chainCombo5}},-- Increases chain combo bonus
		{upgradeGroup = "shop_room5_checkoutcombo",	price = 430, 	values 				= {upgrades.checkoutCombo2, upgrades.checkoutCombo3, upgrades.checkoutCombo4}},				-- Increases checkout combo bonus
		{upgradeGroup = "shop_room5_entertainer", 	price = 450},																													-- Unlocks the entertainer
		{upgradeGroup = "shop_room5_mouseshowtime", price = 890, 	values 				= {upgrades.mouseShowTime}} 																-- Increases mouse show time
	},

	room6 = {
		{upgradeGroup = "shop_room6_entertainer", 	price = 520},																									-- Unlocks the entertainer
		{upgradeGroup = "shop_room6_cleaner", 		price = 1035},																									-- Unlocks the cleaner
		{upgradeGroup = "shop_room6_walkspeed", 	price = 850, 	valueMultipliers 	= {upgrades.heroWalkSpeed}}, 												-- Hero walks faster
		{upgradeGroup = "shop_room6_moodtable", 	price = 870, 	valueMultipliers 	= {upgrades.moodDurationTable, upgrades.moodStartTable}},					-- Increases mood at tables
		{upgradeGroup = "shop_room6_ovendecay", 	price = 690,	values 				= {upgrades.room6_ovendecay}},												-- Increases decay time of the oven
		{upgradeGroup = "shop_room6_fullorder",		price = 340, 	values 				= {upgrades.fullOrder}}, 													-- Increases full order bonus
		{upgradeGroup = "shop_room6_quicksuper", 	price = 1045, 	values 				= {upgrades.quickBonus, upgrades.quickDuration}}, 							-- Quick Bonus Extra + Quick Duration Extra
		{upgradeGroup = "shop_room6_mousesuper", 	price = 1560, 	values 				= {upgrades.mouseShowTime}, valueMultipliers = {upgrades.mouseShowRate}} 	-- Mouse Show Time + Mouse Show Rate
	},
}
