levelDesc = levelDesc or {}

roomNames = {
	"room1",
	"room2",
	"room3",
	"room4",
	"room5",
	"room6",
}

-- Default values in levelDesc
levelDesc.defaultPoductSettings = {
        orderable = true,
        edible = true,
        chance = 100,
        regular = 100, -- Chance per customer
        kid = 100,
        elder = 100,
        yuppie = 100,
        normal = 100,
        biggie = 100,

        male = 100,  -- Chance per gender
        female = 100,
}

PAUSE_ON_LOST_FOCUS = false


-- These two parameters tell us the hour and minute when we can send a new
-- diamond to a player.
neighborsAvailabilityStartHour = 8
neighborsAvailabilityStartMinute = 0

levelDesc.defaultConsumeAnimation = "sit_eat"

levelDesc.maxHearts = 10
levelDesc.counterOrderSize = 2  --size of an order at the counter
levelDesc.tableOrderSize = 10 --this should be the size of a table order, but this is 4, so I don't know what this is

levelDesc.orderSteps = 1 --the number of steps of an order

-- D15's metadifficulty system - Outdated
levelDesc.levelsWonForHigherDifficulty = 1 --The number of wins needed to stop automatic difficulty adjustment
levelDesc.levelsLostForLowerDifficulty = 2 --The number of loses needed to start automatic difficulty adjustment

levelDesc.overrideUninitializedCharacterPositions = false

trophyNumCoins = 50000
totalTrophyCount = 16

-- MOOD HEART DECREASE TIMINGS
MoodStartShakeTimeMS = 3000				--The amount of MS when the shake animation starts at the end of the mood timer
MoodStartDecreaseAnimRelative = 1.0	--The relative point when the heart start to decrease,
										-- where 1.0 is the beginning and 0.0 is the end of the mood timer
MoodHeartsAppearLapse = 100				-- Time between the appearance of one heart and the next when the hearts appear for the first time
MoodFillDuration = 300					-- The time it takes for a heart to fill When a customer gains one
HeartsEatingHideDelay = 1500			-- Delay between the delivery of the order and the hiding of the hearts in a table when the custome gains hearts

-- The shake animation works as follows:
-- Shake -(then)-> Fade out + Scale
HeartAnimationParameters = {			-- Parameters of the shake hearts animation
	shakeRotation = 0,
	shakeDuration = 2500,			-- shakeDuration + fadeDuration should be approximately == MoodStartShakeTimeMS
	durationOfOneShake = 200,
	jumpDuration = 500,				-- The jump, fade and scaling time
	initialScale = 1,
	finalScale = 1.5,
	xShake = 4,						-- Displacement on x of the shake
	yShake = 0,						-- Displacement on y of the shake
	changeShakeState = 75,
	xJump = 10,
	yJumpTop = -25,
	yJumpBottom = 50,
	loseHeartSound = "customer_becomes_angry:sound",
	bubbleYDisplacement = -10,		-- Displacement from the top of the order bubble.
}

levelDesc.rangeDifficultyAngles ={
	["easy"] = 54,
	["medium"] = 40.5,
	["hard"] = 27

}

levelDesc.valueMultipliers =
    {
        queueMoodDurationMultiplier = 1.5, -- Mood drop multiplier in the (counter?) queue, takes longer to get angry in the queue
        tableMoodDurationMultiplier = 1.0,
        counterMoodDurationMultiplier = 1.0,

		-- D15 stations mood
		---- Room 1
		workshopMoodDurationMultiplier = 1.0,
		---- Room 2
		specialstationqueueMoodDurationMultiplier = 1.0,
		specialstationqueue2MoodDurationMultiplier = 1.0,
		---- Room 3
		cradleMoodDurationMultiplier = 1.0,
		playgroundMoodDurationMultiplier = 1.0,
		---- Room 4
		bathqueueMoodDurationMultiplier = 1.0,
		---- Room 5
		queueBedEmilyMoodDurationMultiplier = 1.0,
		queueBedPregnant1MoodDurationMultiplier = 1.0,
		queueBedPregnant2MoodDurationMultiplier = 1.0,

		-- D16 stations mood
		-- Room 2
		bathMoodDurationMultiplier = 1.0,

        tableTipMultiplier = 1, -- Higher tip from a table
        counterTipMultiplier = 1.0, -- Normal from the counter
        stoolTipMultiplier = 1.0, -- Normal from the stool
        meditationTipMultiplier = 1.0,

        dropDelayMultiplier = 1.0, -- Used when the "trough" upgrade has been bought

        --entertainDuration = {0.8, 1, 1.2}, -- easy, normal, hard
				entertainDuration = 1,
        -- moodDropTime = {
        --     {1.7, 1.55, 1.4}, -- easy mood drop time (automatic difficulty adjusts: two down, one down, normal)
        --     {1.1, 1.05, 1.0}, -- normal
        --     {1.0, 0.95, 0.9}, -- hard
        -- },
				moodDropTime = 1.2,
        spawnDelay = 1,
        --star1ChallengeScore = {1.0, 1.0, 1.0},
				star1ChallengeScore = 1,

		-- TO DO
		mouseShowTimeMultiplier = 1.0,
		mouseShowDelayMultiplier = 1.0,
    }

levelDesc.valueAdders =
    {
        startMood = {
            {1, 1, 0}, -- easy
            {1, 0, 0}, -- normal
            {0, 0, 0}, -- hard
        },
    }

levelDesc.animationDescs =
    {
        sit_read_right = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        sit_order_right = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},

        bath_sit_idle_right = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        bath_sit_order_right = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        bath_sit_think_right = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},

		--R1
		stand_eat = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}},
        stand_drink = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}},

		-- Consume animations mustn't use the _right suffix here:
		sit_read = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
		sit_eat = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
		sit_drink = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
		sit_wrap = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},

        --R3
        sit_play = {shouldPlayInStoryMode=false, holdCycleDuration={0, 600}, noShadow=true},
        sit_write = {shouldPlayInStoryMode=false, holdCycleDuration={0, 600}, noShadow=true},

        --R4
        bath_sit_drink = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        bath_sit_eat = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        bath_sit_relax = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},

        --R5
        lay_eat = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        lay_drink = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
        lay_read = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},

		-- R6
		front_sit_eat = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
		front_sit_drink = {shouldPlayInStoryMode=false, holdCycleDuration={0, 1200}, noShadow=true},
    }

moodAppearances = { "angry", "annoyed", "", "happy", "ecstatic", }

--$$$
-- D15 complexity limits
--[[levelDesc.complexityLimits =
{
    {  -- easy
        {easy = 1, medium = 1, hard = 1, very_hard = 0},   -- size 1 , easy order
        {easy = 2, medium = 1, hard = 1, very_hard = 0},   -- size 2 , easy order
        {easy = 2, medium = 1, hard = 1, very_hard = 0},   -- size 3 , easy order
        {easy = 3, medium = 2, hard = 1, very_hard = 0},   -- size 4 , easy order
        {easy = 3, medium = 2, hard = 1, very_hard = 0},   -- size 4 , easy order
        {easy = 3, medium = 2, hard = 1, very_hard = 0}    -- size 4 , easy order
    },
    {-- medium
        {easy = 1, medium = 1, hard = 1, very_hard = 1},   -- size 1, medium order
        {easy = 1, medium = 2, hard = 1, very_hard = 1},   -- size 2, medium order
        {easy = 1, medium = 2, hard = 1, very_hard = 1},   -- size 3, medium order
        {easy = 2, medium = 2, hard = 2, very_hard = 1},    -- size 4, medium order
        {easy = 2, medium = 2, hard = 2, very_hard = 1},    -- size 4, medium order
        {easy = 2, medium = 2, hard = 2, very_hard = 1}    -- size 4, medium order
    },
    {-- hard
        {easy = 1, medium = 1, hard = 1, very_hard = 1},   -- size 1, hard order
        {easy = 1, medium = 1, hard = 2, very_hard = 1},   -- size 2, hard order
        {easy = 1, medium = 1, hard = 2, very_hard = 1},   -- size 3, hard order
        {easy = 1, medium = 2, hard = 2, very_hard = 1},    -- size 4, hard order
        {easy = 1, medium = 2, hard = 2, very_hard = 1},    -- size 4, hard order
        {easy = 1, medium = 2, hard = 2, very_hard = 1}    -- size 4, hard order
    },
}
]]--
-- D16 complexity limits, basically, no limits
levelDesc.complexityLimits =
{
    {  -- easy
        {easy = 1, medium = 1, hard = 1, very_hard = 1},   -- size 1 , easy order
        {easy = 2, medium = 2, hard = 2, very_hard = 2},   -- size 2 , easy order
        {easy = 3, medium = 3, hard = 3, very_hard = 3},   -- size 3 , easy order
        {easy = 4, medium = 4, hard = 4, very_hard = 4},   -- size 4 , easy order
        {easy = 5, medium = 5, hard = 5, very_hard = 5},   -- size 4 , easy order
        {easy = 6, medium = 6, hard = 6, very_hard = 6}    -- size 4 , easy order
    },
    {-- medium
		{easy = 1, medium = 1, hard = 1, very_hard = 1},   -- size 1 , easy order
        {easy = 2, medium = 2, hard = 2, very_hard = 2},   -- size 2 , easy order
        {easy = 3, medium = 3, hard = 3, very_hard = 3},   -- size 3 , easy order
        {easy = 4, medium = 4, hard = 4, very_hard = 4},   -- size 4 , easy order
        {easy = 5, medium = 5, hard = 5, very_hard = 5},   -- size 4 , easy order
        {easy = 6, medium = 6, hard = 6, very_hard = 6}    -- size 4 , easy order
    },
    {-- hard
		{easy = 1, medium = 1, hard = 1, very_hard = 1},   -- size 1 , easy order
        {easy = 2, medium = 2, hard = 2, very_hard = 2},   -- size 2 , easy order
        {easy = 3, medium = 3, hard = 3, very_hard = 3},   -- size 3 , easy order
        {easy = 4, medium = 4, hard = 4, very_hard = 4},   -- size 4 , easy order
        {easy = 5, medium = 5, hard = 5, very_hard = 5},   -- size 4 , easy order
        {easy = 6, medium = 6, hard = 6, very_hard = 6}    -- size 4 , easy order
    },
}

levelDesc.complexityChances = {
    {  -- easy
        {{easy = 60, medium = 30, hard = 10}},                                          						-- size 1
        {{easy = 100}, {easy = 20, medium = 60, hard = 20}},                                					-- size 2
	    {{easy = 100}, {easy = 20, medium = 60, hard = 20}, {easy = 60, medium = 30, hard = 10}},				-- size 3
        {{easy = 100}, {easy = 100}, {easy = 20, medium = 60, hard = 20}, {easy = 20, medium = 60, hard = 20}},	-- size 4
        {{easy = 100}, {easy = 100}, {easy = 20, medium = 60, hard = 20}, {easy = 20, medium = 60, hard = 20}},  -- size 4
        {{easy = 100}, {easy = 100}, {easy = 20, medium = 60, hard = 20}, {easy = 20, medium = 60, hard = 20}}  -- size 4
    },
    {-- medium
        {{easy = 20, medium = 50, hard = 20, very_hard = 10}},                                                   	      						-- size 1
        {{medium = 100}, {easy = 40, medium = 0, hard = 40, very_hard = 20}},                                         							-- size 2
        {{medium = 100}, {easy = 40, medium = 0, hard = 40, very_hard = 20}, {easy = 20, medium = 50, hard = 20, very_hard = 10}},  			-- size 3
        {{medium = 100}, {medium = 100}, {easy = 40, medium = 0, hard = 40, very_hard = 20}, {easy = 40, medium = 0, hard = 40, very_hard = 20}},-- size 4
        {{medium = 100}, {medium = 100}, {easy = 40, medium = 0, hard = 40, very_hard = 20}, {easy = 40, medium = 0, hard = 40, very_hard = 20}},-- size 4
        {{medium = 100}, {medium = 100}, {easy = 40, medium = 0, hard = 40, very_hard = 20}, {easy = 40, medium = 0, hard = 40, very_hard = 20}}-- size 4
    },
    {-- hard
        {{easy = 10, medium = 20, hard = 50, very_hard = 20}},                                                             								-- size 1
        {{hard = 100}, {easy = 20, medium = 40, hard = 0, very_hard = 40} },                                                        					-- size 2
        {{hard = 100}, {easy = 20, medium = 40, hard = 0, very_hard = 40}, {easy = 10, medium = 20, hard = 50, very_hard = 20}},                  		-- size 3
        {{hard = 100}, {medium = 100}, {easy = 10, medium = 25, hard = 40, very_hard = 25}, {easy = 10, medium = 30, hard = 40, very_hard = 20}} ,       -- size 4
        {{hard = 100}, {medium = 100}, {easy = 10, medium = 25, hard = 40, very_hard = 25}, {easy = 10, medium = 30, hard = 40, very_hard = 20}} ,       -- size 4
        {{hard = 100}, {medium = 100}, {easy = 10, medium = 25, hard = 40, very_hard = 25}, {easy = 10, medium = 30, hard = 40, very_hard = 20}}        -- size 4
    },
}
--==============================================================================
--METADIFFICULTY
--==============================================================================
-- complexityChances when metadifficulty is on

metadifficultyMinLevel = 0
metadifficultyMaxLevel = 10
metadifficultyDefaultLevel = 5
metadifficultyActivationShift = 9 -- Index of the level according to the Episodes
metadifficultyActivationEpisode = 1
metadifficultyIncWhenGameFinished = 2
metadifficultyReplay3StarsStrikeCounter = 3
levelDesc.metadifficultyMoodMultiplier  		= {1, 1, 1} --{minLevel, defaultLevel, maxLevel}
levelDesc.metadifficultySpawnDelayMultiplier 	= {1, 1, 1} --{minLevel, defaultLevel, maxLevel}
levelDesc.metadifficulty3StarsMaxScoreExcess 	= 200
levelDesc.metadifficulty3StarsMinScoreExcess	= 50
levelDesc.metadifficultyMouseShowingTime 		= {1.25, 1, 0.75}
levelDesc.metadifficultyMouseShowingRateTime 	= {0.75, 1, 1.25}
--==============================================================================

levelDesc.complexityChancesWithMetadifficultyLevels = {
    { -- easy
        easy = {80,60,20}, medium = {20,30,50}, hard = {0,10,20}, very_hard = {0,0,10}
    },
    { -- medium
        easy = {60,20,10}, medium = {30,50,20}, hard = {10,20,50}, very_hard = {0,10,20}
    },
    { -- hard
        easy = {20,10,0}, medium = {50,20,10}, hard = {20,45,60}, very_hard = {10,25,30}
    }
}

-- D15
levelDesc.tipClasses = {
	{tipNormal=2, tipHappy=5, tipEcstatic=10},		-- 1 Low
	{tipNormal=10, tipHappy=15, tipEcstatic=20},	-- 2 Medium
	{tipNormal=20, tipHappy=30, tipEcstatic=40},	-- 3 High
}
-- D15
levelDesc.patienceClasses = {
	{moodDropTime=25000},  -- 1 Low
	{moodDropTime=20000}, -- 2 Medium
	{moodDropTime=15000}, -- 3 High
}
-- D15 -- unused
levelDesc.thinkingClasses =
{
	6000, 	-- 1 Low
	8000, 	-- 2 Medium
	10000	-- 3 High
}
-- D15 -- unused
levelDesc.walkSpeedClasses =
{
	350,	-- 1 Low
	500, 	-- 2 Medium
	650 	-- 3 High
}

levelDesc.groupSizeChances = {
	counter = {100},
	stool = {100},
	table = {100,100,100,100},
    table_big = {100,100,100,100,100,100},
	-- D16
	-- room 1
	promo = {100,100},
	-- room 2
	bath = {100, 100},
	-- room 6
	workshop = {100,100},

    special = {100,100,100},


	-- D15
	-- room 2
	specialstationqueue = {100},
	specialstationqueue2 = {100},
	-- room 3
	playground = {100},
	carer = {100},
	-- room 4
	bathqueue = {100, 100},
	yogaqueue = {100},
	-- room 5
	babyattention = {100},
}


levelDesc.initPos = {x=-9999, y=-9999}

levelDesc.values =
    {
        moneyFloaterDelay = 1000,
		moneyFullOrderAtOncePerProduct = 5,  --The bonus you get for delivering a full order (per product of that full order)
        moneyCustomerChain2 = 5, --The bonus you get for delivering 2 customers from the same tray
        moneyCustomerChain3 = 10,
        moneyCustomerChain4 = 15,
        moneyCustomerChain5 = 20,
        moneyCustomerChain6 = 20,
        moneyCustomerChain7 = 20,
        moneyCustomerChain8 = 20,
        moneyCustomerChain9 = 20,
        moneyCustomerChain10 = 20,
		comboCheckout2 = 20, --The money you get for checking out multiple customers at the same time
        comboCheckout3 = 40,
        comboCheckout4 = 60,

		maxCleanBonus = 4,
		cleanBonus2 = 10, -- Test value, modify it with the correct one
		cleanBonus3 = 20, -- Test value, modify it with the correct one
		cleanBonus4 = 30, -- Test value, modify it with the correct one
		cleanBonusCleanerTime = 6500, --Time the cleaner has to get the clean bonus between two tables
		cleanBonusHeroTime = 6000, --Time the hero has to get the clean bonus between two tables
		restartComboOnMax = true, -- If set to true, the 5th table restarts the counter to 2

		-- D13
        --[[
		comboCheckout2 = 10, --The money you get for checking out multiple customers at the same time
        comboCheckout3 = 20,
        comboCheckout4 = 30,
		--]]
        closeDelay = 4000,
        cleanDuration = 2000, --The time it costs to clean a table
        entertainDuration = 4000, --The time it costs to entertain a table
        idleAnimTimeoutMin = 8000,
        idleAnimTimeoutMax = 20000,
        thinkIconFrameTime = 200,
        maxBalloonSize = 6,
        maxTraySize = 3, --base value of 3 for the tray-size (if not filled in the levelfile)
        startMood = 3, --the base mood of customers entering your restaurant
        moodDropTime = 10000, --the base time it takes to drop one state down
        tableStartMoodDropTimeMultiplier = 2, --The mood droptime of customers that enter is doubled, only for that first state when they enter
        tipNormal = 10, --base value of tips on normal customer
        tipHappy = 15, --base value of tips on happy customer
        tipEcstatic = 20, --base value of tips on ecstatic customer
        tip = 0,
        moneyPerProductAngry = 10,  --the money per product of an order
        moneyPerProductAnnoyed = 10,
        moneyPerProductNormal = 10,
        moneyPerProductHappy = 10,
        moneyPerProductEcstatic = 10,
        consumeFrameTime = 200,
        readFrameTime = 200,
        orderFrameTime = 200,
        quickBonusDuration = 7500, --The time you have to get a quick bonus
		quickBonus = 5, --The bonus you get for being quick
        fractionDoneBeforeNextExtraTasty = 0.8, -- For extra tasty button chains: if the value is 0.8, the next in the chain can start when the item before is at 80%
        entertainerMoodIncrease = 1, --the number of moods an entertainer increases
        heroWalkSpeed = 1200, --main characters walkspeed
        additionalCustomerAppearWeight = 10,
        extraCustomer = false,
        extraTraySlots = 0,


		-- D16 stations mood
		-- Room 2
		--bathStartMoodDropTimeMultiplier = 2,

		--[[
		-- D15 stations mood
		---- Room 1
		workshopStartMoodDropTimeMultiplier = 1,
		---- Room 2
		specialstationqueueStartMoodDropTimeMultiplier = 1,
		specialstationqueue2StartMoodDropTimeMultiplier = 1,
		---- Room 3
		cradleStartMoodDropTimeMultiplier = 1,
		playgroundStartMoodDropTimeMultiplier = 1,
		---- Room 4
		bathqueueStartMoodDropTimeMultiplier = 2,
		---- Room 5
		queueBedEmilyStartMoodDropTimeMultiplier = 1,
		queueBedPregnant1StartMoodDropTimeMultiplier = 1,
		queueBedPregnant2StartMoodDropTimeMultiplier = 1,
		]]

		-- Legacy outdated variables
        moneySameCustomerType = 11, --This doesn't work and it shouldn't
        loveSeatMoodIncreaseDuration = 5000,  --no longer used
        marriedCoupleQuickBonus = 100,
        extraTastyBonus = 2,  --No longer used
        newExtraTastyBonus = 100, --no longer used
        reservationTip = 0, --no longer used
        reservationRingDuration = 8000, --no longer used
        reservationExclamationTime = 5000, --no longer used
        attendHeartScore = 1,  --no longer used
        attendMaxTimes = 3, --no longer used
        memorableMomentHeartsScore = 2, --no longer used
        memorableMomentPerfectHeartsScore = 3, --no longer used
        deliverHeartsScore = 1, --no longer used
        deliverPerfectHeartsScore = 2, --no longer used
        memorableMomentAppearFractionMinimum = 0.3, --no longer used
        memorableMomentAppearFractionMaximum = 0.6, --no longer used
        slideScoreAngry = 5, --no longer used
        slideScoreAnnoyed = 10, --no longer used
        slideScoreNormal = 15, --no longer used
        slideScoretHappy = 20, --no longer used
        slideScoreEcstatic = 25, --no longer used
		-- Legacy outdated variables end

        -- Values for the GOAT
  		quickBonus = 5,
        checkoutBonusMoodAngry = 0,
        checkoutBonusMoodAnnoyed = 0,
        checkoutBonusMoodEcstatic = 0,
        checkoutBonusMoodHappy = 0,
        checkoutBonusMoodNormal = 0,
		-- D13
		--[[
        checkoutBonusMoodEcstatic = 30,
        checkoutBonusMoodHappy = 20,
        checkoutBonusMoodNormal = 10,
		]]
        defaultProductValue = 10,
        cleanStoreBonus = 20,                -- Bonus for having the store clean at the end of the day
        fullStockedStoreBonus = 30,              -- Bonus for having all the stocks full at the end of the day
        cleanBonus = 10,                     -- Bonus for cleaning a table
        mouseBonus = 100,
    }


characterTypes = {
        default = {
            x=levelDesc.initPos.x, y=levelDesc.initPos.y,
            class						= "DelCharacter",		-- E.g. "Customer"
            baseAnimation				= "error-default",		-- Dummy
            defaultAnimation			= "",					--
            walkSpeed					= 700,					-- Pixels / sec
            animationWalkSpeed			= 700,					-- Pixels / sec
            verticalWalkMultiplier		= 0.666,				-- Modifies vertical speed
            walkFrameDistanceHor		= 120*2/(3*2),			-- Pixels to travel for next walk frame (horizontal)
            walkFrameDistanceVer		= 12*2,					-- Pixels to travel for next walk frame (vertical)
            minAge						= 30,					--
            maxAge						= 30,					--
            valueMultipliers			= {},					--
            valueAdders					= {},					--
            playIdleAnimations			= true,
            isCustomer					= false,
            allowAutoHorizontalFlip		= true,
            floor						= -30,
            moodPos						= {70, -280},
            moodPosSit					= {-100, -220},
            tipPos						= {70, -240},
            tipPosSit					= {-100, -180},
            moodHeartPos				= {0, -380},
            anchor						= "bottom",
            tableClipHeight				= 125,
            lookoutDuration				= 11000,
            waitAtDirtyTableTime		= 10000,
            shadowResource				= "shadow:characters",
			shadowBlendMode 			= "multiply",
            idleAnimations = {
                {a="idle1", f=150, c=1},
                {a="idle2", f=150, c=1},
                {a="idle3", f=150, c=1},
              },
            thinkTime = 0,
            eatTime = 5000,
        },

	-- P&L2
	-- Main characters
	-- TO BE REPLACED
--[[
    >>>>>>>>>>>>>>>>>>>>>>>
    >>>>>>>>>>>>>>>>>>>>>>>
    >>>>>CONCEPT CAST>>>>>>
    >>>>>>>>PL2>>>>>>>>>>>>
    >>>>>>>>>>>>>>>>>>>>>>>
--]]
    jacob= {
		baseAnimation = "jacob",
		tableClipHeight = 150,
	},

    jacob_young= {
		baseAnimation = "jacob_young",
		tableClipHeight = 150,
	},

    jacob_prison= {
		baseAnimation = "jacob_prison",
		tableClipHeight = 150,
	},
    marks= {
		baseAnimation = "marks",
		tableClipHeight = 150,
	},
    ron= {
		baseAnimation = "ron",
		tableClipHeight = 150,
	},
    misc_officer= {
		baseAnimation = "misc_officer",
		tableClipHeight = 150,
	},
    misc_female_officer= {
		baseAnimation = "misc_female_officer",
		tableClipHeight = 150,
	},
    judge_vance= {
		baseAnimation = "judge_vance",
		tableClipHeight = 150,
	},
    technician= {
		baseAnimation = "technician",
		tableClipHeight = 150,
	},
    bailiff= {
		baseAnimation = "bailiff",
		tableClipHeight = 150,
	},
    bomb_squad_1= {
		baseAnimation = "bomb_squad_1",
		tableClipHeight = 150,
	},
    employee_spa= {
		baseAnimation = "employee_spa",
		tableClipHeight = 150,
	},
    forensic_1= {
		baseAnimation = "forensic_1",
		tableClipHeight = 150,
	},
    evans= {
		baseAnimation = "evans",
		tableClipHeight = 150,
	},
    chen= {
		baseAnimation = "chen",
		tableClipHeight = 150,
	},
    andrew= {
		baseAnimation = "andrew",
		tableClipHeight = 150,
	},
    andrew_barman= {
		baseAnimation = "andrew_barman",
		tableClipHeight = 150,
	},
    andrew_young= {
		baseAnimation = "andrew_young",
		tableClipHeight = 150,
	},
    parker_young= {
		baseAnimation = "parker_young",
		tableClipHeight = 150,
	},
    kaylee= {
		baseAnimation = "kaylee",
		tableClipHeight = 150,
	},
    rick= {
		baseAnimation = "rick",
		tableClipHeight = 150,
	},
    steve= {
		baseAnimation = "steve",
		tableClipHeight = 150,
	},
    bernard= {
		baseAnimation = "bernard",
		tableClipHeight = 150,
	},
    victoria= {
		baseAnimation = "victoria",
		tableClipHeight = 150,
	},
    victorias_sister= {
		baseAnimation = "victorias_sister",
		tableClipHeight = 150,
	},
    prison_guard= {
		baseAnimation = "prison_guard",
		tableClipHeight = 150,
	},
    district_attourney= {
		baseAnimation = "district_attourney",
		tableClipHeight = 150,
	},
    parker = {
        baseAnimation = "parker",
        tableClipHeight = 150,
    },
    lane_court = {
        baseAnimation = "lane_court",
        tableClipHeight = 150,
        },
    
    stella = {
        baseAnimation = "stella",
        tableClipHeight = 150,
    },

    vasquez = {
        baseAnimation = "vasquez",
        tableClipHeight = 150,
    },
    donut_cop_1 = {
        baseAnimation = "donut_cop_1",
        tableClipHeight = 150,
    },
    donut_cop_2 = {
        baseAnimation = "donut_cop_2",
        tableClipHeight = 150,
    },
        lane = {
        baseAnimation = "lane",
        tableClipHeight = 150,
    },

    daisy = {
        baseAnimation = "daisy",
        tableClipHeight = 150,
    },
    bucket = {
        baseAnimation = "bucket",
        tableClipHeight = 150,
    },

--[[
    <<<<<<<<<<<<<<<<<<<<<<<
    <<<<<<<<<<<<<<<<<<<<<<<
    <<<<<CONCEPT CAST<<<<<<
    <<<<<<<<<PL2<<<<<<<<<<<
    <<<<<<<<<<<<<<<<<<<<<<<
--]]





--[[
    >>>>>>>>>>>>>>>>>>>>>>>
    >>>>>>>>>>>>>>>>>>>>>>>
    >>>>>>>>OTHER>>>>>>>>>>
    >>>>>>>>PL2>>>>>>>>>>>>
    >>>>>>>>>>>>>>>>>>>>>>>
--]]


phone = {
    baseAnimation = "phone",
},

deliveryman = {
    baseAnimation = "deliveryman",
},

--[[
    <<<<<<<<<<<<<<<<<<<<<<<
    <<<<<<<<<<<<<<<<<<<<<<<
    <<<<<<<<OTHER<<<<<<<<<<
    <<<<<<<<<PL2<<<<<<<<<<<
    <<<<<<<<<<<<<<<<<<<<<<<
--]]


        -- Customers P&L2
        -- r1

        ["police_officer_3_female"] = {
            baseAnimation = "customer-police_officer_3",
            gender = "female"
        },


        ["police_officer_3_male"] = {
            baseAnimation = "customer-police_officer_3",
            gender = "male"
        },


        ["police_officer_2_male"] = {
            baseAnimation = "customer-police_officer_2",
            gender = "male"
        },

        ["police_officer_2_female"] = {
            baseAnimation = "customer-police_officer_2",
            shadowResource	= "shadow_large:characters",
            gender = "female"
        },

        ["police_officer_1_male"] = {
            baseAnimation = "customer-police_officer_1",
            gender = "male"
        },

		["police_officer_1_female"] = {
            baseAnimation = "customer-police_officer_1",
            gender = "female"
        },

        ["suspect_1_female"] = {
            baseAnimation = "customer-suspect_1",
            gender = "female"
        },

        ["suspect_1_male"] = {
            baseAnimation = "customer-suspect_1",
            gender = "male"
        },

        ["suspect_4_female"] = {
            baseAnimation = "customer-suspect_4",
            gender = "female"
        },

        ["suspect_4_male"] = {
            baseAnimation = "customer-suspect_4",
            gender = "male"
        },

        ["suspect_2_male"] = {
            baseAnimation = "customer-suspect_2",
            gender = "male"
        },

		["suspect_2_female"] = {
            baseAnimation = "customer-suspect_2",
            gender = "female"
        },


		["suspect_3_female"] = {
            baseAnimation = "customer-suspect_3",
            shadowResource	= "shadow_large:characters",
            gender = "female"
        },

		["suspect_3_male"] = {
            baseAnimation = "customer-suspect_3",
            shadowResource	= "shadow_large:characters",
            gender = "male"
        },
        
        ["csi_specialist_4_male"] = {
            baseAnimation = "customer-csi_specialist_4",
            gender = "male",
            shadowResource	= "shadow_large:characters"
        },
  
        ["csi_specialist_4_female"] = {
            baseAnimation = "customer-csi_specialist_4",
            gender = "female",
        },


        ["csi_specialist_3_female"] = {
            baseAnimation = "customer-csi_specialist_3",
            gender = "female"
        },

		["csi_specialist_3_male"] = {
            baseAnimation = "customer-csi_specialist_3",
            gender = "male",
            shadowResource	= "shadow_large:characters"
        },

        ["csi_specialist_2_male"] = {
            baseAnimation = "customer-csi_specialist_2",
            gender = "male",
            shadowResource	= "shadow_large:characters"
        },

		["csi_specialist_2_female"] = {
            baseAnimation = "customer-csi_specialist_2",
            gender = "female"
        },

        ["csi_specialist_1_male"] = {
            baseAnimation = "customer-csi_specialist_1",
            gender = "male",
        },

		["csi_specialist_1_female"] = {
            baseAnimation = "customer-csi_specialist_1",
            gender = "female",
        },

        ["lab_scientist_4_female"] = {
            baseAnimation = "customer-lab_scientist_4",
            shadowResource	= "shadow_large:characters",
            gender = "female"
        },

        ["lab_scientist_4_male"] = {
            baseAnimation = "customer-lab_scientist_4",
            shadowResource	= "shadow_large:characters",
            gender = "male"
        },


        ["lab_scientist_3_female"] = {
            baseAnimation = "customer-lab_scientist_3",
            shadowResource	= "shadow_large:characters",
            gender = "female"
        },

        ["lab_scientist_3_male"] = {
            baseAnimation = "customer-lab_scientist_3",
            shadowResource	= "shadow_large:characters",
            gender = "male"
        },


		["lab_scientist_2_female"] = {
            baseAnimation = "customer-lab_scientist_2",
            shadowResource	= "shadow_large:characters",
            gender = "female"
        },

		["lab_scientist_2_male"] = {
            baseAnimation = "customer-lab_scientist_2",
            gender = "male"
        },

		["lab_scientist_1_female"] = {
            baseAnimation = "customer-lab_scientist_1",
            gender = "female"
        },

		["lab_scientist_1_male"] = {
            baseAnimation = "customer-lab_scientist_1",
            gender = "male"
        },

        --CUSTOMERS PARAMETERS
        ["suspect_1"] = {
            normal = true,
            baseAnimation = "customer-suspect_1",
            floor = -48,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 2,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },


            ["suspect_4"] = {
            normal = true,
            baseAnimation = "customer-suspect_4",
            floor = -48,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 2,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },
		
		
		["suspect_2"] = {
            normal = true,
            baseAnimation = "customer-suspect_2",
            floor = -48,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 2,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },
		
		["suspect_3"] = {
            normal = true,
            baseAnimation = "customer-suspect_3",
            floor = -48,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 2,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
            shadowResource = "shadow_large:characters",
        },

        ["police_officer_1"] = {
            normal = true,
            baseAnimation = "customer-police_officer_1",
            floor = -20,
            walkSpeed = 460,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 131,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },

        ["police_officer_2"] = {
            normal = true,
            baseAnimation = "customer-police_officer_2",
            floor = -20,
            walkSpeed = 460,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 131,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },

        ["police_officer_3"] = {
            normal = true,
            baseAnimation = "customer-police_officer_3",
            floor = -20,
            walkSpeed = 460,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 131,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 2,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },
       

        ["csi_specialist_1"] = {
            normal = true,
            baseAnimation = "customer-csi_specialist_1",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },
           

		["csi_specialist_2"] = {
            normal = true,
            baseAnimation = "customer-csi_specialist_2",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },

        ["csi_specialist_3"] = {
            normal = true,
            baseAnimation = "customer-csi_specialist_3",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },

        ["csi_specialist_4"] = {
            normal = true,
            baseAnimation = "customer-csi_specialist_4",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },


        ["lab_scientist_1"] = {
            normal = true,
            baseAnimation = "customer-lab_scientist_1",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },

        ["lab_scientist_2"] = {
            normal = true,
            baseAnimation = "customer-lab_scientist_2",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },  



        ["lab_scientist_3"] = {
            normal = true,
            baseAnimation = "customer-lab_scientist_3",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },
        
        ["lab_scientist_4"] = {
            normal = true,
            baseAnimation = "customer-lab_scientist_4",
            floor = -15,
            walkSpeed = 700,
            walkFrameDistanceHor = 120*3/(3*3),
            walkFrameDistanceVer = 12*3,
            tableClipHeight = 135,
            thinkTime = 0,
            eatTime = 5000,
            tipClass = 1,
            patienceClass = 3,
            complexityClass = 2,
            walkSpeed = 700,
            animationwalkSpeed = 700,
        },

        
}

--$$$

--table.copy_into(characterTypes, tmpCharacterTypes, false, false, false)

for _,v in pairs(characterTypes) do
    v.defaultSection = v.baseAnimation
    if (v.tipClass) then
        local tc = levelDesc.tipClasses[v.tipClass]
        --GH.assert(tc, "Tip class not found: '"..tostring(v.tipClass).."'")
        for k,t in pairs(tc) do v[k] = t end
    end
    if (v.patienceClass) then
        local pc = levelDesc.patienceClasses[v.patienceClass]
        --GH.assert(pc, "Patience class not found: '"..tostring(v.patienceClass).."'")
        for k,t in pairs(pc) do v[k] = t end
    end
end


maxQuickprepsOnMenu = 14 -- Restaurant 2
maxBonusTipOnMenu = 15 -- Restaurant 2 again

levelDesc.productEffects =
{
        default = {--[[workDuration=400, tip=0, increaseHappiness=0--]]}, --all the effects of the item-bonusses in the product chooser
}


local productEffects = levelDesc.productEffects

-- New for D13
levelDesc.productEffectValues =
{
    -- default
    defaultSingleWorkTime = 400,        -- workDuration
    defaultCompoundWorkTime = 200,      -- workDuration
    defaultRestockWorkTime = 600,		-- workDuration (restock)
    defaultPrepareTime = 2000,          -- prepareDuration
    defaultDecayTime = 4000,            -- decayDelay
    defaultFueledPrepareTime = 4000,    -- prepareDuration for the fueled objects
    defaultFueledDecayTime = 12000,     -- decayDelay for the fueled objects
    defaultWorth = 1,					-- worth
    defaultMoodBonus = 0,				-- increaseHappiness
    defaultMaxStock = 6,					-- stock
	defaultStartingStock = 3, 	        -- initial stock
    defaultTipAmount = 0,				-- tip
    defaultMeltTime = 5000,				-- meltDuration
    defaultRegrowDelayMin = 6000,		-- regrowDelayMin
    defaultRegrowDelayMax = 6000,		-- regrowDelayMax
    -- quickprep
    fastSingleWorkTime = 200,     		-- workDuration
	fastRestockWorkTime = 300, 		    -- workDuration (restock)
    fastCompoundWorkTime = 100,   		-- workDuration
    fastPrepareTime = 1600,       		-- prepareDuration
    fastFueledPrepareTime = 3000,       -- prepareDuration for the fueled objects
	-- decay
    slowDecayTime = 8000,         		-- decayDelay
	verySlowDecayTime = 12000,			-- decayDelay
    slowFueledDecayTime = 16000,        -- decayDelay for the fueled objects
    -- tip
    bonusTipAmount = 2,           		-- tip
    moodBonus = 1, 		 				-- increaseHappiness
    bigMoodBonus = 2,					-- increaseHappiness (Big)
	-- melt
    slowMeltTime = 10000,		 		-- meltDuration
    -- restock
    increaseWorth = 2, 					-- worth
	bigMaxStock = 9,   				    -- maxStock
    -- grow
    fastRegrowDelayMin = 3000,    		-- regrowDelayMin
    fastRegrowDelayMax = 3000, 			-- regrowDelayMax
}

local productEffectValues = levelDesc.productEffectValues

productGroups = {
    { -- MAP 1

		--ROOM1 (chens_restaurant)
        pg_single7 ={{images={"button#c3-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        pg_single8 ={{images={"button#s1-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        pg_single9 ={{images={"button#c2-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},},


        pg_restocker11 =
		{
            {images={"button#r1","button#s1-3","button#s1-3_empty"}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil
                }
            },
		},


        pg_compound21 =
		{
			{images={"button#s1-61",  "button#s1-62", "button#s1-64"},
                effects={
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                }
            },
		},
        
        pg_pile = 
        {
            {images={"button#c1-1", "button#c1-2"}, 
                effects={
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                }
            },
        },   


        -- ROOM 2 (POLICE STATION)
        pg_single2_5 =
		{
			{images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        
        --EVIDENCE BAG VERSIONS
		pg_single2_6 =
		{
			{images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v1
        },
        
        pg_single2_6_2 =
		{
			{images={"button#s1-6_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v2
        },
        
		pg_single2_6_3 =
		{
			{images={"button#s1-6_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v3
        },
        
		pg_single2_6_4 =
		{
			{images={"button#s1-6_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v4
        },
        
		pg_single2_6_5 =
		{
			{images={"button#s1-6_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v5
        },

		pg_single2_7 =
		{
			{images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        
		--RAP SHEET VERSIONS
		pg_single2_8 =
		{
			{images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets
        },
        pg_single2_8_2 =
		{
			{images={"button#s1-8_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V2
        },
		pg_single2_8_3 =
		{
			{images={"button#s1-8_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V3
        },
		pg_single2_8_4 =
		{
			{images={"button#s1-8_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V4
        },
		pg_single2_8_5 =
		{
			{images={"button#s1-8_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V5
        },
       



        pg_compound2_1 = 
        {
            {images={"button#r1","button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64","button#s1-64_empty"},
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil,
                }
            },
        },



--DELETE THIS ONE
--[[
		pg_compound1 =
		{
			{images={"button#r1",  "button#c2-1",  "button#c2-2", "button#c2-3", "button#c2-4", "button#c2-3_empty", "button#c2-4_empty"},
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil, nil
                }
            },
        },
        --]]
		-- glass of water
		pg_timer1 =
		{
			{images={"button#timer1-a", "button#timer1-a.ready"}, 
                effects={
                    nil,
                    {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
                }
            },
		},


        -- ROOM 3 (KAYLEE'S BASEMENT)





        pg_single3_1 = {{images={"button#s3-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single3_2 = {{images={"button#s3-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single3_3 = {{images={"button#c2-1"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},

        
        pg_restocker3_1 =
		{
            {images={"button#r5","button#s3-1","button#s3-1_empty"}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil
                }
            },
		},


        
        pg_compound31 =
		{
			{images={"button#s1-61",  "button#s1-62", "button#s1-63", "button#s1-64"},
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                }
            },
		},


        
        -- ROOM 4 (Toxicology)

        pg_single4_1 = 
        {
             {images={"button#s4-1","button#s4-1_empty"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},nil,}},
         },
         pg_single4_2 = 
         {
             {images={"button#s4-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },
         pg_single4_3 = 
         {
             {images={"button#s4-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

         pg_single4_4 = 
         {
             {images={"button#s7-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

        
        
         pg_single11 = {{images={"button#s7-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        
         pg_single12 = {{images={"button#s7-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        
         pg_timer11 ={{images={"button#timer2-a", "button#timer2-a.ready"}, effects={nil, {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        
         pg_timer12 = {{images={"button#timer1-a", "button#timer1-a.ready"},effects={nil,{prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        
         pg_compound10 =
         {
             {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime},
                     nil, nil, nil, nil,
                 }
             },
         },
        
        
         pg_compound11 =
         {
             {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime},
                     nil, nil, nil, nil,
                 }
             },
         },
         pg_compound12 =
         {
             {images={"button#r5", "button#c5-2",  "button#c5-3", "button#c5-4", "button#c5-1", "button#c5-1_empty",}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                     nil 
                 }
             },
         },
        
         pg_compound13 =
         {
             {images={"button#r5", "button#c6-3",  "button#c6-2", "button#c6-4", "button#c6-1", "button#c6-1_empty",}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                     nil 
                 }
             },
         },
         pg_compound4_1 = 
         {
             {images={"button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64"},
                 effects={
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
        
                 }
             },
         },
        },

    { -- MAP 2

            -- ROOM 2 (POLICE STATION)
            pg_single2_5 =
            {
                {images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
            },
            
            pg_single2_6 =
            {
                {images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            pg_single2_6_2 =
            {
                {images={"button#s1-6_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v2
            },
            
            pg_single2_6_3 =
            {
                {images={"button#s1-6_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v3
            },
            
            pg_single2_6_4 =
            {
                {images={"button#s1-6_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v4
            },
            pg_single2_6_5 =
            {
                {images={"button#s1-6_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v5
            },
    
            pg_single2_7 =
            {
                {images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            
            pg_single2_8 =
            {
                {images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            
            pg_single2_8_2 =
            {
                {images={"button#s1-8_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V2
            },
            pg_single2_8_3 =
            {
                {images={"button#s1-8_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V3
            },
            pg_single2_8_4 =
            {
                {images={"button#s1-8_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V4
            },
            pg_single2_8_5 =
            {
                {images={"button#s1-8_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V5
            },
       
    
            -- glass of water
            pg_timer1 =
            {
                {images={"button#timer1-a", "button#timer1-a.ready"}, 
                    effects={
                        nil,
                        {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
                    }
                },
            },
    
            pg_compound2_1 = 
            {
                {images={"button#r1","button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64","button#s1-64_empty"},
                    effects={
                        {workDuration = productEffectValues.defaultRestockWorkTime},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        nil,
                    }
                },
            },
    
--------------------------VILA BEDCHAMBER---------------------------     
		pg_single60 = 
        {
            {images={"button#s6-1"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
   
		pg_r6_1 =
		{
			{images={"button#r6-3", "button#s6-2", "button#s6-2_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},
		
	pg_r6_2 =
		{
			{images={"button#r6-2", "button#s6-1", "button#s6-1_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},
	
		pg_compound61 =
		{
			{images={"button#s6-11", "button#s6-12", "button#s6-13", "button#s6-14"},
				effects={
					{workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
					{workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
					{workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
					{workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
				}
			},
		},
	
	
		pg_single61	= 
		{
            {images={"button#s6-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
		
		pg_r6_3 =
		{
            {images={"button#s6-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


		pg_single65 = 
        {
            {images={"button#s6-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
		

		
--------------------TOXICOLOGY-----------------------------

pg_single4_1 = 
{
     {images={"button#s4-1","button#s4-1_empty"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},nil,}},
 },

 pg_single4_2 = 
 {
     {images={"button#s4-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
 },

 pg_single4_3 = 
 {
     {images={"button#s4-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
 },
 pg_single4_4 = 
 {
     {images={"button#s7-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
 },


 pg_single11 = {{images={"button#s7-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},

 pg_single12 = {{images={"button#s7-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},

 pg_timer11 ={{images={"button#timer2-a", "button#timer2-a.ready"}, effects={nil, {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},

 pg_timer12 = {{images={"button#timer1-a", "button#timer1-a.ready"},effects={nil,{prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},

 pg_compound10 =
 {
     {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
         effects={
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime},
             nil, nil, nil, nil,
         }
     },
 },


 pg_compound11 =
 {
     {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
         effects={
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime},
             nil, nil, nil, nil,
         }
     },
 },
 pg_compound12 =
 {
     {images={"button#r5", "button#c5-2",  "button#c5-3", "button#c5-4", "button#c5-1", "button#c5-1_empty",}, 
         effects={
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
             nil 
         }
     },
 },

 pg_compound13 =
 {
     {images={"button#r5", "button#c6-3",  "button#c6-2", "button#c6-4", "button#c6-1", "button#c6-1_empty",}, 
         effects={
             {workDuration = productEffectValues.defaultRestockWorkTime}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
             nil 
         }
     },
 },
 pg_compound4_1 = 
 {
     {images={"button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64"},
         effects={
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
             {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},

         }
     },
 },

        -- ROOM 5 (Evidence room)
        pg_single50_4 = 
        {
            {images={"button#s5-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_5 = 
        {
            {images={"button#s5-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_6 = 
        {
            {images={"button#s5-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_7 = 
        {
            {images={"button#s5-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_11 = 
        {
            {images={"button#s5-11"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_12 = 
        {
            {images={"button#s5-12"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_13 = 
        {
            {images={"button#s5-13"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_14 = 
        {
            {images={"button#s5-14"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_15 = 
        {
            {images={"button#s5-15"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_16 = 
        {
            {images={"button#s5-16"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_17 = 
        {
            {images={"button#s5-17"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_18 = 
        {
            {images={"button#s5-18"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_19 = 
        {
            {images={"button#s5-19"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_20 = 
        {
            {images={"button#s5-20"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_21 = 
        {
            {images={"button#s5-21"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_22 = 
        {
            {images={"button#s5-22"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_23 = 
        {
            {images={"button#s5-23"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_24 = 
        {
            {images={"button#s5-24"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_r5_1 =
		{
			{images={"button#r5-1", "button#s5-25", "button#s5-25_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},


        pg_r5_2 =
		{
			{images={"button#r5-2", "button#s5-26", "button#s5-26_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},


        pg_single50_25 = 
        {
            {images={"button#s5-25"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_26 = 
        {
            {images={"button#s5-26"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },

    },

    { -- MAP 3

            -- ROOM 2 (POLICE STATION)
            pg_single2_5 =
            {
                {images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
            },
            
            pg_single2_6 =
            {
                {images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            pg_single2_6_2 =
            {
                {images={"button#s1-6_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v2
            },
            
            pg_single2_6_3 =
            {
                {images={"button#s1-6_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v3
            },
            
            pg_single2_6_4 =
            {
                {images={"button#s1-6_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v4
            },
            pg_single2_6_5 =
            {
                {images={"button#s1-6_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v5
            },

            pg_single2_7 =
            {
                {images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            
            pg_single2_8 =
            {
                {images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            pg_single2_8_2 =
            {
                {images={"button#s1-8_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V2
            },
            pg_single2_8_3 =
            {
                {images={"button#s1-8_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V3
            },
            pg_single2_8_4 =
            {
                {images={"button#s1-8_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V4
            },
            pg_single2_8_5 =
            {
                {images={"button#s1-8_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V5
            },

		-- glass of water
		pg_timer1 =
		{
			{images={"button#timer1-a", "button#timer1-a.ready"}, 
                effects={
                    nil,
                    {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
                }
            },
		},

        pg_compound2_1 = 
        {
            {images={"button#r1","button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64","button#s1-64_empty"},
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil,
                }
            },
        },
        
    ------------------
    ------ROOM7-------
    ------------------
    pg_single7_1 = {{images={"button#s1-1"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
    pg_single7_2 = {{images={"button#s1-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
    pg_single7_3 = {{images={"button#s1-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
    pg_single7_4 = {{images={"button#s1-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
    pg_single7_5 = {{images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},


    pg_compound7_1 = 
    {
        {images={"button#s1-61",  "button#s1-62", "button#s1-63"},
            effects={
                {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
            }
        },
    },
        -- ROOM 5 (Evidence room)
        pg_single50_4 = 
        {
            {images={"button#s5-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_5 = 
        {
            {images={"button#s5-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_6 = 
        {
            {images={"button#s5-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_7 = 
        {
            {images={"button#s5-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_11 = 
        {
            {images={"button#s5-11"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_12 = 
        {
            {images={"button#s5-12"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_13 = 
        {
            {images={"button#s5-13"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_14 = 
        {
            {images={"button#s5-14"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_15 = 
        {
            {images={"button#s5-15"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_16 = 
        {
            {images={"button#s5-16"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_17 = 
        {
            {images={"button#s5-17"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_18 = 
        {
            {images={"button#s5-18"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_19 = 
        {
            {images={"button#s5-19"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_20 = 
        {
            {images={"button#s5-20"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_21 = 
        {
            {images={"button#s5-21"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_22 = 
        {
            {images={"button#s5-22"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_23 = 
        {
            {images={"button#s5-23"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_24 = 
        {
            {images={"button#s5-24"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_r5_1 =
		{
			{images={"button#r5-1", "button#s5-25", "button#s5-25_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},


        pg_r5_2 =
		{
			{images={"button#r5-2", "button#s5-26", "button#s5-26_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},


        pg_single50_25 = 
        {
            {images={"button#s5-25"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_26 = 
        {
            {images={"button#s5-26"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },

        
    
        
     },

    { -- MAP 4

        -- ROOM 2 (POLICE STATION)
        pg_single2_5 =
		{
			{images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
		
		pg_single2_6 =
		{
			{images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
		},
        pg_single2_6_2 =
        {
            {images={"button#s1-6_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v2
        },
        
        pg_single2_6_3 =
        {
            {images={"button#s1-6_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v3
        },
        
        pg_single2_6_4 =
        {
            {images={"button#s1-6_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v4
        },
        pg_single2_6_5 =
        {
            {images={"button#s1-6_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v5
        },
    
		pg_single2_7 =
		{
			{images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
		},
		
		pg_single2_8 =
		{
			{images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
		},
        pg_single2_8_2 =
        {
            {images={"button#s1-8_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V2
        },
        pg_single2_8_3 =
        {
            {images={"button#s1-8_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V3
        },
        pg_single2_8_4 =
        {
            {images={"button#s1-8_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V4
        },
        pg_single2_8_5 =
        {
            {images={"button#s1-8_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V5
        },
    

		-- glass of water
		pg_timer1 =
		{
			{images={"button#timer1-a", "button#timer1-a.ready"}, 
                effects={
                    nil,
                    {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
                }
            },
		},

        pg_compound2_1 = 
        {
            {images={"button#r1","button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64","button#s1-64_empty"},
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil,
                }
            },
        },




        

        -- ROOM 4 (Toxicology)
        
        
        pg_single4_1 = 
       {
            {images={"button#s4-1","button#s4-1_empty"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},nil,}},
        },

        pg_single4_2 = 
        {
            {images={"button#s4-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single4_3 = 
        {
            {images={"button#s4-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },

        pg_single4_4 = 
        {
            {images={"button#s7-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single11 = {{images={"button#s7-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},

        pg_single12 = {{images={"button#s7-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},

        pg_timer11 ={{images={"button#timer2-a", "button#timer2-a.ready"}, effects={nil, {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},

        pg_timer12 = {{images={"button#timer1-a", "button#timer1-a.ready"},effects={nil,{prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},

		pg_compound10 =
		{
			{images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime},
                    nil, nil, nil, nil,
                }
            },
        },


		pg_compound11 =
		{
			{images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime},
                    nil, nil, nil, nil,
                }
            },
        },
		pg_compound12 =
		{
			{images={"button#r5", "button#c5-2",  "button#c5-3", "button#c5-4", "button#c5-1", "button#c5-1_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                    nil 
                }
            },
		},

        pg_compound13 =
		{
			{images={"button#r5", "button#c6-3",  "button#c6-2", "button#c6-4", "button#c6-1", "button#c6-1_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                    nil 
                }
            },
        },
        pg_compound4_1 = 
        {
            {images={"button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64"},
                effects={
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},

                }
            },
        },

        
        --ROOM11 (UNDERGROUND PARKING 2)
        
        pg_single11_1 =
		{
			{images={"button#s1-1"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_2 =
		{
			{images={"button#s1-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_3 =
		{
			{images={"button#s1-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_4 =
		{
			{images={"button#s1-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_5 =
		{
			{images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_6 =
		{
			{images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_7 =
		{
			{images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
        pg_single11_8 =
		{
			{images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},

    },

    { -- MAP 5

        -- ROOM 2 (POLICE STATION)
        pg_single2_5 =
		{
			{images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
		},
		
		pg_single2_6 =
		{
			{images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
		},
        pg_single2_6_2 =
        {
            {images={"button#s1-6_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v2
        },
        
        pg_single2_6_3 =
        {
            {images={"button#s1-6_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v3
        },
        
        pg_single2_6_4 =
        {
            {images={"button#s1-6_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v4
        },
        pg_single2_6_5 =
        {
            {images={"button#s1-6_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v5
        },
		
		pg_single2_7 =
		{
			{images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
		},
		
		pg_single2_8 =
		{
			{images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
		},
        pg_single2_8_2 =
        {
            {images={"button#s1-8_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V2
        },
        pg_single2_8_3 =
        {
            {images={"button#s1-8_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V3
        },
        pg_single2_8_4 =
        {
            {images={"button#s1-8_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V4
        },
        pg_single2_8_5 =
        {
            {images={"button#s1-8_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V5
        },

		-- glass of water
		pg_timer1 =
		{
			{images={"button#timer1-a", "button#timer1-a.ready"}, 
                effects={
                    nil,
                    {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
                }
            },
		},


        pg_compound2_1 = 
        {
            {images={"button#r1","button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64","button#s1-64_empty"},
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil,
                }
            },
        },



        

        -- ROOM 4 (Toxicology)

        pg_single4_1 = 
        {
             {images={"button#s4-1","button#s4-1_empty"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},nil,}},
         },
         pg_single4_2 = 
         {
             {images={"button#s4-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

         pg_single4_3 = 
         {
             {images={"button#s4-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

         pg_single4_4 = 
         {
             {images={"button#s7-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

        
         pg_single11 = {{images={"button#s7-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        
         pg_single12 = {{images={"button#s7-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        
         pg_timer11 ={{images={"button#timer2-a", "button#timer2-a.ready"}, effects={nil, {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        
         pg_timer12 = {{images={"button#timer1-a", "button#timer1-a.ready"},effects={nil,{prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        
         pg_compound10 =
         {
             {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime},
                     nil, nil, nil, nil,
                 }
             },
         },
        
        
         pg_compound11 =
         {
             {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime},
                     nil, nil, nil, nil,
                 }
             },
         },
         pg_compound12 =
         {
             {images={"button#r5", "button#c5-2",  "button#c5-3", "button#c5-4", "button#c5-1", "button#c5-1_empty",}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                     nil 
                 }
             },
         },
        
         pg_compound13 =
         {
             {images={"button#r5", "button#c6-3",  "button#c6-2", "button#c6-4", "button#c6-1", "button#c6-1_empty",}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                     nil 
                 }
             },
         },
         pg_compound4_1 = 
         {
             {images={"button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64"},
                 effects={
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
        
                 }
             },
         },
                



-----------------
----COURTROOM----
-----------------
pg_restocker9_1  =
{
    {images={"button#r1","button#s1-1","button#s1-1_empty"}, 
        effects={
            {workDuration = productEffectValues.defaultRestockWorkTime},
            {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
            nil
        }
    },
},

pg_timer9_1 =
{
    {images={"button#timer1-a", "button#timer1-a.ready"}, 
        effects={
            nil,
            {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
        }
    },
},


pg_timer9_2 =
{
    {images={"button#timer2-a","button#r2", "button#timer2-a.ready","button#s1-2_empty"},
     effects={nil,
      {workDuration = productEffectValues.defaultRestockWorkTime}, 
      {prepareDuration = productEffectValues.defaultPrepareTime, 
      decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus 
     },nil
    
    }
    
    },
},
        pg_single9_1 = --s1-2
        {
            {images={"button#s1-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_2 = 
        {
            {images={"button#s1-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_3 = 
        {
            {images={"button#s1-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_4 = 
        {
            {images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_5 = 
        {
            {images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_6 = 
        {
            {images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_7 = 
        {
            {images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_8 = 
        {
            {images={"button#s1-9"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_9 = 
        {
            {images={"button#s1-10"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },
        pg_single9_10 = 
        {
            {images={"button#s1-11"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },

        pg_single9_11 = 
        {
            {images={"button#s1-12"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },




    },

    { -- MAP 6
    
            -- ROOM 2 (POLICE STATION)
            pg_single2_5 =
            {
                {images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},
            },
            
            pg_single2_6 =
            {
                {images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            pg_single2_6_2 =
            {
                {images={"button#s1-6_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v2
            },
            
            pg_single2_6_3 =
            {
                {images={"button#s1-6_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v3
            },
            
            pg_single2_6_4 =
            {
                {images={"button#s1-6_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v4
            },
            pg_single2_6_5 =
            {
                {images={"button#s1-6_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Evidence bag v5
            },
               
            pg_single2_7 =
            {
                {images={"button#s1-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            
            pg_single2_8 =
            {
                {images={"button#s1-8"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
            },
            pg_single2_8_2 =
            {
                {images={"button#s1-8_2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V2
            },
            pg_single2_8_3 =
            {
                {images={"button#s1-8_3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V3
            },
            pg_single2_8_4 =
            {
                {images={"button#s1-8_4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V4
            },
            pg_single2_8_5 =
            {
                {images={"button#s1-8_5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},--Rap sheets V5
            },
    
            pg_compound2_1 = 
            {
                {images={"button#r1","button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64","button#s1-64_empty"},
                    effects={
                        {workDuration = productEffectValues.defaultRestockWorkTime},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                        nil,
                    }
                },
            },
            -- glass of water
		pg_timer1 =
		{
			{images={"button#timer1-a", "button#timer1-a.ready"}, 
                effects={
                    nil,
                    {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}
                }
            },
		},





        

        -- ROOM 4 (Toxicology)

        pg_single4_1 = 
        {
             {images={"button#s4-1","button#s4-1_empty"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},nil,}},
         },
        
         pg_single4_2 = 
         {
             {images={"button#s4-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

         pg_single4_3 = 
         {
             {images={"button#s4-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

         pg_single4_4 = 
         {
             {images={"button#s7-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
         },

         pg_single11 = {{images={"button#s7-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        
         pg_single12 = {{images={"button#s7-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        
         pg_timer11 ={{images={"button#timer2-a", "button#timer2-a.ready"}, effects={nil, {prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        
         pg_timer12 = {{images={"button#timer1-a", "button#timer1-a.ready"},effects={nil,{prepareDuration = productEffectValues.defaultPrepareTime, decayDelay = productEffectValues.defaultDecayTime, increaseHappiness = productEffectValues.defaultMoodBonus}}},},
        
         pg_compound10 =
         {
             {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime},
                     nil, nil, nil, nil,
                 }
             },
         },
        
        
         pg_compound11 =
         {
             {images={"button#r4-1", "button#r4-2","button#r4-3","button#c4-1", "button#c4-2", "button#c4-3", "button#c4-4", "button#c4-5", "button#c4-2_empty", "button#c4-3_empty", "button#c4-4_empty", "button#c4-5_empty"}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime},
                     nil, nil, nil, nil,
                 }
             },
         },
         pg_compound12 =
         {
             {images={"button#r5", "button#c5-2",  "button#c5-3", "button#c5-4", "button#c5-1", "button#c5-1_empty",}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                     nil 
                 }
             },
         },
        
         pg_compound13 =
         {
             {images={"button#r5", "button#c6-3",  "button#c6-2", "button#c6-4", "button#c6-1", "button#c6-1_empty",}, 
                 effects={
                     {workDuration = productEffectValues.defaultRestockWorkTime}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},  
                     nil 
                 }
             },
         },
         pg_compound4_1 = 
         {
             {images={"button#s1-61",  "button#s1-62", "button#s1-63","button#s1-64"},
                 effects={
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
                     {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},
        
                 }
             },
         },
        
        -- ROOM 5 (Evidence room)
        pg_single50_4 = 
        {
            {images={"button#s5-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_5 = 
        {
            {images={"button#s5-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_6 = 
        {
            {images={"button#s5-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_7 = 
        {
            {images={"button#s5-7"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_11 = 
        {
            {images={"button#s5-11"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_12 = 
        {
            {images={"button#s5-12"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_13 = 
        {
            {images={"button#s5-13"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_14 = 
        {
            {images={"button#s5-14"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_15 = 
        {
            {images={"button#s5-15"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_16 = 
        {
            {images={"button#s5-16"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_17 = 
        {
            {images={"button#s5-17"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_18 = 
        {
            {images={"button#s5-18"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_19 = 
        {
            {images={"button#s5-19"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_20 = 
        {
            {images={"button#s5-20"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_21 = 
        {
            {images={"button#s5-21"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_22 = 
        {
            {images={"button#s5-22"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_23 = 
        {
            {images={"button#s5-23"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_24 = 
        {
            {images={"button#s5-24"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_r5_1 =
		{
			{images={"button#r5-1", "button#s5-25", "button#s5-25_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},


        pg_r5_2 =
		{
			{images={"button#r5-2", "button#s5-26", "button#s5-26_empty",}, 
                effects={
                    {workDuration = productEffectValues.defaultRestockWorkTime}, 
                    {increaseHappiness = productEffectValues.defaultMoodBonus},
                    nil 
                }
            },
		},


        pg_single50_25 = 
        {
            {images={"button#s5-25"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        pg_single50_26 = 
        {
            {images={"button#s5-26"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus}}},
        },


        
    ------------------
    -----ROOM10-------
    ------------------

        pg_single10_1 = {{images={"button#s1-1"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single10_2 = {{images={"button#s1-2"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single10_3 = {{images={"button#s1-3"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single10_4 = {{images={"button#s1-4"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single10_5 = {{images={"button#s1-5"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},
        pg_single10_6 = {{images={"button#s1-6"}, effects={{increaseHappiness = productEffectValues.defaultMoodBonus},{tip = productEffectValues.defaultTipAmount}}},},




        pg_compound10_1 = 
		{
			{images={"button#r1","button#r2", "button#s1-61",  "button#s1-62", "button#s1-63", "button#s1-64","button#s1-65","button#s1-66","button#s1-63_empty","button#s1-64_empty" }, 
                effects={
                    
                    {workDuration = productEffectValues.defaultRestockWorkTime},
                    {workDuration = productEffectValues.defaultRestockWorkTime},  
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},                     
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus},                    
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    {workDuration = productEffectValues.defaultCompoundWorkTime, increaseHappiness = productEffectValues.defaultMoodBonus}, 
                    nil,nil 
                
                }
            },
		},







        },
    
}

--[[
endLevelJingle = {
    rest1 = {day5={}},
    rest8 = {day9={}}
}
]]

-- muting the ending jingle example
--[[
levelDesc.endLevelJingle = {
    rest1 = {day3={sound="day_start:sound"}}, -- Play this sound
    rest2 = {day2={}} -- No sound
}
--]]
