dofile("script/events/Event.lua")

-- ************************************ Deliver Event ************************************ --
CheckUpEvent = deriveLuaClass("CheckUpEvent", "Event")

function CheckUpEvent:init(desc)
	CheckUpEvent.superInit(self, desc)

	-- Status
	self.currentCheckUpId = 1
	self.checkUpStatus = "offscreen"
	self.eventObjectId = desc.eventObjectId or "eventObject"
end

function CheckUpEvent:setupChallenge()
	level.challengeManager:setupEventChallenge(#self.checkUpDelays, true)

	self.stateTimer = self.checkUpDelays[self.currentCheckUpId]
end

function CheckUpEvent:onTick(time)
	if (not self.started or self:areAllItemsDone()) then
		return
	end

	if (self.checkUpStatus == "offscreen" and self.stateTimer) then
		self.stateTimer = self.stateTimer - time
		if (self.stateTimer <= 0) then
			self.checkUpStatus = "checking up"
			self.eventObject = self.eventObject or level:getObject(self.eventObjectId)
			self.eventObject.onWorkStart = self.eventObject_onWorkStart
			taskSystem:createAnimation("eventObjectWalkIn")--..self.currentCheckUpId)
		end
	end
end

function CheckUpEvent.eventObject_onWorkStart(obj, task)
	event:hideHintArrow()
	if (not event.started or event.completed) then
		return false
	end

	obj.onWorkStart = function(obj, task) end

	taskSystem:createAnimation("eventObjectWork")
end

function CheckUpEvent:handleTrigger(trigger, data)
	CheckUpEvent.super.handleTrigger(self, trigger, data)
	if (trigger == "checkUpComplete") then
		self.currentCheckUpId = self.currentCheckUpId + 1
		self:scoreItemDone({obj=self.eventObject})
		self:onProgress()
		taskSystem:createAnimation("eventObjectWalkOut")
	end
	if (trigger == "walkOutComplete") then
		self.checkUpStatus = "offscreen"
		self.stateTimer = self.checkUpDelays[self.currentCheckUpId]
	end
end

function CheckUpEvent:areAllItemsDone()
	return self.currentCheckUpId > #self.checkUpDelays
end

function CheckUpEvent:getProgress()
	return (self.currentCheckUpId-1) / #self.checkUpDelays
end

function CheckUpEvent:getNumItemsTodoTotal()
	return #self.checkUpDelays
end
