dofile("script/events/Event.lua")

-- ************************************ Hidden Object Event ************************************ --
HiddenObjectEvent = deriveLuaClass("HiddenObjectEvent", "Event")

function HiddenObjectEvent:init(desc)
	HiddenObjectEvent.superInit(self, desc)

	-- Configuration variables

	-- Status variables

	-- Override
	self.matchingItemType = "HiddenObject"
end

function HiddenObjectEvent:onInitialized()
	HiddenObjectEvent.super.onInitialized(self)
	for _,item in ipairs(self.items) do
		item.drawOutline = false
		item.obj.onClick = self.hiddenObject_onClick
		item.obj.highlightSound = "" -- Mute the highlight
		item.obj.drawOutline = false
	end
end

function HiddenObjectEvent.hiddenObject_onClick(obj)
	if (obj.visible) then

		--if (player.trophyManager and player.gameStats.hiddenObjectFound) then
		--	player.gameStats:hiddenObjectFound(obj.name.."_"..player.room.."_"..player.shift.."_"..player.level)
		--	player.trophyManager:checkTrophyGoalReached(19)
		--end

		event:itemDone(obj.item)
		if (obj.workSoundId) then
			obj:playSample(obj.workSoundId)
		end
		return true
	end
end

-- ************************************ Hidden Object ************************************ --
HiddenObject = deriveLuaClass("HiddenObject", "Object")

function HiddenObject:init(desc)
	HiddenObject.superInit(self, desc)
	self.isInsidePriority = desc.isInsidePriority or 10
end
