doRoomFiles('room6')
dofile("script/events/DeliverEvent.lua")

levelDesc = levelDesc or {}
levelDesc.values.maxTraySize = 6

levelDesc.autoStartShift = true
--levelDesc.hasEventBar = true

--$$$
--Everything above or below the delimiters will be ignored by the tool
--Between the delimiters, only non-function elements of levelDesc will be maintained.

levelDesc.customerChances = {
	biggie_snu_formal = 7,
	children_kid = 4,
	elder_snu = 5,
	normal_snu = 6,
	yuppie_casual = 8,
}

levelDesc.trigger = {
	class = "TriggerSystem",
	triggers = {
		{delay = 0, orderSize = 4, place = "table", size = 4, trigger = "spawn", },
		{delay = 12000, orderSize = 4, place = "table", size = 4, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "table", size = 2, trigger = "spawn", },
		{class = "GestureCustomerGroup", customers = {{traits = "biggie_snu_formal", gender="male",}, {traits = "normal_kid", gender="female",}, }, delay = 12000, orderSize = 2, place = "workshop", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "table", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 20000, orderSize = 2, place = "counter", trigger = "spawn", },
		{class = "GestureCustomerGroup", customers = {{traits = "elder_snu", gender="female",}, {traits = "biggie_kid", gender="male",}, }, delay = 6000, orderSize = 2, place = "workshop", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 9000, orderSize = 4, place = "table", size = 4, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "table", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{class = "GestureCustomerGroup", customers = {{traits = "biggie_snu_formal", gender="male",}, {traits = "normal_kid", gender="female",}, }, delay = 6000, orderSize = 2, place = "workshop", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 4, place = "table", size = 4, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "table", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{class = "GestureCustomerGroup", customers = {{traits = "normal_snu", gender="male",}, {traits = "children_kid", gender="male",}, }, delay = 8000, orderSize = 2, place = "workshop", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "table", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 11000, orderSize = 4, place = "table", size = 4, trigger = "spawn", },
		{class = "GestureCustomerGroup", customers = {{traits = "biggie_snu_formal", gender="male",}, {traits = "normal_kid", gender="female",}, }, delay = 12000, orderSize = 2, place = "workshop", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "table", size = 2, trigger = "spawn", },
		{delay = 12000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 2, place = "counter", trigger = "spawn", },
		{delay = 6000, orderSize = 4, place = "table", size = 4, trigger = "spawn", },
	},
}

--$$$
levelDesc.eventDesc =
{
	 class = "DeliverEvent",
	 autoStart = true,
	 useCustomersList = true,
	 randomCustomers = false,
	 randomProducts = false,
	 maxItemsInOrderAtTheSameTime = 1,
	 timeBeforeFirstOrder = 12000,
	 minTimeBetweenOrders = 25000,
	 maxTimeBetweenOrders = 28000,
	 scoreOneDone = 0,
	 scoreAllDone = 0,
	 items = {
		{
			obj="day10_eventCharacter",
			acceptedProducts=
			{
				--1st order (only available products)
				"#single5-a", "#single5-b",
				--2nd order (only available products)
				"#timer1-2-a.ready#timer1-4-a", "#timer1-2-b.ready#timer1-4-b",
				--3rd order (only available products)
				"#single4-a", "#single4-b",
				--4th order (only available products)
				"#timer1-1-a.ready#timer1-3-a", "#timer1-1-b.ready#timer1-3-b",
				--5th order (only available products)
				"#compound2-1-a#compound2-2-a#compound2-3-a#compound2-5-a",	"#compound2-1-b#compound2-2-b#compound2-3-b#compound2-5-b",
				--6th order (only available products)
				"#single1-a", "#single1-b",
				--7th order (only available products)
				"#timer1-1-a.ready#timer1-4-a", "#timer1-1-b.ready#timer1-4-b",
				--8th order (only available products)
				--"#compound1-1-a#compound1-2-a#compound1-1-a#compound1-3-a#compound1-4-a", "#compound1-1-b#compound1-2-b#compound1-1-b#compound1-3-b#compound1-4-b",
				--9th order (only available products)
				"single2-a", "#single2-b",
			},
			eventCustomersList=
			{
				{defaultSection="evelyn", baseAnimation="evelyn"},
				{defaultSection="brigid", baseAnimation="brigid"},
				{defaultSection="mary_lynn_casual", baseAnimation="mary_lynn_casual"},
				{defaultSection="andy", baseAnimation="andy"},
				{defaultSection="stacy", baseAnimation="stacy"},
				{defaultSection="mike", baseAnimation="mike"},
				{defaultSection="sharon", baseAnimation="sharon"},
				{defaultSection="chad", baseAnimation="chad"},
				{defaultSection="emily", baseAnimation="emily"},
			}
		}
	 },
}
