minigameClassNames = {
	"Stitch",						-- 1
	"BubbleTap",					-- 2
	"AdjustDrip",					-- 3
	"ApplyCream",					-- 4
	"MakePills",					-- 5
	"FillUp",						-- 6
	"SearchMeds",					-- 7
	"CutsCuts",						-- 8
	"HookUp",						-- 9
	"Massage",						-- 0
	"ResetJoints",					-- a
	"WhackPunch",					-- b
	"UltrasoundClots",				-- c
	"CheckScan",					-- d
	"MatchXRay",					-- e
	"Anaesthetic",					-- f +++
	"CheckStable",					-- g
    "SuckMess",						-- h
    "Boss",							-- i
    "RandomGame",					-- j
};

Minigame = getClass("Minigame")
Minigame.gameDefaults = {
    name="game",
    pivot="center",
  --  x=17, y=182, width=1590, height=1028,
		autoCenter=true,
    closeDelayWon = 400,
    closeDelayLost = 1000,
}
Minigame.containerDefaults = {
	name="minigameContainer",
	doDarkenBackground = true,
	anchor="center",
	autoCenter=true,
	movable = false,
	clickAnywhereToCloseOk = true,
    width=1626, height=177+1059,
	components = {
		{class="GameNode", name="gui",
			children = {
				{class="Sprite", name="back", x=0, y=0, anchor="center"},
				--{class="Sprite", name="bar", x=0, y=0, image="heartbar:minigames"},
				{class="Label", name="goal", x=765, y=40, setup="outline50", roundPos=false, anchor="center"},
				{class="Sprite", name="portrait", x=1210, y=48, clipRect={-999, 0, 9999, 178}, scale=0.9},
				{class="GameNode", name="health", x=1301, y=50},
				{class="Label", name="name", x=1311, y=94, setup="outline30", roundPos=false},
				{class="Label", name="age", x=1311, y=139, setup="outline30", roundPos=false},
				{class="Sprite", name="timebar", x=48, y=128, image="timebar:minigames", children={
					{class="Sprite", name="timebar_fill", image="timebar_fill:minigames"},
				}},

				--{class="Sprite", name="gamebar", x=48, y=128, image="timebar:minigames"},
				--{class="Sprite", name="gamebar_fill", x=48, y=128, image="timebar_fill:minigames"},
			},
		},

		{class="GameNode", name="tutorial", x=0, y=0, visible=false,
			children = {
				{class="Sprite", name="tutorial_bg", x=0, y=0},
				{class="Button", name="tutorial_ok", x=1851, y=1297, anchor="bottomRight", textId="BUTTON_OK", setup="txt_btn"},
			},
		},

		{class="Object", name="resident", x=0, y=0, anchor="top", messageDialogOffset={x=0, y=20}},
		--{class="Label", name="banner", y=500, anchor="center", roundPos=false, setup="outline70", visible=false},
		--{class="Sprite", name="banner_glow", anchor="center", image="heading_glow:minigames", blendMode="additive", scaleX=0, alpha=0, x=894, y=55},
	},
}

-- ************************************ Click Anywhere Minigame ************************************ --
-- "The simplest minigame possible!"

ClickGame = deriveLuaClass("ClickGame", "Sprite")
ClickGame.hearts =
{
	999999,
	888888,
	777777,
}

function ClickGame:onStart()
	self.minigame:onTutorialFinished()
end

function ClickGame:onTouchBegin()
	self.minigame:incMinigameScore(1)
end
