Ultrasound = deriveLuaClass("Ultrasound", "Sprite")

Ultrasound.variations = {
	{
	endDelay = 1000,
	clearImage = "3_months:ultrasound",
	midBlurImage = "3_months_mid_blur:ultrasound",
	maxBlurImage = "3_months_max_blur:ultrasound",
	continue_textId = "MINIGAME_SONOGRAM_ALLISON1",
	won_textId = "MINIGAME_HEARTBEAT_ALLISON3",
	message_text_size = 80,
	maxBlurImage_min = 0.44,								--        0=======================================.49==.51=======================================1
	maxBlurImage_max = 0.56,								--        ===============0.44================0.48===========0.52===0.56==========================
	midBlurImage_min = 0.48,								--        					maxBlurImage_min		midBlurImage_min	midBlurImage_max	maxBlurImage_max
	midBlurImage_max = 0.52,
	clickToContinueTextId = "MINIGAME_TIP_SONOGRAM",
	},
	{
	endDelay = 2000,
	clearImage = "9_months:ultrasound",
	midBlurImage = "9_months_mid_blur:ultrasound",
	maxBlurImage = "9_months_max_blur:ultrasound",
	continue_textId = "MINIGAME_SONOGRAM_ALLISON2",
	won_textId = "MINIGAME_HEARTBEAT_ALLISON3",
	message_text_size = 80,
	maxBlurImage_min = 0.53,								--        0==========================================0.64=======================================1
	maxBlurImage_max = 0.75,								--        ===============0.53================0.63===========0.65============0.75==========
	midBlurImage_min = 0.63,								--        					maxBlurImage_min		midBlurImage_min	midBlurImage_max	maxBlurImage_max
	midBlurImage_max = 0.65,
	clickToContinueTextId = "MINIGAME_TIP_SONOGRAM",
	},
	{
	endDelay = 1000,
	clearImage = "9_months:ultrasound",
	midBlurImage = "9_months_mid_blur:ultrasound",
	maxBlurImage = "9_months_max_blur:ultrasound",
	continue_textId = "MINIGAME_SONOGRAM_ALLISON3",
	won_textId = "MINIGAME_HEARTBEAT_ALLISON3",
	message_text_size = 80,
	maxBlurImage_min = 0.34,								--        0=======================================.49==.51=======================================1
	maxBlurImage_max = 0.46,								--        ===============0.44================0.48===========0.52===0.56==========================
	midBlurImage_min = 0.38,								--        					maxBlurImage_min		midBlurImage_min	midBlurImage_max	maxBlurImage_max
	midBlurImage_max = 0.42,
	clickToContinueTextId = "MINIGAME_TIP_SONOGRAM",
	},
}

function Ultrasound:onShow()
		level:showClickToContinueMinigame(1500,self.clickToContinueTextId)
		self.messageShown = false
		self.soundTimer2 = 0
		self.accuracySound="ultrasound_minigame:sound"
		self.wonSound = "paige_positive_effect_customer:sound"
		self.clickButtonSound = "product_clicked:sound"
		self:prepareMinigameUi()
		self:setImageBlurUpdater()
		self.slider.onMouseLeftUpIn = function()
			messageShown = true
			if(self.greenButton1.alpha == 1) then
				self.slider.enabled=false
				level:hideClickToContinueMinigame()
				self.clearImage.blendMode="additive"
				self:showMessage(self.won_textId)
				SpriteExt.playSample(nil, {self.wonSound})
				self:animate({delay=self.endDelay}, {call=function() self.minigame:gameWon() self.messagePosition:hideMessageDialog(self.dialogDef) end})
			else
				self:showMessage(self.continue_textId)
			end
		end
		self.slider.onMouseLeftDownIn = function()
			if(messageShown == true) then
				self.messagePosition:hideMessageDialog(self.dialogDef)
				SpriteExt.playSample(nil, {self.clickButtonSound})
			end
		end
end

function Ultrasound:addSprite(desc)
	desc = isString(desc) and {image=desc} or desc or {}
	desc.class = desc.class or "Sprite"
	desc.image = desc.image or desc[1]
	return self:newChild(desc)
end

function Ultrasound:onTick(time)
	self:tick(time)
	if(self.screenEffect1.y == -976)then
		self.screenEffect1.y = 562
		self.screenEffect1:animate({y=-976, duration=50000})
	end
	if(self.screenEffect2.y == -976)then
		self.screenEffect2.y = 562
		self.screenEffect2:animate({y=-976, duration=50000})
	end

	if(self.element.value >= self.midBlurImage_min and self.element.value <= self.midBlurImage_max) then
		self.greenButton1.alpha = 1
		self.greenButton2.alpha = 1
		self.greenButton3.alpha = 1
		self.greenButton1.alpha = 1
		self.redButton.alpha = 0
		self.redButton:cancelAnimations()
		self.animRedButton = true
	else
		self.greenButton1.alpha = 0
		self.greenButton2.alpha = 0
		self.greenButton3.alpha = 0
		--self.clearImage.blendMode="blend"

		if(self.animRedButton == true) then
				self.animRedButton = false
				self.redButton:animate({blink={startAlpha=1,endAlpha=00,fadeIn=250,fadeOut=500}})
		end
	end
	if (not self.minigame.finished) then
			local p
			if(self.element.value <= self.midBlurImage_min) then
				p = (self.element.value - 0)/(self.midBlurImage_min-0)
			else
				p = (self.element.value - 1)/(self.midBlurImage_max-1)
			end
			if (self.soundTimer2 > 0) then
				self.soundTimer2 = self.soundTimer2 - time*(1+2*math.scurve(p))
			end

			if (self.soundTimer2 <= 0) then
				SpriteExt.playSample(nil, {self.accuracySound, volume=p*0.8+0.2, pitch=p*0.1+0.95})
				self.soundTimer2 = 1200
			end
		end
end

function Ultrasound:setImageBlurUpdater()
	self.element = self.slider
	self.slider.valueChanged = function()
		if(self.element.value >= 0 and self.element.value <= self.maxBlurImage_min) then
			self.maxBlurImage.alpha = 1 - ((self.element.value - 0) / (self.maxBlurImage_min - 0))
			self.midBlurImage.alpha = 1
		elseif(self.element.value >= self.maxBlurImage_max and self.element.value <= 1) then
				self.maxBlurImage.alpha = (self.element.value - self.maxBlurImage_max) / (1 - self.maxBlurImage_max)
				self.midBlurImage.alpha = 1
		elseif(self.element.value > self.maxBlurImage_min and self.element.value < self.midBlurImage_min) then
				self.midBlurImage.alpha = 1 - (self.element.value - self.maxBlurImage_min) / (self.midBlurImage_min - self.maxBlurImage_min)
				self.maxBlurImage.alpha = 0
		elseif(self.element.value > self.midBlurImage_max and self.element.value < self.maxBlurImage_max) then
				self.midBlurImage.alpha = (self.element.value - self.midBlurImage_max) / (self.maxBlurImage_max - self.midBlurImage_max)
				self.maxBlurImage.alpha = 0
		end
	end
end

function Ultrasound:showMessage(messageId)
	 self.dialogDef = {
		class="BalloonDialog",
		owner = self,
		dialogId = "TUTORIAL_QUESTION",
		anchor = "top",
		bottomPadding = 24,
		textId = messageId,
		customTip = "balloon_pointer_left",
		--tipSide = "right",
		maxLineCount = 4,
		restrictScreenPosition = "",
		doPopIn = true,
		doPopOut = true,
		children = "",
		offset = toPoint(0),
		onTaskSkip = "",
		contentOffsetY = 20,
		msgType = "message",
		needsClick = false,
		showAnimation = "popin",
		sidePadding = 20,
		tipType = "balloon_pointer_left",
		topPadding = 20,
		bubbleLayer = "dialog",
		textSize = self.message_text_size,
	}
	self.messagePosition:showMessageDialog(self.dialogDef)
end

function Ultrasound:prepareMinigameUi(time)
	self.minigame.back.image = "background:ultrasound"
	self.animRedButton = true
	self.computerBack = self:addSprite({"monitor-off:ultrasound", x=0, y=-170, anchor="center"})
	self.clearImage = self:addSprite({self.clearImage, x=0, y=-170, anchor="center"})
	self.midBlurImage = self:addSprite({self.midBlurImage, x=0, y=-170, anchor="center"})
	self.maxBlurImage = self:addSprite({self.maxBlurImage, x=0, y=-170, anchor="center"})
	self.screenEffect1 =self:addSprite({"screen-fx:ultrasound", x=0, y=-213, anchor="center"})
	self.screenEffect2 =self:addSprite({"screen-fx:ultrasound", x=0, y=562, anchor="center"})
	self.computer = self:addSprite({"computer:ultrasound", x=-47, y=-17, anchor="center",})
	self.light1 = self.computer:addChild(self:addSprite({"light:ultrasound", x=-526, y=-482, anchor="center"}))
	self.light2 = self.computer:addChild(self:addSprite({"light:ultrasound", x=526, y=-482, anchor="center"}))
	self.light1_glow = self.computer:addChild(self:addSprite({"light:ultrasound", x=-526, y=-482, anchor="center"}))
	self.light2_glow = self.computer:addChild(self:addSprite({"light:ultrasound", x=526, y=-482, anchor="center"}))
	self.light3 = self.computer:addChild(self:addSprite({"light:ultrasound", x=-426, y=-354, anchor="center", scale = 0.7, alpha = 0.8}))
	self.light4 = self.computer:addChild(self:addSprite({"light:ultrasound", x=412, y=-354, anchor="center", scale = 0.7, alpha = 0.8}))
	self.greenButton1 = self.computer:addChild(self:addSprite({"green_button:ultrasound", x=730, y=344.3, anchor="center", alpha = 0}))
	self.greenButton2 = self.computer:addChild(self:addSprite({"green_button:ultrasound", x=682.3, y=344.3, anchor="center", alpha = 0}))
	self.greenButton3 = self.computer:addChild(self:addSprite({"green_button:ultrasound", x=638 , y=344.3, anchor="center", alpha = 0}))
	self.redButton = self.computer:addChild(self:addSprite({"red_button:ultrasound", x=682.3, y=344.3, anchor="center"}))
	self.slider = self.computer:addChild({ class="Slider", name="slider_ultrasound", image="slider:ultrasound", x=22, y=568, anchor="center", minX=-556, maxX=556,
		button = { class="Button", name="slider_button",x=0,  y=-31, image="slider_button:ultrasound", anchor="center" },
	})

	self.messagePosition = self:addChild(self:addSprite({ class="Object", name="messagePosition",x=-821,  y=-194, baseAnimation="chair_dummy:gamescene", anchor="center" }))


	--Animations
	self.screenEffect1:animate({blink={startAlpha=1,endAlpha=0.55,fadeIn=500,fadeOut=500}})
	self.screenEffect2:animate({blink={startAlpha=1,endAlpha=0.55,fadeIn=500,fadeOut=500}})
	self.light1_glow:animate({blink={startAlpha=0.5,endAlpha=0,fadeIn=100,fadeOut=100}})
	self.light2_glow:animate({blink={startAlpha=0.5,endAlpha=0,fadeIn=100,fadeOut=100}})
	self.screenEffect1:animate({y=-976, duration=25000})
	self.screenEffect2:animate({y=-976, duration=50000})
	self.screenEffect1.clipRect={x=(self.screenEffect1.x - self.screenEffect1.anchor.x), y=(self.screenEffect1.y - self.screenEffect1.anchor.y + 25), width=self.screenEffect1.width, height=self.screenEffect1.height +75}
	self.screenEffect2.clipRect={x=(self.screenEffect1.x - self.screenEffect1.anchor.x), y=(self.screenEffect1.y - self.screenEffect1.anchor.y + 25), width=self.screenEffect1.width, height=self.screenEffect1.height +75}

  --Message Dialog
	-- self.message = self.computer:addChild({ class="Sprite", name="minigame_message", x=-1040, y=-242 ,image="item-popup:shop",anchor="bottomLeft", scale=0, children={
	-- 	{class="Label", name="text", anchor="center", align="center", setup=setups.txt, textSize=80, x=382, y=-197, roundPos=false, maxWidth=780, maxHeight=270, wrapStyle="word",}}})
	-- self.message.visible = false
end
