AnimatedObject = deriveLuaClass("AnimatedObject", "Object")

degToRadians = 0.0174532925

function AnimatedObject:init(desc)
    AnimatedObject.superInit(self, desc)

	self.startRot = desc.startRot or 0
	self.endRot = desc.endRot or 0
	self.rotationDuration = desc.rotationDuration or 0
	self.horizontalAmplitude = desc.horizontalAmplitude or 0
	self.horizontalDuration = desc.horizontalDuration or 0
	self.verticalAmplitude = desc.verticalAmplitude or 0
	self.verticalDuration = desc.verticalDuration or 0

	if self.horizontalDuration ~= 0 then
		self:animate({duration = self.horizontalDuration, wave = {x = self.x, amplitude = self.horizontalAmplitude, loops=-1}})
	end

	if self.verticalDuration ~= 0 then
		self:animate({duration = self.verticalDuration, wave = {y = self.y, amplitude = self.verticalAmplitude, loops=-1}})
	end

	if self.rotationDuration ~= 0 then
		self:animate({duration = self.rotationDuration, style = "easeInOut", wobble = {startRot = self.startRot * degToRadians, endRot = self.endRot * degToRadians}})
	end
end
