-- ************************* Bed Station **************************** --

Bed = getClass("Bed")

function Bed:init(desc)
    Bed.superInit(self, desc)

    self.maySwitchFromDirtyTable = false
    self.fakeCustomerName = desc.fakeCustomerName
    self.dirtyBusyImage = desc.dirtyBusyImage or "exclamation"

    if (self.frameCount > 1) then
        self.frame = 1 --folded table
     end
end

function Bed:onLevelInitialized()
	self.super.onLevelInitialized(self)
    if(self.fakeCustomerName) then
        self.fakeCustomer = level:getSpriteExt(self.fakeCustomerName)
        --if (not self.fakeCustomer.chair) then
        --    local chair = self:getChair(1)
            --self.fakeCustomer:sitAtChair(chair)
        --end
    end
end

function Bed:onWorkStart(task)
    self.super.onWorkStart(self, task)
    if (self.group and
        (self.group.state == "AskCleanToPay" or self.group.stat == "AskCleanToOrder") ) then
        self.group:doCleaningAppearance()
    end
end

function Bed:onWorkFinish(task)
    self.super.onWorkFinish(self, task)
    if (self.group and self.group.state == "AskCleanToPay") then
        self.group:handleCustomerPay()
        self.group.state = "Leaving"
    elseif (self.group and self.group.state == "AskCleanToOrder") then
        self.group.state = "Thinking"
    end
end

function Bed:onTableStateChanged()
    self.super.onTableStateChanged(self)
    if (self.frameCount > 1) then
        if (self.plateState == "occupied" or self.plateState == "dirty" or self.plateState == "busy") then
            self.frame = 0 --unfolded table
        elseif (self.plateState == "empty") then
            self.frame = 1 --folded table
        end
    end
end
