-- ************************************ Cash Register ************************************ --
CashRegister = deriveLuaClass("CashRegister", "Object")

CashRegister.state = "idle"
CashRegister.working = true
CashRegister.processCustomer = false
CashRegister.delay = 0
CashRegister.combos = 0
CashRegister.doCombo = false;
CashRegister.tm = 500;
--CashRegister.myCounter

function CashRegister:init(desc)
	CashRegister.superInit(self, desc)
	self.clickable = true

end

function CashRegister:onLevelInitialized()
	CashRegister.super.onLevelInitialized(self)

	self.counters = self.counters or {}
	for i=1,10 do
		local counter = self["counter"..i]
		if (counter) then
			counter = level:getObject(counter)
		end
		if (counter) then
			table.push_back(self.counters, counter)
		end
	end
end

function CashRegister:getCounters()
	if (table.empty(self.counters)) then
		return level.counters
	end
	return self.counters
end

function CashRegister:onClick()
	if(CashRegister.working == false) then
	return false;
	end
	self:addTask({class="WorkTask", target=self})
	CashRegister.super.onClick(self)
	self:playSample("money_cash_register_customer")
--	self:addTask({class="WorkTask", target=self})				
--self:addTask({class="PlayAnimationTask", animation= "register_use", cycles=100, frameTime=100, playDefaultOnFinish=true})
--self:playAnimation("register_use", 10, 100)
self:addTask({class = "PlayAnimationTask",
                animation = "use",
                cycles = 6,
                onFinishedCallback = function() self:Done(someParameter) end})
	return true
end

function CashRegister:PlayNewAnimation(animName)
--taskSystem:cancelAllTasksFor(self)
--self.workAnimation = "use"
--self:addTask({class="WorkTask", target=self})				
--self:addTask({class="PlayAnimationTask", animation= animName, cycles=100, frameTime=100, playDefaultOnFinish=true})
--self:playAnimation(animName, 10)
--print(animName + "--------------------------------------------cashregister")
self:addTask({class = "PlayAnimationTask",
                animation = animName,
                cycles = 6,
                onFinishedCallback = function() self:Done(someParameter) end})
				
				
end
function CashRegister:Done(someParameter)
  -- Whatever logic you need...

end

function CashRegister:onTick(Time)
	--self.state = "idle"
	if (level and level.challengeManager) then
	--	if(level.challengeManager:CounterState() ~= "" and self.tm > 0) then
		--		print("cahregister timp !!!!!!!!!!!!!!!   ")
		--print (self.tm)
			--self.state = level.challengeManager:CounterState();
			--end
		--	if(self.lastState ~= self.state and self.state ~= "idle" ) then
				--self:stop()				
			--	self:playAnimation(self.state, -1)
			--	self:animate({startFrame=0, frameTime=150,loops=1})
		--		self.processCustomer = false
	--		end
--		end
	end

	if(self.processCustomer == false) then

	if(self.myCounter) then
		if(self.myCounter.hasCustomers == true) then
		
			if(self.state == "idle") then
			--	print("players waiting on que")
				self.state = "ask"
				--self:stopLoopSample("money_cash_register_end")
				self:playAnimation("signal", 10)
				--self:playSample("checkout_request")
				self:animate({{startFrame=0, frameTime=80}, {frame=0}})
				--self.PlayNewAnimation("use")
			self.clickable = true
			end
		else
		if(self.state == "ask") then
		--	print("no players waiting on que")
				self.state = "idle"
				--self:stopLoopSample("money_cash_register_end")
		--		self.PlayNewAnimation("register")
			self.clickable = true
			end
		end
	else
		self.myCounter = level:getObject("counter")
		if(self.state ~= "wake") then
			self.state = "idle"
		end
	end

	if(self.state == "idle" and self.lastState ~= self.state) then
		self:playAnimation("register", 10)
		--self:stopLoopSample("money_cash_register_end")
		self:animate({{startFrame=0, frameTime=80}, {frame=0}})
end
end
self.lastState = self.state;

  if(self.processCustomer and self.state ~= "sleep") then

	-- Customer pay time 
	if(self.delay >=1200) then
		local counters = self:getCounters()
		
			self.processCustomer = false
		for _,v in ipairs(counters) do
			local characters = v.queue.characters
			if(#characters > 0) then
			--	self:loopSample("money_cash_register_end")
				self:playAnimation("use", 30)
				self:animate({{startFrame=0, frameTime=50}, {frame=0}})
				self:NextCustomer()
			else
				
				doCombo = true;
			end
			
			doCombo = true;

		self.delay = 0
		end
	else
		self.delay = self.delay + Time
	end
  else

	if(doCombo) then
		self:ComboScore()
		doCombo = false
	end
  end


end

function CashRegister:ComboScore()

	print(self.combos);
	local comboScore = 0
	if (self.combos > 1) then
		comboScore = self.combos;
		if(self.combos >5 ) then
		comboScore = 5
		end
		if (self.combos >= 3) then
			if (level.BM_incCombo3Person) then
				level:BM_incCombo3Person()
			end
			if (player.gameStats.incComboCheckoutChain) then
				player.gameStats:incComboCheckoutChain()
			end
		else
			if (player.gameStats.resetComboCheckoutChain) then
				player.gameStats:resetComboCheckoutChain()
			end
			if (self.combos == 2) then
				if (level.BM_incCombo2Person) then
					level:BM_incCombo2Person()
				end
			end
		end
	end

	if (doSound) then
		self:animate({{startFrame=0, frameTime=80}, {frame=0}})
	end
	level:onCashRegisterEnd(self, customerGroups, comboScore)

end

function CashRegister:onWorkStart(task)
	found = false
	
	CashRegister.super.onWorkStart(self, task)
	local counters = self:getCounters()
	for _,v in ipairs(counters) do
		local characters = v.queue.characters
		for _,c in ipairs(characters) do
			if (c.group.state == "Paying") then
				hints:successfulSequence("checkout customers")
				--self:loopSample("money_cash_register_end")
				self:playAnimation("use", 30)
				
				return true
			end
		end
	end
	return false
end

function CashRegister:NextCustomer()

	local payDelay = 300
	level:onCashRegisterStart(self)
	local doSound = false
	local counters = self:getCounters()
	local customerGroups = {}
	for _,v in ipairs(counters) do
		v:setBagsInactive()

		local characters = v.queue.characters
		for idx,c in ipairs(characters) do
			if (c.group.state == "InQueueAtCounter") then
				--local delay = (idx-1) * payDelay
				c.group:handleCustomerPay(0)
				table.push_back(customerGroups, c.group)
				self.combos = self.combos + 1
				self.processCustomer = true
				return
			end
		end
		doSound = true
		
	end
	
end

function CashRegister:onWorkFinish(task)
	CashRegister.super.onWorkFinish(self, task)

	level:onCashRegisterStart(self)
	self.combos = 0
	local payDelay = 300

	local doSound = false
	local counters = self:getCounters()
	local customerGroups = {}
	for _,v in ipairs(counters) do
		v:setBagsInactive()

		local characters = v.queue.characters
		for idx,c in ipairs(characters) do
			if (c.group.state == "Paying") then
				--local delay = (idx-1) * payDelay
				self:playAnimation("use", 30)
				self:animate({{startFrame=0, frameTime=50}, {frame=0}})
				c.group:handleCustomerPay(0)
				table.push_back(customerGroups, c.group)
				self.combos = self.combos + 1
				self.processCustomer = true
				return

			end
		end
		doSound = true
	end
	--level:onCashRegisterEnd(self, customerGroups, 0)
end
