dofile("script/objects/Cooker.lua")

CiderPress = deriveLuaClass("CiderPress", "Cooker")

-- TODO: change the hard coded values of the parameters in init

function CiderPress:init(desc)
    CiderPress.superInit(self, desc)

    self.yDisplacement = desc.yDisplacement or 50
    self.speedY = desc.speedY or 2

    self.topY = self.y
    self.bottomY = self.y + self.yDisplacement

    self.STOPPED = 0
    self.ANIMATING = 1
    self.RETURN = 2
    self.animationState = self.STOPPED
end

function CiderPress:status_onStartPreparing(ing)
	self:movePress()
end

function CiderPress:status_onBecomeAvailable(ing)
    self:returnPress()
end

function CiderPress:movePress()
    self.animationState = self.ANIMATING
end

function CiderPress:returnPress()
    self.animationState = self.RETURN
end

function CiderPress:stopPress()
    self.animationState = self.STOPPED
end

function CiderPress:onTick(time)
    self:tick(time)

    if (self.animationState == self.ANIMATING) then
        self.y = self.y + self.speedY
        if (self.y < self.topY) then
            self.y = self.topY
            self.speedY = -self.speedY
        elseif (self.y > self.bottomY) then
            self.y = self.bottomY
            self.speedY = -self.speedY
        end
    elseif (self.animationState == self.RETURN) then
        self.y = self.y + self.speedY
        if (self.y < self.topY) then
            self.y = self.topY
            self.speedY = -self.speedY
            self:stopPress()
        elseif (self.y > self.bottomY) then
            self.y = self.bottomY
            self.speedY = -self.speedY
        end
    end
end
