-- ************************************ Extra Customer upgrade_bbq ************************************ --
ExtraCustomer = deriveLuaClass("ExtraCustomer", "Object")

--Usage Example
levelDesc = levelDesc or {}
function levelDesc:onLevelEnd()
  if(levelDesc.values["extraCustomer"]) then
    extraCustomer = level:getObject("ExtraCustomerUpgrade")
    extraCustomer.spawnExtraCustomer()
  end
end


function ExtraCustomer:init(desc)
  ExtraCustomer.superInit(self, desc)

  --Configuration Variables-------------------------------------
  self.customerPlace = desc.customerPlace or "counter"
  self.customerTrait = desc.customerTrait or "normal_snu"
  self.customerGender = desc.customerGender or "male"
  self.customerOrderSize = desc.customerOrderSize or 1
  self.customerSize = desc.customerSize or 1
  self.customerDelay = desc.customerDelay or 3000

  --Internal variables------------------------------------------
  delayCounter = 0
  readyToSpawnCustomer = false

end

function ExtraCustomer:spawnExtraCustomer()

  readyToSpawnCustomer = true
end


function ExtraCustomer:spawnExtraCustomerAfterDelay()

  if(levelDesc.values["extraCustomer"]) then
    level:fireTrigger("spawn",
    {
      place = self.customerPlace,
      customers = {{traits=self.customerTrait, gender=self.customerGender}},
      orderSize = self.customerOrderSize,
      --size = self.customerSize,
    })
  end

end

function ExtraCustomer:onTick(time)
  self:tick(time)
  if(readyToSpawnCustomer) then
    delayCounter = delayCounter + time
    if(delayCounter >= 3000) then
      readyToSpawnCustomer = false
      self:spawnExtraCustomerAfterDelay()
    end
  end
end
