FadingLight = deriveLuaClass("FadingLight", "Object")


function FadingLight:init(desc)
    FadingLight.superInit(self, desc)

	self.maxAlpha = desc.maxAlpha or 0.8
	self.minAlpha = desc.minAlpha or 0
	self.fadingSpeed = desc.fadingSpeed or 0.002
	self.sineWaveTime = desc.startingTime or 0

	self.minDelayBetweenFades =  desc.minDelayBetweenFades or 3000
	self.maxDelayBetweenFades =  desc.maxDelayBetweenFades or 6000

	self.fadeAmplitude = self.maxAlpha - self.minAlpha
	self.remainingDelay = 0
	self.previousAlphaValue = -1
	self.isAlphaIncreasing = true
end

function FadingLight:onTick(time)
	self:tick(time)

	if self.remainingDelay < 0 then
		self.sineWaveTime = self.sineWaveTime + (time * self.fadingSpeed)
		self.alpha = self.minAlpha + (((math.sin(self.sineWaveTime) + 1) * 0.5) * self.fadeAmplitude)

		-- In case of reaching the minimum or the maximum sine value, a delay will be applied
		if self.isAlphaIncreasing ~= (self.alpha > self.previousAlphaValue) then
			self.isAlphaIncreasing = not self.isAlphaIncreasing
			self.remainingDelay = math.Random(self.minDelayBetweenFades, self.maxDelayBetweenFades)
		end
		self.previousAlphaValue = self.alpha

	else 
		self.remainingDelay = self.remainingDelay - time
	end
end