OnRailsObject = getClass("OnRailsObject")

function OnRailsObject:init(desc)
  OnRailsObject.superInit(self, desc)
  self.desc = desc
  self.levelFinishChecked = false
  self.startAtHome = desc.startAtHome or false
end

function OnRailsObject:onPreInitializeLevel()
  self:PrepareWaypoints()
  self:start()
  if(self.startAtHome == true) then
    self:startAtHomeCall()
  end
end

function OnRailsObject:onLevelInitialized()
  OnRailsObject.super.onLevelInitialized(self)
end

function OnRailsObject:onTick(time)
  self:tick(time)
end

function OnRailsObject:PrepareWaypoints()
  local waypoints = {}
  for i = 1, 100 do
    local wpt = self.desc["waypoint#" .. i]
    if wpt and wpt ~= "" then
      table.insert(waypoints, wpt)
    end
  end

  self:setupPathWaypoints(waypoints)
  self:setupWaypointTransitions()
end
