--OnRailsObjectSelector = deriveLuaClass("OnRailsObjectSelector", "Object")
OnRailsObjectSelector = getClass("OnRailsObjectSelector")

function OnRailsObjectSelector:init(desc)
  OnRailsObjectSelector.superInit(self, desc)
  self.desc = desc
  self.objects = {}
  self.currentObject = nil
  self.random = desc.random or false
  self.minSpawnTime = desc.minSpawnTime or 2000
  self.maxSpawnTime = desc.maxSpawnTime or 2000
  self.maxEnabledObjects = desc.maxEnabledObjects or 0
end

-- function OnRailsObjectSelector:onPreInitializeLevel()
-- end

function OnRailsObjectSelector:onLevelInitialized()
  OnRailsObjectSelector.super.onLevelInitialized(self)
  self:PrepareObjects()
  self:setupSpawnTime()
end

function OnRailsObjectSelector:onTick(time)
  self:tick(time)
end

function OnRailsObjectSelector:getRandomObject()
  if(self.objects) then
    self.currentObject = self.objects[math.Random(1, self.objects.size)]
    return self.currentObject
  else return ""
  end
end

function OnRailsObjectSelector:PrepareObjects()
  for i = 1, 15 do
    local obj = self.desc["object" .. i]
    if obj and obj ~= "" then
      local objInstance = level:getObject(obj)
      if objInstance then
        table.insert(self.objects, obj)
        objInstance:setOnRailsObjectEnabled(false)
      end
    end
  end
  self:setupObjectsList(self.objects)
  --He we should choose the first onrails object calling a cpp function (remember to check the restock stock before chooseing it)
  --self:setupPathWaypoints(self.objects)
  --self:setupWaypointTransitions()
end
