OnRailsWaypoint = deriveLuaClass("OnRailsWaypoint", "SpriteExt")

function OnRailsWaypoint:init(desc)
  OnRailsWaypoint.superInit(self, desc)

  self.waypointEnabled = desc.waypointEnabled or false
  self.floor = desc.floor or 9999

  self.idleMinDuration = desc.idleMinDuration or 2000
  self.idleMaxDuration = desc.idleMaxDuration or 5000

  self.idleAnimationSection = desc.idleAnimationSection or ""
  self.idleAnimationResource = desc.idleAnimationResource or ""
  self.idleAnimationStartFrame = desc.idleAnimationStartFrame or -1
  self.idleAnimationEndFrame = desc.idleAnimationEndFrame or -1
  self.idleAnimationCycles = desc.idleAnimationCycles or -1
  self.idleAnimationPlayback = desc.idleAnimationPlayback or "Default"
  self.idleAnimationPlayback = desc.idleAnimationFrameTime or 100
  self.idleAnimationFrozenFrames = desc.idleAnimationFrozenFrames or nil

  self.startAnimationName = desc.startAnimationName or ""
  self.startAnimationWaitTime = desc.startAnimationWaitTime or 1000
  self.startAnimationCycles = desc.startAnimationCycles or 1
  self.startAnimationFrameTime = desc.startAnimationFrameTime or -1

  self.waypointType = desc.waypointType or "default"
  self.actionObject = desc.actionObject or ""

  self.autoFlipMode = desc.autoFlipMode or "Disabled"
  self.autoFlipDelay = desc.autoFlipDelay or 1000
  self.autoFlipRandomness = desc.autoFlipRandomness or 30

  self.originalPosX = self.x
  self.originalPosY = self.y

  if self.idleMinDuration < 0 then self.idleMinDuration = 0 end
  if self.idleMaxDuration < 0 then self.idleMaxDuration = 0 end

  if self.idleMinDuration > self.idleMaxDuration then
    self.idleMinDuration = self.idleMaxDuration
  end

  if self.autoFlipDelay < 0 then autoFlipDelay = 0 end
  if self.idleMaxDuration == 0 then self.autoflipMode = "Disabled" end
  if self.autoFlipDelay == 0 then self.autoFlipMode = "Disabled" end
  if self.autoFlipDelay >= self.idleMaxDuration and
    self.autoflipMode ~= "Disabled" then
    self.autoflipMode = "Disabled"
  end

  if self.autoFlipRandomness < 0 then self.autoFlipRandomness = 0
  elseif self.autoFlipRandomness > 100 then self.autoFlipRandomness = 100
  end
end

function OnRailsWaypoint:onLevelInitialized()
  OnRailsWaypoint.super.onLevelInitialized(self)
  --//
end

function OnRailsWaypoint:onTick(time)
  self:tick(time)
  --//
end

function OnRailsWaypoint:GetPosition()
  return {x=self.x, y=self.y}
end

function OnRailsWaypoint:ResetOriginalPosition()
  self.x = self.originalPosX
  self.y = self.originalPosY
end
