PortionIngredient = deriveLuaClass("PortionIngredient", "IngredientButton")

function PortionIngredient:init(desc)
	PortionIngredient.superInit(self, desc)
	
	self.ingredients = {}
	self.old_isDown = false
	self.selectedCount = 0
end

function PortionIngredient:onLevelInitialized()
	PortionIngredient.super.onLevelInitialized(self)
	for i=1, 20 do
		local ingName = self["ingredients"..i]
		if (ingName) then
			table.push_back(self.ingredients, level:getObject(ingName))
			assert(self.ingredients[i], "ingredient does not exist: "..ingName)
		end
	end
end

function PortionIngredient:onTick(time)
	self:tick(time)

	local selected = not self.highlighted and not self.isDown and self.highlightTargetAlpha > 0
	if (self.old_selected ~= selected) then
		self.old_selected = selected
		
		for _,v in ipairs(self.ingredients) do
			if (selected == true) then
				v.selectedCount = v.selectedCount + 1
			else
				v.selectedCount = v.selectedCount - 1
				v.selectedCount = math.max(0, v.selectedCount)
			end
			v.selected = v.selectedCount > 0
		end

	else
		local down = self.isDown
		if (self.old_isDown ~= down) then
			self.old_isDown = down

			for _,v in ipairs(self.ingredients) do
				v.isDown = down
			end

			if (not down) then
				local p = GH.getMouseCursorPos()
				for _,v in ipairs(self.ingredients) do
					if (v:isInside(p.x, p.y)) then
						v.isDown = true
						v.old_isDown = false
						v:onTick(0)
						break
					end
				end
			end
		else
			local highlighted = self.highlighted
			for _,v in ipairs(self.ingredients) do
				v.highlighted = highlighted
				local mag = v.magnifyTooltipSprite
				if (mag) then mag.alpha = 0 end
			end

			if (not highlighted) then
				for _,v in ipairs(self.ingredients) do
					if (level and level.mouseOverObject and level.mouseOverObject.name == v.name) then
						v.highlighted = true
						local mag = v.magnifyTooltipSprite
						if (mag) then mag.alpha = 1 end
						v:onTick(0)
						break
					end
				end
			end	
		end
	end
end

--[[
	local isOver = (level and level.mouseOverObject == self)
	if (self.old_isOver ~= isOver) then
		self.old_isOver = isOver
		
		if (isOver) then
			self.isOverCount = self.isOverCount + 1
			for _,v in ipairs(self.ingredients) do
				v.isOverCount = v.isOverCount + 1
			end
		else
			self.isOverCount = math.max(0, self.isOverCount - 1)
			for _,v in ipairs(self.ingredients) do
				v.isOverCount = math.max(0, v.isOverCount - 1)
			end
		end
		for _,v in ipairs(self.ingredients) do
			v.highlighted = (v.isOverCount > 0)
		end
	end

	local isDown = self.isDown and isOver
	if (self.old_isDown ~= isDown) then
		self.old_isDown = isDown
		
		if (isDown) then
			self.isDownCount = self.isDownCount + 1
			for _,v in ipairs(self.ingredients) do
				v.isDownCount = v.isDownCount + 1
			end
		else
			self.isDownCount = math.max(0, self.isDownCount - 1)
			for _,v in ipairs(self.ingredients) do
				v.isDownCount = math.max(0, v.isDownCount - 1)
			end
		end
		for _,v in ipairs(self.ingredients) do
			v.isDown = (v.isDownCount > 0)
		end
	end

	if (not isDown and v.isDownCount <= 0) then
		self.highlighted = (self.isOverCount > 0)
	end
--]]
