Roulette = deriveLuaClass("Roulette", "Object")

function Roulette:init(desc)
	Roulette.superInit(self, desc)
	--print("Roulette:init")
	self.speed = desc.speed or 5 --degrees per second
	self.slowDownSeconds = desc.slowDownSeconds or 1
	self.totalTime = 0
	self.startSlowingTime = 0
end


function Roulette:onLevelInitialized()
	Roulette.super.onLevelInitialized(self)

	self.state = "rotating"
	--print("Roulette:onLevelInitialized")
end

function Roulette:onTick(time)
	self:tick(time)
	self.totalTime = self.totalTime + time

	local timeInSeconds = time/1000

	if (self.state == "stopped") then

	elseif (self.state == "rotating") then
		self.rotation = (self.rotation + (self.speed * timeInSeconds) ) % 360
	elseif (self.state == "slowing") then
		if (self.startSlowingTime + self.slowDownSeconds >=  self.totalTime) then
			self.state = "stopped"
		else
			-- speed ............. 0
			-- [..slowDownSeconds..]
			-- speed - (speed / slowDownSeconds) * (self.totalTime - self.startSlowingTime)

			local currentSpeed = (self.speed / self.slowDownSeconds) * (self.totalTime - self.startSlowingTime)
			self.rotation = self.rotation + (currentSpeed * timeInSeconds)
		end
	end
end

function Roulette:onClick()
	--print("slowing")
	self.state = "slowing"
	self.startSlowingTime = self.totalTime
end
