SoundEmitter = deriveLuaClass("SoundEmitter", "Object")

function SoundEmitter:init(desc)
    SoundEmitter.superInit(self, desc)

	self.soundToPlay = desc.soundToPlay
	self.continuousLoop = desc.continuousLoop or false
	self.minDelay = desc.minDelay or 0
	self.maxDelay = desc.maxDelay or 10000
	self.minVolume = desc.minVolume or 1
	self.maxVolume = desc.maxVolume or 1

	self.timeUntilNextSound = 0

	if self.soundToPlay then
		if self.continuousLoop then
			self:loopSample(self.soundToPlay, math.Random(self.minVolume, self.maxVolume))
		else
			self.timeUntilNextSound = math.Random(self.minDelay, self.maxDelay)
		end
	end
end

function SoundEmitter:onTick(time)
	self:tick(time)

	if not self.continuousLoop then
		self.timeUntilNextSound = self.timeUntilNextSound - time
	  	if self.timeUntilNextSound < 0 then
			self:playSample(self.soundToPlay, math.Random(self.minVolume, self.maxVolume))
			self.timeUntilNextSound = math.Random(self.minDelay, self.maxDelay)
	  	end
	end
end