-- ******************************* SpecialStationDragButton ********************************** --

SpecialStationDragButton = deriveLuaClass("SpecialStationDragButton", "Object")

function SpecialStationDragButton:init(desc)
    SpecialStationDragButton.superInit(self, desc)
    self.clickable = true
    self.name = "DragButton"
end

function SpecialStationDragButton:setDrag(drag)
    self.drag = drag
    -- self.circleSprite = self:newChild({class="Sprite", image="drag_button:special_stations", anchor="center"})
end

function SpecialStationDragButton:setSounds(pressedSound, releasedSound)
    self.pressedSound = pressedSound
    self.releasedSound = releasedSound
end

function SpecialStationDragButton:rotateArrow(direction)
    if (self.drag) then
        if (direction == self.drag.DIRECTION_UP) then
            self.rotation = 270
        elseif (direction == self.drag.DIRECTION_UP_RIGHT) then
            self.rotation = 315
        elseif (direction == self.drag.DIRECTION_RIGHT) then
            self.rotation = 0
        elseif (direction == self.drag.DIRECTION_DOWN_RIGHT) then
            self.rotation = 45
        elseif (direction == self.drag.DIRECTION_DOWN) then
            self.rotation = 90
        elseif (direction == self.drag.DIRECTION_DOWN_LEFT) then
            self.rotation = 135
        elseif (direction == self.drag.DIRECTION_LEFT) then
            self.rotation = 180
        elseif (direction == self.drag.DIRECTION_UP_LEFT) then
            self.rotation = 225
        end
    end
end

function SpecialStationDragButton:setInactiveGraphics()
    if (self.dragLabel) then
        self.dragLabel.alpha = 0
    end
    self.image = "range_button_disabled:special_stations"
end

function SpecialStationDragButton:setActiveGraphics()
    if (self.drag and self.dragLabel) then
        self.dragLabel:animate({alpha=1, duration=self.drag.appearAlphaDuration})
    end
    self.image = "drag_button:special_stations"
end

function SpecialStationDragButton:onClick()
    -- This onClick function is necessary to overwrite the default behaviour of
    -- onClick
end

function SpecialStationDragButton:onMouseDown()
    if (self.drag) then
        SpecialStationDrag.super.onMouseDown(self.drag)
        if (self.drag.actualState ~= self.drag.STATE_APPEARING and self.drag.actualState ~= self.drag.STATE_STOP) then
            if (not self.isInStory) then
                level.draggingObject = true
            end
            self.drag.actualState = self.drag.STATE_MOUSE_DOWN
            self.drag:hideHintAnimation()
            self.drag:hideHighlight(false)
            self.drag:playActiveAnimations()
        end
        if (self.dragLabel) then
            if (self.dragLabel.alpha == 1) then
                self.dragLabel:animate({alpha=0, duration=self.drag.appearAlphaDuration})
            end
        end
    end
    self:buttonPressed()
end

function SpecialStationDragButton:buttonPressed()
    self.scaleX = 1.2
    self.scaleY = 1.2
    if (self.pressedSound) then
        self:playSample(self.pressedSound)
    end
end

function SpecialStationDragButton:buttonReleased()
    self.scaleX = 1
    self.scaleY = 1
    if (self.releasedSound) then
        self:playSample(self.releasedSound)
    end
end
