------------------------------------------------
-- InteractiveObjects for Special stations    --
------------------------------------------------
SpecialStationInteractiveObject = deriveLuaClass("SpecialStationInteractiveObject", "Object")

function SpecialStationInteractiveObject:init(desc)
    SpecialStationInteractiveObject.superInit(self, desc)
end

-- Custom events
function SpecialStationInteractiveObject:gestureComplete()
end


function SpecialStationInteractiveObject:stationComplete()
end

function SpecialStationInteractiveObject:reset()
end


------------------------------------
-- InteractivePhotocall for R4    --
------------------------------------
InteractivePhotocall = deriveLuaClass("InteractivePhotocall", "SpecialStationInteractiveObject")
function InteractivePhotocall:init(desc)
    self.startPositionY = self.y
    self.transitionTime = 1000
    self.transitionAmount = 285
end

function InteractivePhotocall:gestureComplete()
	self:reset()

	self:addTask({class = "PositionTask",
		position = {x = self.x, y = self.y + self.transitionAmount},
		duration = self.transitionTime,
		ease = "easeInOut",
	})
end

function InteractivePhotocall:stationComplete()
	self:addTask({class = "PositionTask",
		position = {x = self.x, y = self.startPositionY},
		duration = self.transitionTime,
		ease = "easeInOut",
	})
end

function InteractivePhotocall:reset()
	self.y = self.startPositionY
end
