dofile("script/objects/StatusObject.lua")

-- ************************************ Status Timer ************************************ --
CookerTimer = deriveLuaClass("CookerTimer", "StatusObject")

function CookerTimer:statusUpdate(status, init, ing)
	CookerTimer.super.statusUpdate(self, status, init, ing)
	if (status == "inactive") then
		self.rotation = 0
	end
end

function CookerTimer:status_onUpdateStatusFraction(ing, frac)
	local totalFrac = 0
	if (self.curStatus == "prepare") then
		totalFrac = frac/3
	elseif (self.curStatus == "ready") then
		totalFrac = 1/3 + frac/3
	elseif (self.curStatus == "decay") then
		totalFrac = 2/3 + frac/3
	end
	self.rotation = 360 * totalFrac
end

-- ************************************ Fueled Timer ************************************ --
FueledTimer = deriveLuaClass("FueledTimer", "StatusObject")

function FueledTimer:statusUpdate(status, init, ing)
	FueledTimer.super.statusUpdate(self, status, init, ing)
	if (status == "inactive") then
		self.rotation = 0
	end
end

function FueledTimer:status_onUpdateStatusFraction(ing, frac)
	local totalFrac = 0
	if (self.curStatus == "prepare") then
		totalFrac = frac/3
	elseif (self.curStatus == "ready") then
		totalFrac = 1/3 + 2*frac/3
	end
	self.rotation = 360 * totalFrac
end

-- ************************************ Normal Timer ************************************ --
NormalTimer = deriveLuaClass("NormalTimer", "StatusObject")

function NormalTimer:statusUpdate(status, init, ing)
	print("bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb")
	print("status"..status)
	NormalTimer.super.statusUpdate(self, status, init, ing)
end

function NormalTimer:status_onUpdateStatusFraction(ing, frac)
	print("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa")
	self.rotation = 360 * frac
	print(frac)
	print("hahahahahahhahahahahahahahahahaahahahah")
end

-- ************************************ Changer Timer ************************************ --
ChangerTimer = deriveLuaClass("ChangerTimer", "CookerTimer")

function ChangerTimer:status_onUpdateStatusFraction(ing, frac)
	if (self.curStatus == "prepare") then
		frac = 0
	elseif (self.curStatus == "ready") then
		if (ing.decayStage) then
			local numStages = #ing.stages
			local portion = 1/(numStages+1)
			frac = (numStages*frac) * portion
		end
	elseif (self.curStatus == "decay") then
		if (ing.decayStage) then
			local numStages = #ing.stages
			local portion = 1/(numStages+1)
			frac = (numStages+frac) * portion
		else
			frac = 1
		end
	end
	self.rotation = 360 * frac
end

-- ************************************ Changer Wheel ************************************ --
ChangerWheel = deriveLuaClass("ChangerWheel", "StatusObject")

function ChangerWheel:statusUpdate(status, init, ing)
	ChangerWheel.super.statusUpdate(self, status, init, ing)
	if (status == "inactive") then
		self.frame = 0
	end
end

function ChangerWheel:status_onUpdateStatusFraction(ing, frac)
	if (self.curStatus == "prepare") then
		frac = 0
	elseif (self.curStatus == "ready") then
		if (ing.decayStage) then
			local numStages = #ing.stages
			local portion = 1/(numStages+1)
			frac = (numStages*frac) * portion
		end
	elseif (self.curStatus == "decay") then
		if (ing.decayStage) then
			local numStages = #ing.stages
			local portion = 1/(numStages+1)
			frac = (numStages+frac) * portion
		else
			frac = 1
		end
	end
	local frameCount = self.frameCount
	self.frame = math.min(frameCount-1, frameCount * frac)
end
