-- ************************************ Grow ************************************ --
Timber = deriveLuaClass("Timber", "Grow")

function Timber:init(desc)
	Timber.superInit(self, desc)
--	self.startGrowScale = desc.startGrowScale or 0
	self.endPosition = self.location or {x=0, y=0}
	self.startPosition = {x=self.endPosition.x - 310, y=self.endPosition.y - 250}

	self.endRotation = self.rotation
	self.startRotation = 45
end

function Timber:onStartPreparing()
	Grow.super.onStartPreparing(self) -- leave like this
	self.location = self.startPosition
	self.rotation = self.startRotation
end

function Timber:onBecomeAvailable(fromTimer)
	Grow.super.onBecomeAvailable(self, fromTimer) -- leave like this
	self.scaleStartTime = 0
	self.location = self.endPosition
	self.rotation = self.endRotation
end

function Timber:onTick(time)
	self:tick(time)
	if (self.state == "prepare") then

		local x = math.lerp(
			math.jcurve(self.timer.clampedFraction),
			self.startPosition.x, self.endPosition.x)
		local y = math.lerp(
			math.jcurve(self.timer.clampedFraction),
			self.startPosition.y, self.endPosition.y)
		self.location = {x=x, y=y}

		if (self.timer.clampedFraction > 0.8) then		
			self.rotation = math.lerp(
				math.inv_lerp(self.timer.clampedFraction-0.8, 0, 0.2), 
				self.startRotation, self.endRotation)
		end
	end
end

--function Timber:getObjectThatCanMakeIngredient(ingredientName, unfinishedQueuedProducts)
--	return self.super.getObjectThatCanMakeIngredient(self, ingredientName, unfinishedQueuedProducts)
--end
