dialogs.daily_dialog = {
	-- // PARAMETERS // --
	class="DailyDialog",
	name="daily_dialog",
	darkenBackground=true,
	autoCenter = true,
	setup = setups.dialog_default,
	width=1400, height=1400,
	anchor="center",
	heroSelectedSound = "daily_challenge_element_show1:sound",
	locationSelectedSound = "daily_challenge_element_show2:sound",
	challengeSelectedSound = "daily_challenge_element_show3:sound",
	fullChallengeReadySound = "end_scene_1star_reached_star:sound",
	timeInitial = 500,
	timeGeneratingBlinkPhase = 600,
	timeGenerating = 3000,
	timeBetweenChoices = 1000,
	timeFadeInInfo = 500,

	-- // COMPONENTS // --
	components = {
		-- Title
		{class="Label", name="dialogTitle", anchor="center", textId="DAILY_TITLE", setup=setups.dialog_header_text},

		-- Close Button
		{class="Button", name="close", setup=setups.btn_close},

		-- Score
		{class="BorderSprite", name="score_bg", x=0, y=-458, image="high_score:shift_start_ui", borderTop=43, borderBottom=43, borderLeft=43, borderRight=43, width=700, anchor="center", children=
			{
				{class="Label", name="scoreTitle", x=-10, y=-9, anchor="center", textId="HIGHSCORE", setup=setups.dialog_header_text, textSize=54},
				{class="Label", name="scoreValue", x=10, y=-9, anchor="center", setup=setups.txt, color0=0xffffff, textSize=54},
			}
		},

		-- Clock
		{class="Sprite", name="clock_bg", x=-650, y=556, image="clock:map_ui", anchor="center", children=
			{
				{class="GameNode", name="clock_center", x=0, y=-18, anchor="center", children=
					{
						{class="Sprite", name="clock_frame", x=0, y=0, image="clock_frame:map_ui", anchor="center", scale= 1.7619, children=
							{
								{class="ThresholdSprite", name="clock_frame_passed", x=0, y=0, image="clock_frame_passed:map_ui", thresholdMask="clock_frame_threshold:map_ui", anchor="center"},
							}
						},
						{class="Sprite", name="clock_pointer", x=0, y=0, anchor="center", rotation=0, children=
							{
								{class="Sprite", name="clock_pointer_img", x=0, y=-33.5, image="clock_hand:map_ui", anchor="center"},
							}
						},
						{class="Sprite", name="clock_pointer_little", x=0, y=0, anchor="center", rotation=0, children=
							{
								{class="Sprite", name="clock_pointer_little_img", x=0, y=-40, image="clock_hand_little:map_ui", anchor="center"},
							}
						},
						{class="Sprite", name="clock_center_img", x=0, y=0, image="clock_center:map_ui", anchor="center"},
					}
				},
				{class="BorderSprite", name="time_bg", x=1, y=135, image="clock_button:map_ui", anchor="center", borderTop=55, borderBottom=55, borderLeft=55, borderRight=55, width=300, children=
					{
						{class="Label", name="timeH", x=-52, y=-9, anchor="right", align="right", setup=setups.dialog_header_text, textSize=56, text="00"},
						{class="Label", name="timeSepL", x=-45, y=-14, anchor="center", setup=setups.dialog_header_text, textSize=56, text=":"},
						{class="Label", name="timeM", x=0, y=-9, anchor="center", setup=setups.dialog_header_text, textSize=56, text="00"},
						{class="Label", name="timeSepR", x=45, y=-14, anchor="center", setup=setups.dialog_header_text, textSize=56, text=":"},
						{class="Label", name="timeS", x=52, y=-9, anchor="left", align="left", setup=setups.dialog_header_text, textSize=56, text="00"},
					}
				},
				{class="Sprite", name="little_diamond_1", x=-65, y=-152.6, image="diamond_little:shift_start_ui", anchor="center", children=
					{
						{class="Sprite", name="little_diamond_3", x=130, y=0, image="diamond_little:shift_start_ui", anchor="center"},
						{class="Sprite", name="little_diamond_2", x=65, y=-15, image="diamond_little:shift_start_ui", anchor="center", scale=1.2},
					}
				},
			}
		},

		-- Description
		{class="BorderSprite", name="description", x=0, y=12, image="description_bubble:shift_start_ui", anchor="center", borderTop=15, borderBottom=15, borderLeft=15, borderRight=15, width=1200, height=120, children=
			{
				{class="Label", name="generatingText", x=0, y=0, anchor="center", setup=setups.brown_txt, textSize=50, textId="DAILY_GENERATING"},
				{class="Label", name="descriptionText", x=0, y=0, anchor="center", align="center", setup=setups.paleblue_txt, textSize=42, maxWidth=1000, wrapStyle="word"},
			}
		},

		-- Challenge
		{class="Sprite", name="challenge_img", x=435, y=375, image="tired_hero:events_ui", anchor="center"},

		-- Location
		{class="Sprite", name="location_img", x=32, y=250, image="room_building_01:map_ui_compressed", anchor="center"},

		-- Challenge Hero
		{class="Sprite", name="hero_img", x=-300, y=616.8, image="emily:map_ui_compressed", anchor="bottom"},

		-- Stars & Diamonds
		{class="GameNode", name="starsDiamonds", x=0, y=-280, anchor="center", children=
			{
				{class="GameNode", name="star1", x=-330, y=0, anchor="center", children=
					{
						{class="Sprite", name="star_empty1", x=0, y=0, image="star_empty:shift_start_ui", currentFrame=0, anchor="center"},
						{class="Sprite", name="star_full1", x=0, y=0, image="star:shift_start_ui", currentFrame=0, anchor="center"},
						{class="BorderSprite", name="diamond_bg1", x=0, y=172, image="diamondcoins_back:shift_start_ui", borderTop=30, borderBottom=30, borderLeft=35, borderRight=35, width=200, anchor="center", children=
							{
								{class="Label", name="numDiamonds1", x=-13, y=-4, anchor="center", setup=setups.txt, color0=0xffffff, textSize=54},
								{class="Sprite", name="diamond1", x=70, y=0, image="diamond:shift_start_ui", anchor="center"},
							}
						}
					}
				},
				{class="GameNode", name="star2", x=0, y=0, anchor="center", children=
					{
						{class="Sprite", name="star_empty2", x=0, y=0, image="star_empty:shift_start_ui", currentFrame=0, anchor="center"},
						{class="Sprite", name="star_full2", x=0, y=0, image="star:shift_start_ui", currentFrame=0, anchor="center"},
						{class="BorderSprite", name="diamond_bg2", x=0, y=172, image="diamondcoins_back:shift_start_ui", borderTop=30, borderBottom=30, borderLeft=35, borderRight=35, width=200, anchor="center", children=
							{
								{class="Label", name="numDiamonds2", x=-13, y=-4, anchor="center", setup=setups.txt, color0=0xffffff, textSize=54},
								{class="Sprite", name="diamond2", x=70, y=0, image="diamond:shift_start_ui", anchor="center"},
							}
						}
					}
				},
				{class="GameNode", name="star3", x=330, y=0, anchor="center", children=
					{
						{class="Sprite", name="star_empty3", x=0, y=0, image="star_empty:shift_start_ui", currentFrame=0, anchor="center"},
						{class="Sprite", name="star_full3", x=0, y=0, image="star:shift_start_ui", currentFrame=0, anchor="center"},
						{class="BorderSprite", name="diamond_bg3", x=0, y=172, image="diamondcoins_back:shift_start_ui", borderTop=30, borderBottom=30, borderLeft=35, borderRight=35, width=200, anchor="center", children=
							{
								{class="Label", name="numDiamonds3", x=-13, y=-4, anchor="center", setup=setups.txt, color0=0xffffff, textSize=54},
								{class="Sprite", name="diamond3", x=70, y=0, image="diamond:shift_start_ui", anchor="center"},
							}
						}
					}
				},
			},
		},

		-- Play Button
		{class="Button", name="play", x=32, y=522, setup=setups.stdbtn_green, anchor="center",
			label={class="Label", setup=setups.stdbtn_green_txt, name="txt_map", textId="BUTTON_PLAY"}
		},
	},
}
