scenes.game = {
	class = "GameScene",
	guiHud = {class="Sprite",
		children={
			{class="ChallengeBar", x=GH.getUnitWidth(), y=0, name="challenge_bar", closedX=-286, openX=-800, arc=5.3, radius=86, anchor="topRight",
			children=
			{
				{class="Button", y=0, name="slider", image="challenge_slider:gamescene", anchor="left", clipRect={x=-910, y=0, width=798, height=400},
				children={
					{class="Label", x=322, y=0, name="text", setup=setups.paleblue_txt, textSize=42, lineHeight=60, anchor="center", align="center", maxWidth=440, wrapStyle="word"},
				}},
				{class="Button", name="circle", image="challenge_circle:gamescene", anchor="center",
				children={
					{class="Sprite", name="gutter", image="challenge_gutter:gamescene", anchor="center"},
					{class="ThresholdSprite", name="bar", image="challenge_fill:gamescene", thresholdMask="challenge_threshold:gamescene", anchor="center"},
					{class="Sprite", name="icon", anchor="center", x=-1, scaleX=0.54, scaleY=0.54},
					{class="Sprite", name="status_icon", anchor="center"},
					{class="Sprite", name="check", image="challenge_checkmark:gamescene", anchor="center", visible=false},
				}},
			}},
		},
	},
	guiBarOld = {class="Sprite", anchor="bottomLeft",
		children =
		{
			{class="Button", name="menu", image="menu_button_round:gamescene", setup=setups.btn, anchor="center", scale=((isPhone and 1.18) or 1)},

			{class="Sprite", name="score_bar", image="money_bar_goal:gamescene"},

			{class="Sprite", name="clock_frame_red", image="clock_frame_red:gamescene", anchor="center"},
			{class="Sprite", name="clock_frame", image="clock_frame:gamescene", anchor="center"},
			{class="ThresholdSprite", name="clock_frame_passed", image="clock_frame_passed:gamescene", thresholdMask="clock_frame_threshold:gamescene", anchor="center"},
			{class="Sprite", name="clock_pointer_shadow", image="clock_pointer_shadow:gamescene", anchor="center"},
			{class="Sprite", name="clock_pointer", image="clock_pointer:gamescene", anchor="center" },
			{class="Sprite", name="clock_center", image="clock_center:gamescene", anchor="center"},

			{class="Sprite", name="gui_mouse", image="mouse:gamescene", anchor="bottom", visible=false},

			{class="Label", name="episode_text", setup=setups.outline, color0=0xb2e8f8, color1=0x471e1A, textSize=34},
			{class="Label", name="episode_value", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=34},

			{class="Label", name="score_text", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=32, textId="SCORE"},
			{class="Label", name="score_value", setup=setups.outline, color0=0xfff88a, color1=0x471e1A, textSize=32},

			{class="Sprite", name="1star_indicator", anchor="bottom", },
			{class="Label", name="1star_score", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=30},
			{class="Sprite", name="2star_indicator", anchor="bottom", },
			{class="Label", name="2star_score", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=30},
			{class="Sprite", name="3star_indicator", anchor="bottom", },
			{class="Label", name="3star_score", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=30},
			{class="Tray", name="tray"},

			--{class="Sprite", name="heart", image="heart:gamescene", anchor="center", },

			{class="Label", name="host_challenge", setup=setups.outline, anchor="center", align="center", color0=0xffffff, color1=0x471e1A, textSize=26},
		},
	},
	guiBar = {class="BorderSprite", anchor="bottom",
		name="background", image="bar:widebar", borderLeft=27, borderRight=27, borderTop=0, borderBottom=0, width=2427,
		children =
		{
			{class="Button", name="menu", image="pause_button:widebar", setup=setups.btn, anchor="left", scale=((isPhone and 1.18) or 1), x=-960, y=-56},

			{class="GameNode", name="leftContainer", anchor="bottomRight", x=-53, anchor="left",
				children={
					{class="BorderSprite", name="episode_container", image="level:widebar", anchor="center", borderLeft=0, borderRight=0, borderTop=0, borderBottom=0,
						width=246, height=34, y=-35, x=-800,
						children={
							{class="Label", name="episode_text", setup=setups.outline, color0=0xe5e0f1, color1=0x1c1673, wrapStyle="word", align="center", maxWidth=300, textSize=34, x=0, y=-30, anchor="bottom"},
							{class="Label", name="episode_value", setup=setups.outline, color0=0xe5e0f1, color1=0x1c1673, wrapStyle="word", maxWidth=150, textSize=34,x=0, y=-30, anchor="top"},
						}
					},
					{class="Sprite", name="trayContainer", x=-700, y=-116, image="tray_dots:widebar",
						children={
							{class="Tray", name="tray"},
						}
					}
				}
			},
			{class="GameNode", name="clockgroup", anchor="bottom",
				children = {
					{class="Sprite", name="clock_frame_w", image="clock_frame:widebar", anchor="bottom"},
					{class="GameNode", name="clock_contents", y=-12,
						children={
							{class="Sprite", name="clock_frame_red", image="clock_frame_red:gamescene", anchor="bottom"},
							{class="Sprite", name="clock_frame", image="clock_frame:gamescene", anchor="bottom"},
							{class="ThresholdSprite", name="clock_frame_passed", image="clock_frame_passed:gamescene", thresholdMask="clock_frame_threshold:gamescene", anchor="bottom"},
							{class="Sprite", name="clock_pointer_shadow", image="clock_pointer_shadow:gamescene", anchor="center", y=-52},
							{class="Sprite", name="clock_pointer", image="clock_pointer:gamescene", anchor="center", y=-52},
							{class="Sprite", name="clock_center", image="clock_center:gamescene", anchor="bottom"},
						}
					}
				}
			},
			{class="GameNode", name="rightContainer", anchor="bottom", x=512, width=1024,
				children={
					{class="BorderSprite", name="score_container", image="level:widebar", flipHorizontal = true, anchor="left", borderLeft=0, borderRight=0, borderTop=0, borderBottom=0,
						width=246, height=34, y=-35, x=-410,
						children={
							{class="GameNode", name="score_container", anchor="center", width=300, x=120,
								children={
									{class="Label", name="score_text", setup=setups.outline, color0=0xe5e0f1, color1=0x1c1673, textSize=32, textId="SCORE", anchor="left", x=-50, y=-60},
									{class="Label", name="score_value", setup=setups.outline, color0=0x14e8ed, color1=0x1c1673, textSize=40, anchor="left", y=-20}
								}
							}
						}
					},

					{class="BorderSprite", name="scorebar_container", image="hole:widebar", anchor="left", borderLeft=0, borderRight=0, borderTop=0, borderBottom=0,
						width=606, height=52, y=-50, x=-190,
						children={
							{class="Sprite", name="score_bar", image="money_bar_goal:gamescene", x=15, y=-15, width=578, height=32,},
							{class="Sprite", name="1star_indicator", anchor="bottom", },
							{class="Label", name="1star_score", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=30, anchor="bottom"},
							{class="Sprite", name="2star_indicator", anchor="bottom", },
							{class="Label", name="2star_score", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=30, anchor="bottom"},
							{class="Sprite", name="3star_indicator", anchor="bottom", },
							{class="Label", name="3star_score", setup=setups.outline, color0=0xffffff, color1=0x471e1A, textSize=30, anchor="bottom"},
						}
					}
				}
			},


			{class="Sprite", name="mouseContainer", image="mouse_empty:widebar", anchor="right", x=970, y=-60,
				children={
					{class="Sprite", name="gui_mouse", image="mouse:widebar", anchor="right",},
				}
			}

		},
	},
	menuBar = {class="BorderSprite", anchor="bottom",
		name="background", image="menu_bar:menu_ui", borderLeft=0, borderRight=0, borderTop=0, borderBottom=0, width=2427,
		children =
		{
			{class="Button", name="map", anchor="bottomLeft", x=-1211, y=20, setup=setups.btn_back},
			{class="BorderSprite", name ="choose_your_menu_bg", image="choose_label:menu_ui",
				borderRight = 145, borderLeft = 145, borderTop = 119, borderBottom = 119,
				width = 910, height = 280, anchor = "center",
				children = { {class="Label", name="text", setup=setups.stdbtn_txt, anchor = "center",textSize=48, y =38},}
			},
			{class="Sprite", name="choice_gui", anchor="topLeft"},
			{class="Sprite", name="choice_gui_top", anchor="topLeft"},
			{class="Sprite", name="choice_text", x=1024, y=130, anchor="center"}, -- This shop_text is needed for the x and y position of the label in bottom gui mode
			{class="Label", name="episode_choice_text", setup=setups.stdbtn_txt,x=-381, y=-18, anchor="bottom"},
			{class="Button", name="choice_buy", anchor="center", x=(2427 - GH.getUnitWidth()) / 2.0, y=-95, setup=setups.stdbtn_gold,
				visible=false,
				children={
					{class="Label", y=-4, textSize=60, anchor="center", setup=setups.stdbtn_gold_txt, name="txt_button", textId="BUTTON_NO_ADS", }
				}
			},
--			{class="GameNode", name="group_shop_play_btns", x=545, y=-68, anchor="center",
--				children={
					{class="Button", name="shop", image ="shop_button:menu_ui", x=545, y=-72, width=414, height=168, setup=setups.stdbtn, anchor="center",
						borderLeft=157, borderTop=0, borderRight=73, borderBottom=0,
						label = {class="Label", x=48, y=-8, setup=setups.stdbtn_txt, name="txt_button", textId="BUTTON_SHOP"}
					},
					{class="Button", name="choice_continue", anchor="center", x=1014, y=-68, height = 168, setup=setups.stdbtn_green, anchor="center",
						borderLeft=89, borderTop=0, borderRight=89, borderBottom=0,
						label={class="Label", y=-16, setup=setups.stdbtn_green_txt, name="txt_button", textId="BUTTON_PLAY"}
					},
--				}
--			}
		}
	}
}
