dialogs.gift_received = {
    class="GiftReceivedDialog",
    doDarkenBackground=true,
    width=1300, height=1400,
    setup = setups.dialog_default,
    anchor="center",
    components = {
        -- Title
        { class="Label", name="dialogTitle", x=0, y=-600, anchor="center",
            textId="NEIGHBORS_TITLE", textSize=60, setup=setups.dialog_header_text,
        },
        -- Message
        { class="Label", name="message", x=0, y=-500, anchor="top",
            textId="NEIGHBORS_GIFT_RECEIVED",
            setup=setups.dialog_header_text, maxWidth=1000, wrapStyle="word",
        },
        { class="Sprite", name="diamond", x= 0, y=-300, anchor="center",
            image="diamond:shift_start_ui", scaleX=2, scaleY=2,
        },
        {class="BorderSprite", name="diamond_bg", x=0, y=-160,
        image="diamondcoins_back:shift_start_ui",
        borderTop=30, borderBottom=30, borderLeft=35, borderRight=35,
        width=160, anchor="center", children=
            {
                { class="Label", name="numDiamonds",
                    x=0, y=-4, anchor="center", setup=setups.txt,
                    color0=0xffffff, textSize=54, text="x3"
                }
            }
        },
        -- Close Button
        { class="Button", name="close", setup=setups.btn_close },

        -- Friends tab
        { class="BorderSprite", name="friends_background", x=0, y=60, anchor="center",
            image="description_bubble:shift_start_ui", width=1040, height=320,
            borderTop=15, borderBottom=15, borderLeft=15, borderRight=15,
            children= {
                { class="SwipeSpriteLight", name="scroll", clickSound="button:ui",
                    anchor = "bottom", setup=setups.btn, width = 1040, x=0, y=-40,
                    background = "icon_s1:metagame_ui", anchor = "bottom",
                    stops = {
                        0, 200
                    },
                    scrollLimitMin=0,
                    scrollLimitMax=0,
                    needlePosition=0,
                    clipRect={x=-520, y=-150, width=1040, height=350},
                    children={
                        { class="Sprite", name="slot", x=20, y=0, image="gift_photo_overlay:neighbors_ui",
                            anchor="center", --setup=setups.stdbtn, width=194, height=181,
                            children={
                                { class="Sprite", name="slot_picture", image="photo_overlay:neighbors_ui",
                                    anchor="center", x=0, y=-10,
                                },
                                { class="Sprite", name="slot_overlay", image="gift_photo_overlay:neighbors_ui",
                                    anchor="center", x=0, y=0,
                                },
                                { class="Sprite", name="slot_availability", image="friend_ready:neighbors_ui",
                                    anchor="center", x=0, y=124
                                },
                            }
                        },
                    },
                },
            }
        },

        {class="Sprite", name="left_fade", x=-521,y=60, anchor="left",
            image="blue_fade:neighbors_ui", height=270,
        },
        {class="Sprite", name="right_fade", x=520,y=60, anchor="left",
            image="blue_fade:neighbors_ui", height=270, scaleX=-1,
        },

        -- Gift back checkbox
        { class="BorderSprite", name="gift_all_background", x=0, y=320, anchor="center",
            image="description_bubble:shift_start_ui", width=800, height=150,
            borderTop=15, borderBottom=15, borderLeft=15, borderRight=15,
            children={
                {class="Button", name="gift_all_switch", image="checkbox_empty:ui",
                    anchor="center", x=-320, y=0,
                    children={
                        { class="Sprite", name="gift_all_inside", image="checkbox_full:ui",
                            anchor="center", x=0, y=0
                        }
                    },
                },

                { class="Label", name="gift_all_txt", anchor="left",
                    textId="NEIGHBORS_GIFT_BACK",x=-230, y=0, textSize=50,
                    setup=setups.dialog_header_text,
                }
            }
        },

        -- Continue button
        { class="Button", name="gift_continue_button", x=0, y=510, anchor="center", setup=setups.neighborbtn,
            label={
                class="Label", setup=setups.neighborbtn_txt,
                name="fb_friends_button_text", textId="BUTTON_CONTINUE"
            }
        },
    }
}
