
local sliceSetup = {
	diamondcoins_back = {
		borderLeft = 34,
		borderTop = 30,
		borderRight = 34,
		borderBottom = 30
	},
	description_bubble = {
		borderLeft = 25,
		borderTop = 25,
		borderRight = 25,
		borderBottom = 25
	},
	high_score = {
		borderLeft = 35,
		borderTop = 35,
		borderRight = 35,
		borderBottom = 35
	},
}

dialogs.levelStart = {
	class="LevelStartDialog",
	doDarkenBackground=true,
	--popup=true, modal=false,
	setup = setups.dialog_default,
	width=1159, height=1049,
	anchor="center",
	components = {
	--	{class="Sprite", name="wh", image="level_dialog_1:ui", anchor="center"},
	
-- Highscore
		{class="BorderSprite", name="score_layout", x=0, y=200, image="high_score:shift_start_ui", anchor="center", height = 80, width=580, setup=sliceSetup.high_score, children={
			{class="Label", name="score_text", x=-10, y=-10, setup=setups.dialog_header_text, anchor="right",color0=0X4adbed, color1=0x0268b4, textSize=54, textId="HIGHSCORE"},
			{class="Label", name="score", x=10, y=-10, setup=setups.dialog_header_text, anchor="left", color0=0Xfcde0a, color1=0xbd380a, textSize=50},
		}},

-- The Stars
		{class="GameNode", name="star_layout", anchor="center", y=-120, children={
			{class="GameNode", name="1star_layout", x=-260, y=50, anchor="center",  children={
				{class="Sprite", name="1star_empty", image="star_empty:shift_start_ui", anchor="center", rotation = -15, scale=0.9},
				{class="Sprite", name="1star", image="star:shift_start_ui", y=-4, anchor="center", rotation = -15, scale=0.9},

				{class="BorderSprite", name="1reward_layout", image="diamondcoins_back:shift_start_ui", y=170, width=180, anchor="center", setup=sliceSetup.diamondcoins_back, children={
					{class="Label", name="reward1star_label", x=0, y=-4, setup=setups.dialog_header_text, anchor="center", text="100", textSize=46, anchor="center", color0="white",color1=0xbd380a},
					{class="Sprite", name="coin1", image="icon_coin:ui", x=100, y=0, anchor="center"},
					{class="Sprite", name="diamond_empty1", image="icon_diamond:ui", x=90, y=0,  scale=0.8, anchor="center", children={
						{class="Sprite", name="diamond1", image="icon_diamond:ui", anchor="center"},
					}},
				}}
			}},

			{class="GameNode", name="2star_layout", x=0, y=0, anchor="center", children={
				{class="Sprite", name="2star_empty", image="star_empty:shift_start_ui", anchor="center"},
				{class="Sprite", name="2star", image="star:shift_start_ui", y=-4, anchor="center"},

				{class="BorderSprite", name="2reward_layout", image="diamondcoins_back:shift_start_ui", y=180, width=180, anchor="center", setup=sliceSetup.diamondcoins_back, children={
					{class="Label", name="reward2star_label", x=0, y=-4, setup=setups.dialog_header_text, anchor="center", text="100", textSize=46, anchor="center", color0="white",color1=0xbd380a},
					{class="Sprite", name="coin2", image="icon_coin:ui", x=100, y=0, anchor="center"},
					{class="Sprite", name="diamond_empty2", image="icon_diamond:ui",x=90, y=0, scale=0.8,anchor="center", children={
						{class="Sprite", name="diamond2", image="icon_diamond:ui", anchor="center"},
					}},
				}}
			}},

			{class="GameNode", name="3star_layout", x=260, y=50, anchor="center", children={
				{class="Sprite", name="3star_empty", image="star_empty:shift_start_ui", anchor="center", rotation=15,scale=0.9},
				{class="Sprite", name="3star", image="star:shift_start_ui", y=-4, anchor="center", rotation=15,scale=0.9},

				{class="BorderSprite", name="3reward_layout", image="diamondcoins_back:shift_start_ui", y=170, width=180, anchor="center", setup=sliceSetup.diamondcoins_back, children={
					{class="Label", name="reward3star_label", x=0, y=-4, setup=setups.dialog_header_text, anchor="center", text="100", textSize=46, anchor="center", color0="white",color1=0xbd380a},
					{class="Sprite", name="coin3", image="icon_coin:ui", x=100, y=0, anchor="center"},
					{class="Sprite", name="diamond_empty3",   x=90, y=0,image="icon_diamond:ui",  scale=0.8, anchor="center", children={
						{class="Sprite", name="diamond3", image="icon_diamond:ui", anchor="center"},
					}},
				}}
			}},
		}},

-- The Teaser
		{class="BorderSprite", name="description_layout", image="description_bubble:shift_start_ui", x=0, y=260, anchor="top", width=1000, height=150, setup=sliceSetup.description_bubble, children={
			{class="GameNode", name="teaser_group", anchor="top", children={
				--{class="Label", name="teaser_title", x=0, y=-10, setup=setups.dialog_header_text, anchor="bottom", maxWidth=790, wrapStyle="word", align="center"},
				{class="Label", name="teaser", x=0, y=10, setup=setups.paleblue_txt, anchor="top", textSize=50, maxWidth=820, wrapStyle="word", align="center", lineHeight=44},
			}},
			{class="Sprite", name="challenge_icon", x=410, y=70, anchor="center"}
		}},

-- The Mouse & Diamond
			{class="Sprite", name="diamond", image="diamond_get_empty:shift_start_ui", x=-350, y=200, anchor="center", children={
				{class="Sprite", name="reward", image="diamond_get:shift_start_ui", anchor="center"}
			}},

			{class="Sprite", name="mouse_back", image="mouse_empty:shift_start_ui", x=350, y=200, anchor="center", children={
				{class="Sprite", name="mouse", image="mouse:shift_start_ui", anchor="center"}
			}},

-- Play Button
		{class="Button", name="play", x=0, y=540, anchor="center", setup=setups.stdbtn_green,
			children={{class="Label", name="txt_button", setup=setups.stdbtn_green_txt, textId="BUTTON_PLAY", anchor="center"}}
		},

-- Buy Button
		{class="Button", name="buy", x=0, y=540, anchor="center", setup=setups.stdbtn_gold, visible=false, 
			children={
				{class="Label", y=-4, textSize=60, anchor="center", setup=setups.stdbtn_gold_txt, name="txt_button", textId="BUTTON_NO_ADS", }
			}
		},

-- Border/Header stuff
		{class="Button", name="close", setup=setups.btn_close},
		{class="Label", name="dialogTitle", anchor="center", y=-10, textId="DAILY_TITLE", color0=0x02b0d5, color1=0x2b5ea3, setup=setups.level_done_dialog_header},
	},
}
