local function toPoint(v, w)
	if (isTable(v)) then
		return {x = v.x or v[1] or 0, y = v.y or v[2] or 0}
	end
	return {x = v or 0, y = w or 0}
end

--[[local function getPaddings(desc)
	local paddings = {}

	if desc.style == "jagged" then
		paddings.top = 45
		paddings.side = 45
		paddings.bottom = 45
	else
		paddings.top = 25
		paddings.side = 20
		paddings.bottom = 20
	end

	return paddings
end]]--

function createMessageDialogDescription(desc)
	desc = table.copy(desc)
	if (not desc.text) then
		desc.textId = desc.textId or ""
	end
	desc.dialogId = desc.dialogId or desc.textId or math.Random(999999)
	desc.tipType = desc.tipType or "point"
	desc.tipSide = desc.tipSide or "center"
	desc.maxLineCount = desc.maxLineCount or 4
	desc.labelWidth = (desc.labelWidth or defaultMessageBalloonWidth) * ((isPhone and 1.15) or 1.0)

	if (desc.content) then
		desc.content.y = desc.content.y or 10
		desc.content.class = desc.content.class or "Sprite"
	end

	local textSize = desc.textSize or 40
	textSize = textSize * ((isPhone and 1.15) or 1)

	local balloonChildren = {}
	balloonChildren[1] = {
		class="Sprite",
		name="tip",
	}
	balloonChildren[2] = {
		class="TypeLabel",
		name="message",
		text=desc.text,
		maxWidth=desc.labelWidth,
		wrapStyle="word",
		font=desc.font or "main_font:fonts",
		color0=0, alpha1=0, alpha2=0, alpha3=0,
		anchor=desc.anchor or "top",
		x=desc.labelX,
		textSize=textSize,
		lineHeight=textSize,
		y=-15
	}
	-- If there is portrait
	if (desc.portraitSection and desc.portraitSection ~= ""
		and desc.portraitAnimation and desc.portraitAnimation ~= "") then
		balloonChildren[3] = {
			x=0, y=0,
			class="SpriteExt",
			name="portrait",
			defaultSection=desc.portraitSection,
			baseAnimation=desc.portraitAnimation,
			anchor="right",
		}
	end

	local dialogDef = {
		class="BalloonDialog",
		owner = self,
		dialogId = desc.dialogId,
		anchor = "top",
		topPadding = desc.topPadding or 11,
		sidePadding = desc.sidePadding or 20,
		bottomPadding = desc.bottomPadding or 24,
		contentOffsetY = desc.contentOffsetY or 0,
		textId = desc.textId,
		choiceId = desc.choiceId,
		tipType = desc.tipType,
		customTip = desc.customTip,
		tipSide = desc.tipSide,
		maxLineCount = desc.maxLineCount or 4,
		restrictScreenPosition = desc.restrict,
		doPopIn = desc.doPopIn,
		doPopOut = desc.doPopOut,
		children = balloonChildren,
		content = desc.content,
		customImage = desc.customImage,
		offset = toPoint(desc.offset),
		onTaskSkip = desc.onTaskSkip,
	}

	return { def=dialogDef, desc=desc }
end
