dialogs.minigame = {
	class = "MinigameDialog",
	minWidth = 1160, minHeight = 600,
	painter = blueprints.default_painter,
	animationTime = 450,
	movetoBagTime = 300,
	evidenceBag = {class="Object",x=500, y=400,width=265,height=224, baseAnimation="evidence_bag",anchor="center", name = "evidenceBag"},
	checks = {
		{ class="Sprite", name="correct_icon", image="correct_icon:minigames",anchor="center"},
		{ class="Sprite", name="incorrect_icon", image="incorrect_icon:minigames",anchor="center"},
	},

	clickToContinue = {  class="Label", name="click",x=780, y=580, setup=setups.dialog_header_text,textId="BUTTON_CONTINUE", textSize=60, anchor="bottomRight"},
	
	tutorial_button = {
		class="Button",name="tutorialButton", setup=setups.btn_tutorial_minigame,width=138,height=138,x= 650 ,y = -470},
	

	components = {	
	{class="Sprite", name="back",image="background1:minigames",width=2427,height=1536, setup=setups.dialog_hint, anchor="center", children=
			{
				--{ class="Sprite",x=0,y=-400,width=1600, height= 300, name="timebar_bg", image="heartbar:minigames",anchor="bottom" },
				
				{ class="Button", name="skip_minigame", x=2730, y=2630, image="dummy:gamescene", anchor="center", setup=setups.btn},
				{ class="Label", name="header", x=-720, y=-540, setup=setups.dialog_header_text_minigame, textSize=55, anchor="topLeft"},
				{ class="Label", name="message",x=580, y=280, setup=setups.dialog_header_text, textSize=6, anchor="bottomLeft"},
			
				{ class="Sprite",x=-735,y=-440, name="timebar", image="timebar:minigames",anchor="topLeft"},
				{ class="Sprite",x=-735,y=-440, name="timebar_fill", image="timebar_fill:minigames",anchor="topLeft"},
				
				--[[
				{ class="SpriteExt", x=690,y=-640,width = 400,height=244, name="portrait", baseAnimation="ID_tagDefault:minigames",anchor="topRight", children=
				{
					{ class="Sprite",x=-335,y=150, width = 117,height=152, name="portrain_icon", image="exclamation:gamescene",anchor="center"},
					{ class="Label", name="portrait_name",x=-385,y=0, setup=setups.dialog_header_text, textSize=35, anchor="topLeft"},
				}
				},
				--]]
				
				{ class="Sprite", name="heart1", image="timebar_heart:minigames",anchor="topLeft" },
				{ class="Sprite", name="heart2", image="timebar_heart:minigames",anchor="topLeft" },
				{ class="Sprite", name="heart3", image="timebar_heart:minigames",anchor="topLeft" },

				--[[
				{ class="Sprite",x=450,y=-520, name="shield1", image="mood_heart_empty:gamescene",anchor="center" },
				{ class="Sprite",x=450,y=-520, name="shieldD1", image="mood_heart:gamescene",anchor="center" },
				{ class="Sprite",x=490,y=-520, name="shield2", image="mood_heart_empty:gamescene",anchor="center" },
				{ class="Sprite",x=490,y=-520, name="shieldD2", image="mood_heart:gamescene",anchor="center" },
				{ class="Sprite",x=530,y=-520, name="shield3", image="mood_heart_empty:gamescene",anchor="center" },
				{ class="Sprite",x=530,y=-520, name="shieldD3", image="mood_heart:gamescene",anchor="center" },
				{ class="Sprite",x=570,y=-520, name="shield4", image="mood_heart_empty:gamescene",anchor="center" },
				{ class="Sprite",x=570,y=-520, name="shieldD4", image="mood_heart:gamescene",anchor="center" },
				{ class="Sprite",x=610,y=-520, name="shield5", image="mood_heart_empty:gamescene",anchor="center" },
				{ class="Sprite",x=610,y=-520, name="shieldD5", image="mood_heart:gamescene",anchor="center" },
				]]--
			
			}
		},
		
	},
}


dialogs.minigameComplete = {
	class="ShiftClosedDialog", autoCenter=true, width=GH.getUnitWidth(), height=GH.getUnitHeight(), modal=true,
	initialAnimValues={scale=2, alpha=0},
	components = {
		{ class="Sprite", name="back", image="minigame_end_win:minigames",
			anchor="center", x=GH.getUnitWidth()/2, y=750, scale=1,
			children={
				{ class="Label", name="ANALYSIS", setup=setups.paleblue_txt,
					font="main_font:fonts@60", color0=0x000000, alpha=0.5,
					anchor="center", textId="ANALYSIS", y=-195,
				},

				{ class="Label", name="ANALYSIS", setup=setups.paleblue_txt,
					font="main_font:fonts@60", color0=0x6ce5ff, color1=0x000000,
					anchor="center", textId="ANALYSIS", y=-200,
				},

				{ class="Label", name="COMPLETE", setup=setups.outline, anchor="center",
					color0=0xc4ff00, color1=0x498500, textSize=70,
					anchor="center", textId="COMPLETE", y=170,  
				},
		    },
	    },
	},
	
}

dialogs.minigameFailed = {
	class="ShiftClosedDialog", autoCenter=true, width=GH.getUnitWidth(), height=GH.getUnitHeight(), modal=true,
	initialAnimValues={scale=2, alpha=0},
	components = {
		{ class="Sprite", name="back", image="minigame_end_fail:minigames",
			anchor="center", x=GH.getUnitWidth()/2, y=750, scale=1,
			children={
				{ class="Label", name="ANALYSIS", setup=setups.paleblue_txt,
					font="main_font:fonts@60", color0=0x000000, alpha=0.5,
					anchor="center", textId="ANALYSIS", y=-195,
				},

				{ class="Label", name="ANALYSIS", setup=setups.paleblue_txt,
					font="main_font:fonts@60", color0=0x6ce5ff, color1=0x000000,
					anchor="center", textId="ANALYSIS", y=-200,  
				},

				{ class="Label", name="FAILED", setup=setups.outline, anchor="center",
					color0=0xff0000, color1=0x730000, textSize=70,
					anchor="center", textId="FAILED", y=170,  
				},
		    },
	    },
	},
}

