dialogs.neighbors = {
    class="NeighborsDialog",
    name="neighbors",
    doDarkenBackground=true,
    width=1878, height=1400,
    setup = setups.dialog_default,
    anchor="center",
    components = {
        -- Title
        { class="Label", name="dialogTitle", x=0, y=-600, anchor="center",
            textId="NEIGHBORS_TITLE",setup=setups.outline, textSize=60,
            setup=setups.dialog_header_text,
        },
        -- Diamond accessory
        -- { class="Sprite", name="diamond_icon", x=-830, y=-500, anchor="center",
        --     image="diamond_get:shift_start_ui", scaleX=2, scaleY=2,
        -- },
        -- Close Button
        { class="Button", name="close", setup=setups.btn_close },
        -- Back tab sprites
        -- These two sprites are used as a "background" so the tops are always seen
        { class="BorderSprite", name="back_neighbors_tab", x=-350, y=-400, anchor="center",
            image="orange_folder_top:neighbors_ui", width=700, --height=900,
            borderTop=120, borderBottom=120, borderLeft=120, borderRight=120,
        },
        { class="BorderSprite", name="back_facebook_tab", x=350, y=-400, anchor="center",
            image="blue_folder_top:neighbors_ui", width=700, --height=900,
            borderTop=120, borderBottom=120, borderLeft=120, borderRight=120,
        },


        -- Neighbors tab
        { class="BorderSprite", name="neighbors_panel", x=0, y=150, anchor="center",
            image="orange_folder_bottom:neighbors_ui", width=1700, height=900,
            borderTop=120, borderBottom=120, borderLeft=120, borderRight=120,
            children={
                { class="BorderSprite", name="neighbors_tab", x=-350, y=-550, anchor="center",
                    image="orange_folder_top:neighbors_ui", width=700, --height=900,
                    borderTop=120, borderBottom=120, borderLeft=120, borderRight=120,
                },
                { class="BorderSprite", name="neighbors_white_bg",
                    x=0, y=-100, anchor="center",
                    image="white_background:neighbors_ui", width=1660, height=650,
                    borderTop=110, borderBottom=110, borderLeft=100, borderRight=110,
                },
                { class="ScrollPanel", name="scroll", x=-800, y=-424,
                    vertical=true, scrollWidth=1600, visibleWidth=1600,
                    scrollAreaHeight=800, visibleHeight=650,
                    verticalScroll={ class="Slider", name="slider", forceX=-1077,
                        y=635, image="checkbox_empty:ui", anchor="center",
                        minY=-580, maxY=580,
                        button={ class="Button", x=2,
                            image="slider_button:ui", anchor="center"
                        },
                    },
                },
                { class="Sprite", image="white_fade:neighbors_ui", width=1490,
                    anchor="bottom", y =-424, scaleY=-0.5,
                },
                { class="Sprite", image="white_fade:neighbors_ui", width=1490,
                    anchor="bottom", y =226, scaleY=0.5
                },
                { class="Button", name="select_all_button", x=-400, y=340, anchor="center", setup=setups.neighborbtn,
                    width=700,
                    -- label={ class="Label", setup=setups.neighborbtn_txt,
                    --     name="select_all_button_text",textId="BUTTON_SELECT_ALL"
                    -- },
                    children={
                        { class="Sprite", name="select_check", image="checkbox_empty:ui",
                            anchor="center", x=220, y=-11, children={
                                { class="Sprite", name="select_check_inside", image="checkbox_full:ui",
                                    anchor="center", x=0, y=0
                                }
                            }
                        },
                        { class="Label", x=-60, y=-11, setup=setups.neighborbtn_txt, anchor="center",
                            name="select_all_button_text",textId="BUTTON_SELECT_ALL",
                        }
                    }
                },
                { class="Button", name="invite_button", x=400, y=340, width=600, anchor="center", setup=setups.stdbtn_green,
                    label={ class="Label", setup=setups.stdbtn_green_txt, y=-11,
                        name="invite_button_text", textId="BUTTON_SEND_DIAMOND"
                    }
                },
            }
        },

        -- FB Friends tab

        { class="BorderSprite", name="friends_panel", x=0, y=150, anchor="center",
            image="blue_folder_bottom:neighbors_ui", width=1700, height=900,
            borderTop=120, borderBottom=120, borderLeft=120, borderRight=120,
            children={
                { class="BorderSprite", name="friends_tab", x=350, y=-550, anchor="center",
                    image="blue_folder_top:neighbors_ui", width=700, --height=900,
                    borderTop=120, borderBottom=120, borderLeft=120, borderRight=120,
                },
                { class="BorderSprite", name="friends_white_bg",
                    x=0, y=-100, anchor="center",
                    image="white_background:neighbors_ui", width=1660, height=650,
                    borderTop=110, borderBottom=110, borderLeft=100, borderRight=110,
                },
                { class="ScrollPanel", name="friends_scroll", x=-800, y=-424,
                    vertical=true, scrollWidth=1600, visibleWidth=1600,
                    scrollAreaHeight=800, visibleHeight=650,
                    verticalScroll={ class="Slider", name="slider", forceX=-1077,
                        y=635, image="checkbox_empty:ui", anchor="center",
                        minY=-580, maxY=580,
                        button={ class="Button", x=2,
                            image="slider_button:ui", anchor="center"
                        },
                    },
                },
                { class="Sprite", image="white_fade:neighbors_ui", width=1490,
                    anchor="bottom", y =-424, scaleY=-0.5,
                },
                { class="Sprite", image="white_fade:neighbors_ui", width=1490,
                    anchor="bottom", y =226, scaleY=0.5
                },
                { class="Button", name="select_all_friends_button", x=-400, y=340, anchor="center", setup=setups.stdbtn_fb_friends,
                    width=700,
                    -- label={ class="Label", setup=setups.stdbtn_fb_friends_txt,
                    --     name="select_all_button_text",textId="BUTTON_SELECT_ALL"
                    -- },
                    children={
                        { class="Sprite", name="select_check", image="checkbox_empty:ui",
                            anchor="center", x=220, y=-11, children={
                                { class="Sprite", name="select_check_inside", image="checkbox_full:ui",
                                    anchor="center", x=0, y=0
                                }
                            }
                        },
                        { class="Label", x=-60, y=-11, setup=setups.stdbtn_fb_friends_txt, anchor="center",
                            name="select_all_button_text",textId="BUTTON_SELECT_ALL",
                        }
                    }
                },
                { class="Button", name="invite_friends_button", x=400, y=340, width=600, anchor="center", setup=setups.stdbtn_green,
                    label={ class="Label", setup=setups.stdbtn_green_txt, y=-11,
                        name="invite_button_text", textId="BUTTON_INVITE",
                    }
                },
            }
        },
        { class="Button", name="neighbors_button", x=-350, y=-390, anchor="center",
            setup=setups.neighborbtn, width=600,
            label={
                class="Label", setup=setups.neighborbtn_txt, y=-11,
                name="neighbors_button_text", textId="BUTTON_SEND_DIAMOND"
            }
        },
        { class="Button", name="fb_friends_button", x=350, y=-390, anchor="center",
            setup=setups.stdbtn_fb_friends, width=600,
            label={
                class="Label", setup=setups.stdbtn_fb_friends_txt, y=-11,
                name="fb_friends_button_text", textId="BUTTON_INVITE"
            }
        },
    }
}

blueprints.neighbor_item = {
    class="GameNode",
    x=400,
    children= {
        { class="Button", name="test_neigh", x=0, y=0,
            anchor="center", setup=setups.stdbtn, width=760, height=187,
            children={
                { class="Sprite", image="photo_overlay:neighbors_ui",
                    anchor="center", x=-285, y=-11, name="fb_picture",
                },
                { class="Sprite", image="photo_overlay:neighbors_ui",
                    anchor="center", x=-285, y=-11,
                },
                { class="Label", setup=setups.neighborbtn_txt,
                    x=-210, y=-11, anchor="left",name="fb_friends_button_text",
                    text="Name of neighbor", maxWidth=380, wrapStyle="truncate",
                },
                { class="Sprite", name="neighbor_switch", image="checkbox_empty:ui",
                    anchor="center", x=250, y=-11, children={
                        { class="Sprite", name="neighbor_switch_inside", image="checkbox_full:ui",
                            anchor="center", x=0, y=0
                        }
                    }
                }
            }
        }
    }
}

blueprints.fb_friend_item = {
    class="GameNode",
    x=400,
    children= {
        { class="Button", name="test_neigh", x=0, y=0,
            anchor="center", setup=setups.stdbtn_fb_friends,
            width=760, height=187,
            children={
                { class="Sprite", image="photo_overlay_fb:neighbors_ui",
                    anchor="center", x=-285, y=-11, name="fb_picture",
                },
                { class="Sprite", image="photo_overlay_fb:neighbors_ui",
                    anchor="center", x=-285, y=-11,
                },
                { class="Label", setup=setups.stdbtn_fb_friends_txt,
                    x=-210, y=-11, anchor="left",name="fb_friends_button_text",
                    text="Name of neighbor", maxWidth=380, wrapStyle="truncate",
                },
                { class="Sprite", name="neighbor_switch", image="checkbox_empty:ui",
                    anchor="center", x=250, y=-11, children={
                        { class="Sprite", name="neighbor_switch_inside", image="checkbox_full:ui",
                            anchor="center", x=0, y=0
                        }
                    }
                }
            }
        }
    }
}
