local sliceSetup = {
	description_bubble = {
		borderLeft = 25,
		borderTop = 25,
		borderRight = 25,
		borderBottom = 25
	},
}

dialogs.neighbors_message_diamonds = {
    class="NeighborsMessageDialog",
    doDarkenBackground=true,
    width=1200, height=1400,
    setup=setups.dialog_default,
    anchor="center",
    components = {
        -- Title
        { class="Label", name="dialogTitle", x=0, y=-600, anchor="center",
            textId="NEIGHBORS_TITLE",setup=setups.dialog_header_text,
        },
        -- Close Button
        { class="Button", name="close_neighbors", setup=setups.btn_close },
        -- Message
        { class="Label", name="message_title", x=0, y=-470, anchor="top",
            textId="NEIGHBORS_DIAMOND_SENT",
            setup=setups.dialog_header_text, maxWidth=1000, wrapStyle="word",
        },
        { class="Sprite", name="diamond", x= 0, y=-290, anchor="center",
            image="diamond:shift_start_ui", scaleX=1.5, scaleY=1.5,
        },
        { class="Label", name="message_explanation", x=0, y=-200, anchor="top",
            textId="NEIGHBORS_DIAMOND_SENT_EXPLAIN", textSize=60,
            setup=setups.paleblue_txt, maxWidth=800, wrapStyle="word", align="center",
            lineHeight = 100,
        },
        -- Continue button
        { class="Button", name="continue_neighbors", x=0, y=510, anchor="center", setup=setups.neighborbtn,
            label={
                class="Label", setup=setups.neighborbtn_txt,
                name="fb_friends_button_text", textId="BUTTON_CONTINUE"
            }
        },
    }
}

dialogs.friends_message_diamonds = {
    -- TODO: fill with the correct message
    class="NeighborsMessageDialog",
    doDarkenBackground=true,
    width=1200, height=1400,
    setup=setups.dialog_default,
    anchor="center",
    components = {
        -- Title
        { class="Label", name="dialogTitle", x=0, y=-600, anchor="center",
            textId="NEIGHBORS_TITLE",setup=setups.dialog_header_text,
        },
        -- Close Button
        { class="Button", name="close_friends", setup=setups.btn_close },
        -- Message
        { class="Label", name="message_title", x=0, y=-470, anchor="top",
            textId="NEIGHBORS_INVITATION_SENT",
            setup=setups.dialog_header_text, maxWidth=1000, wrapStyle="word",
        },
        { class="Sprite", name="diamond", x= 0, y=-290, anchor="center",
            image="diamond:shift_start_ui", scaleX=1.5, scaleY=1.5,
        },
        { class="Label", name="message_explanation", x=0, y=-200, anchor="top",
            textId="NEIGHBORS_INVITATION_SENT_EXPLAIN", textSize=60,
            setup=setups.paleblue_txt, maxWidth=800, wrapStyle="word", align="center",
            lineHeight = 100,
        },
        -- Continue button
        { class="Button", name="continue_friends", x=0, y=510, anchor="center", setup=setups.neighborbtn,
            label={
                class="Label", setup=setups.neighborbtn_txt,
                name="fb_friends_button_text", textId="BUTTON_CONTINUE"
            }
        },
    }
}

dialogs.neighbors_facebook_login = {
    class="NeighborsMessageDialog",
    doDarkenBackground=true,
    width=1800, height=1450,
    setup=setups.dialog_default,
    anchor="center",
    components = {
        -- Title
        { class="Label", name="dialogTitle", x=0, y=-600, anchor="center",
            textId="NEIGHBORS_TITLE",
            setup=setups.dialog_header_text,
        },
        -- Close Button
        { class="Button", name="close_login", setup=setups.btn_close },
        -- Message
        { class="Sprite", name="info", x= 0, y=-270, anchor="center",
            image="neighbours_info:neighbors_ui", scaleX=1, scaleY=1,
        },
        { class="BorderSprite", name="message_background",
            image="description_bubble:shift_start_ui",
            x=0, y=60, anchor="top", width=1400, height=300,
            setup=sliceSetup.description_bubble, children={
                { class="Label", name="message_explanation", x=0, y=10, anchor="top",
                    textId="NEIGHBORS_FACEBOOK_LOGIN", textSize=60,
                    setup=setups.dialog_header_text, maxWidth=1350, wrapStyle="word", align="center",
                    lineHeight = 60,
                },
                { class="Label", name="message_explanation", x=0, y=100, anchor="top",
                    textId="NEIGHBORS_FACEBOOK_LOGIN_TEXT", textSize=60,
                    setup=setups.paleblue_txt, maxWidth=1350, wrapStyle="word", align="center",
					textSize=50,
                },
            }
        },
        { class="Button", name="login", x=0, y=520, anchor="center",
            setup=setups.stdbtn_fb_logo, width=570,
			children={
				{class="Label", setup=setups.stdbtn_fb_txt, name="txt_button", textId="BUTTON_LOGIN", anchor="center"},
				{class="Sprite", name="diamonds_x5", image="diamonds_x5:ui", anchor="center", x=200, y=-8, scale=0.775},
			}
		},
    }
}
