local sliceSetup = {
	description_bubble = {
		borderLeft = 25,
		borderTop = 25,
		borderRight = 25,
		borderBottom = 25
	},
}

dialogs.no_diamonds = {
	class="NoDiamondsDialog",
	name="no_diamonds",
	anchor="center",
	autoCenter=true,
	setup=setups.dialog_default,
	width=1600, height=1400,
	components = {
		{class="Label", name="dialogTitle", x=0, y=-500, wrapStyle="word", maxWidth=1300, textId = "DIAMOND_NOT_ENOUGH_DIAMONDS_HEADER",setup=setups.dialog_header_text},

		{class="Sprite", name="icon_event", x=-540, y=-170, image="event_icon:metagame_ui", anchor="center"},
		{class="Sprite", name="icon_challenge", x=-200, y=-309, image="challenge_icon:metagame_ui",anchor="center"},
		{class="Sprite", name="icon_daily", x=200, y=-309, image="clock_icon:metagame_ui",anchor="center"},
		{class="Sprite", name="icon_neighbors", x=540, y=-170, image="mailbox_icon:ui",anchor="center"},


		{class="BorderSprite", name="description_layout", image="description_bubble:shift_start_ui", x=0, y=210, anchor="center", width=860, height=320,
			borderLeft = 25, borderTop = 25, borderRight = 25, borderBottom = 25,
			children={
				{class="Label", name="message", x=0, y=0, anchor="center", align="center", wrapStyle="word", maxWidth=800, textId="DIAMOND_NOT_ENOUGH_DIAMONDS",setup=setups.paleblue_txt,},
			}
		},

		{class="Button", name="map", x=0, y=495, setup=setups.stdbtn, anchor="center", width=550,
			label={class="Label", setup=setups.stdbtn_txt, name="txt_map", textId="BUTTON_MAP"}
		},

		-- Facebook login button
		{ class="Button", name="login", x=0, y=495, anchor="center",
            setup=setups.stdbtn_fb_logo, width=570,
			children={
				{class="Label", setup=setups.stdbtn_fb_txt, name="txt_button", textId="BUTTON_LOGIN", anchor="center"},
				{class="Sprite", name="diamonds_x5", image="diamonds_x5:ui", anchor="center", x=200, y=-8, scale=0.775},
			}
		},
		--
		{class="Button", name="open_neighbors", x=0, y=495, setup=setups.stdbtn_fb, anchor="center", width=550,
			children={
				{class="Label", setup=setups.stdbtn_fb_txt, name="txt_button", textId="BUTTON_NEIGHBORS", anchor="center"},
				--{class="Sprite", name="diamond", image="icon_diamond:ui", anchor="center", x=200, y=-8, scale=0.775},
			--label={class="Label", setup=setups.stdbtn_txt, name="txt_map", textId="BUTTON_NEIGHBORS"}
			}
		},
		{class="Button", name="close",setup=setups.btn_close},
	},
}

dialogs.no_diamonds_neighbors = {
	class="NoDiamondsDialog",
	name="no_diamonds",
	anchor="center",
	autoCenter=true,
	setup=setups.dialog_default,
	width=1600, height=1400,
	components = {

		{ class="Label", name="dialogTitle", x=0, y=-600, anchor="center",
			textId="NEIGHBORS_TITLE",
			setup=setups.dialog_header_text,
		},
		-- Message
		{ class="Sprite", name="info", x= 0, y=-270, anchor="center",
			image="neighbours_info:neighbors_ui", scaleX=1, scaleY=1,
		},
		{ class="BorderSprite", name="message_background",
			image="description_bubble:shift_start_ui",
			x=0, y=60, anchor="top", width=1400, height=300,
			setup=sliceSetup.description_bubble, children={
				{ class="Label", name="message_explanation", x=0, y=10, anchor="top",
					textId="NEIGHBORS_FACEBOOK_LOGIN", textSize=60,
					setup=setups.dialog_header_text, maxWidth=1350, wrapStyle="word", align="center",
					lineHeight = 60,
				},
				{ class="Label", name="message_explanation", x=0, y=100, anchor="top",
					textId="NEIGHBORS_FACEBOOK_LOGIN_TEXT", textSize=60,
					setup=setups.paleblue_txt, maxWidth=1350, wrapStyle="word", align="center",
					textSize=50,
				},
			}
		},

		{class="Button", name="map", x=0, y=495, setup=setups.stdbtn, anchor="center", width=550,
			label={class="Label", setup=setups.stdbtn_txt, name="txt_map", textId="BUTTON_MAP"}
		},

		-- Facebook login button
		{ class="Button", name="login", x=0, y=495, anchor="center",
            setup=setups.stdbtn_fb_logo, width=570,
			children={
				{class="Label", setup=setups.stdbtn_fb_txt, name="txt_button", textId="BUTTON_LOGIN", anchor="center"},
				{class="Sprite", name="diamonds_x5", image="diamonds_x5:ui", anchor="center", x=200, y=-8, scale=0.775},
			}
		},
		--
		{class="Button", name="open_neighbors", x=0, y=495, setup=setups.stdbtn_fb, anchor="center", width=550,
			children={
				{class="Label", setup=setups.stdbtn_fb_txt, name="txt_button", textId="BUTTON_NEIGHBORS", anchor="center"},
				--{class="Sprite", name="diamond", image="icon_diamond:ui", anchor="center", x=200, y=-8, scale=0.775},
			--label={class="Label", setup=setups.stdbtn_txt, name="txt_map", textId="BUTTON_NEIGHBORS"}
			}
		},
		{class="Button", name="close",setup=setups.btn_close},
	},
}
