local secretGame_useSound = true

SecretGame = deriveLuaClass("SecretGame", "DelScene")

local Tweakables = {
	AccelerationStart = 0.000004,	-- 4px/s
	AccelerationMax = 0.000011,	-- 11px/s
	SpeedStart = 0.8,			-- 800px/s
	SpeedMax = 2,				-- 4000px/s
	LevelMax = 20,
	JumpHeightUnits = 1.5,
	DirtyJumpHeightUnits = 0.9,
	DoubleJumpHeightUnits = 2,
	JumpDistanceUnits = 3.5,
	DoubleJumpDistanceUnits = 4.5,
	ChunkRandomSearchRadiusDivider = 4, 	--
	LevelupAfterXChunks = 10,				--
	CalculateSpeedBoostWater = function(SecretGameInstance)
		return SecretGameInstance.acceleration * 5000
	end,
	CalculateSpeedDecreaseDirt = function(SecretGameInstance)
		return SecretGameInstance.acceleration * 5000
	end,
	VerticalGroundOffset = -120,
	HayBaleShadowHeight = 70,
}
SecretGame.levelChunks = {
	tutorials = {
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"     H    \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"      C   \n" ..
			"          \n" ..
			"          \n" ..
			"  H       \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"      C   \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"    H     \n" ..
			"==========\n"
		,
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                  C \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"    H               \n" ..
			"======____==========\n"
		,
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                  C \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"====~~~~~~~~~=======\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"====~~====\n"
		,
	},
	chunks = {
		-- EASY
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"   H    \n" ..
		"========\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"   C    \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"   H    \n" ..
		"========\n",

		"        \n" ..
		"     C  \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"    H   \n" ..
		"========\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"   C    \n" ..
		"        \n" ..
		"    C   \n" ..
		"   H    \n" ..
		"========\n",

		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"     C \n" ..
		"       \n" ..
		"       \n" ..
		"     H \n" ..
		"=~=====\n",

		"        \n" ..
		"   C    \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"  C     \n" ..
		"        \n" ..
		"    C   \n" ..
		"  H     \n" ..
		"========\n",

		"       \n" ..
		"       \n" ..
		"       \n" ..
		"    T  \n" ..
		"       \n" ..
		"       \n" ..
		"   C   \n" ..
		"       \n" ..
		"       \n" ..
		"   H   \n" ..
		"====__=\n",

		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"    C  \n" ..
		"       \n" ..
		"       \n" ..
		" C     \n" ..
		"       \n" ..
		"  H    \n" ..
		"=======\n",

		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"      C   \n" ..
		"          \n" ..
		"   T  H   \n" ..
		"===~======\n",

		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"    C  \n" ..
		"       \n" ..
		"   CH  \n" ..
		"=___===\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"     C  \n" ..
		"        \n" ..
		"  H   H \n" ..
		"========\n",

		"          \n" ..
		"     T    \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"   C      \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"    H     \n" ..
		"=~~~======\n",

		"          \n" ..
		"          \n" ..
		"          \n" ..
		"       T  \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"      C   \n" ..
		"          \n" ..
		"      H   \n" ..
		"===___====\n",

		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"     C       \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		" H   H   HC  \n" ..
		"======_===~==\n",

		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"      T      \n" ..
		"          T  \n" ..
		"             \n" ..
		"  H   H   H  \n" ..
		"===___=___===\n",



		-- NORMAL
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"  C     \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"  H   H \n" ..
		"========\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"     T  \n" ..
		"    H   \n" ..
		"=___====\n",

		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"  C    C  \n" ..
		"          \n" ..
		"          \n" ..
		"  H    H  \n" ..
		"====~~====\n",

		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"          C  \n" ..
		"             \n" ..
		"      C      \n" ..
		"             \n" ..
		"  C          \n" ..
		"      H   H  \n" ..
		"=============\n",

		"           \n" ..
		"           \n" ..
		"           \n" ..
		"     T     \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"  C     C  \n" ..
		"   H     H \n" ..
		"==~==_==~==\n",

		"         \n" ..
		"         \n" ..
		"         \n" ..
		"         \n" ..
		"         \n" ..
		"         \n" ..
		"         \n" ..
		"         \n" ..
		"    T    \n" ..
		"  H   H  \n" ..
		"===___===\n",

		"            \n" ..
		"            \n" ..
		"      T     \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		" C       C  \n" ..
		"  H   H   H \n" ..
		"=~===_===~==\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"   CHH  \n" ..
		"=~~~====\n",

		"          \n" ..
		"        C \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"          \n" ..
		"    C     \n" ..
		"          \n" ..
		" T  H   H \n" ..
		"=_========\n",

		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"         C \n" ..
		"           \n" ..
		"           \n" ..
		"    HH T   \n" ..
		"=~~~===_===\n",

		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"    HH  THH \n" ..
		"=~~~========\n",

		"             \n" ..
		"             \n" ..
		"      T      \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"   C     C   \n" ..
		"  C       C  \n" ..
		"   H     H   \n" ..
		"=====___=====\n",

		"            \n" ..
		"            \n" ..
		"            \n" ..
		"        C   \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"   C        \n" ..
		"    HH THHT \n" ..
		"=~~~======_=\n",

		"            \n" ..
		"   CC  CC   \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"            \n" ..
		"  CHH CHH T \n" ..
		"==~=======_=\n",

		-- HARD
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		" C     \n" ..
		"       \n" ..
		"  H  H \n" ..
		"=======\n",

		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		"           \n" ..
		" C  C  C   \n" ..
		"  HC HC H  \n" ..
		"=~=========\n",

		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"             \n" ..
		"  C       T  \n" ..
		"             \n" ..
		"     C C     \n" ..
		"  H       H  \n" ..
		"===_______===\n",

		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"     HH  HH  HH  HH \n" ..
		"=~~~~===============\n",

		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		"       \n" ..
		" C     \n" ..
		"       \n" ..
		"  H  H \n" ..
		"=======\n",

		"             \n" ..
		"             \n" ..
		"             \n" ..
		"            T\n" ..
		"             \n" ..
		"             \n" ..
		"           C \n" ..
		" C           \n" ..
		"             \n" ..
		"     H  H  H \n" ..
		"=_===========\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"  CHHC  \n" ..
		"=__=====\n",

		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"        \n" ..
		"  THHT  \n" ..
		"=__==~~=\n",

		"                    \n" ..
		"                  T \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"              C     \n" ..
		"                    \n" ..
		" C                  \n" ..
		"    T    T          \n" ..
		"  H  H  H  H  H  H  \n" ..
		"===__==========~~===\n",

		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"                    \n" ..
		"  H  H  H  H  H  H  \n" ..
		"=~=============__===\n",
	},
	fillers = {
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"==========\n",
	},
	poor = {
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"     C    \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"     C    \n" ..
			"          \n" ..
			"          \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"====__====\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"====~~====\n"
		,
			"          \n" ..
			"     C    \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"     C    \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"====__====\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"       C  \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"==========\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"===_==~===\n"
		,
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"   C      \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"======_===\n"
		,
	},
	rich = {
			"        \n" ..
			"    C   \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"   C C  \n" ..
			"        \n" ..
			"        \n" ..
			"    C   \n" ..
			"        \n" ..
			"========\n"
		,
			"         \n" ..
			"         \n" ..
			"         \n" ..
			"         \n" ..
			"         \n" ..
			"    C    \n" ..
			"         \n" ..
			"   C C   \n" ..
			" C     C \n" ..
			"  T T T  \n" ..
			"===~=~===\n"
		,
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			" CC  CC \n" ..
			"   TT   \n" ..
			"===~~===\n"
		,
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			" CC  CC \n" ..
			"        \n" ..
			"        \n" ..
			"        \n" ..
			"   TT   \n" ..
			"===__===\n"
		,
			"          \n" ..
			"     T  T \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"          \n" ..
			"    C  C  \n" ..
			"          \n" ..
			"=~~~======\n"
		,
			"         \n" ..
			"   C C   \n" ..
			"         \n" ..
			"  C C C  \n" ..
			"         \n" ..
			"         \n" ..
			"         \n" ..
			"         \n" ..
			"         \n" ..
			"    T    \n" ..
			"=__======\n"
		,
			"   T       T     \n" ..
			"       C       C \n" ..
			"   C       C     \n" ..
			"       C       C \n" ..
			"   C       C     \n" ..
			"       C       C \n" ..
			"   C       C     \n" ..
			"       C       C \n" ..
			"   C       C     \n" ..
			"       T       T \n" ..
			"=~~~____~~~~____=\n"
		,
			"  CC  CC  \n" ..
			"          \n" ..
			"  CC  CC  \n" ..
			"          \n" ..
			" C  CC  C \n" ..
			"          \n" ..
			" C  CC  C \n" ..
			"          \n" ..
			" C  CC  C \n" ..
			"          \n" ..
			"=~~====__=\n"
		,
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"                    \n" ..
			"    T   T   T   T   \n" ..
			"=__________________=\n"
		,
			"                                 \n" ..
			" CC  CCC C   C CCC C CCC C C CCC \n" ..
			"                                 \n" ..
			" C C C   C   C C   C C C C C C   \n" ..
			"                                 \n" ..
			" C C CC  C   C C   C C C C C CCC \n" ..
			"                                 \n" ..
			" C C C   C   C C   C C C C C   C \n" ..
			"                                 \n" ..
			" CC  CCC CCC C CCC C CCC CCC CCC \n" ..
			"=================================\n"
		,
	},
}

function SecretGame.createClickableMapIcon(parent, world, source)
	local unEp = player.unlockedEpisode
	if ((unEp == 6 and player.unlockedShift > 7+4) or unEp > 6) then
		local icon = source.parent:addChild({class="Button", image="pin5:room5_map", x=source.x, y=source.y, anchor=source.anchor, pivot=source.pivot, setup=setups.btn, downScale=1, highlightAlpha=0.0})
		source.visible = false
		icon.onClick = function()
			if (not scene.secretGameTimerPaused) then
				SecretGame.createAndStart(world, true)
				icon:animate({duration=2000,wobble={startRot=0.2,startRotMax=-0.2,endRot=0,endRotMax=0,loops=15},style="easeInOut"})
				parent:addChild({class="ParticleEffect", x=icon.x, y=icon.y, library="effects:particles", emitter="click_fix", play=true, scale=3})
			else
				icon:animate({duration=1000,wobble={startRot=0.1,startRotMax=-0.1,endRot=0,endRotMax=0,loops=4},style="easeInOut"})
			end
			scene.sendMiniGameStartedEvent(self)
		end
		icon:doEvery(15*1000, function()
			icon:animate({duration=1000,wobble={startRot=0.05,startRotMax=-0.05,endRot=0,endRotMax=0,loops=4},style="easeInOut"})
			return math.Random(1*60*1000, 3*60*1000)
		end)

		print ("clickable pin created")
	end
end

function SecretGame.createAndStart(world, fromClick)
	scene.secretGameTimerPaused = true
	local secretGame = GH.createScene("secret")
	GH.setTransition("defaultTransition")
	GH.gotoScene(secretGame)
	return math.Random(10*1000, 60*1000)
end

scenes.secret = {
	class = "SecretGame",
}

function SecretGame:calculatePositions()
	self.uw = GH.getUnitWidth()
	self.uh = GH.getUnitHeight()

	self.screenCenter = {self.uw / 2, self.uh / 2}
	self.floorPosition = (self.uh / 5) * 4.25
	self.haybaleUnit = 200

	self.continueButton.x = self.uw-10
	self.continueButton.y = self.uh-10

	if (self.blackBackground) then
		self.blackBackground.width = self.uw
		self.blackBackground.height = self.uh
	end
end

function SecretGame:onShow()

	self.backButton = self:addChild({class="Button", image="button_back:gamescene", anchor="topLeft", onClick=function() self:onCloseButtonClicked() end})
	self.continueButton = self:addChild({class="Button", anchor="bottomRight", onClick=function() self:onContinueButtonClicked() end, visible=false, setup=setups.stdbtn,
			label={class="Label", setup=setups.stdbtn_txt, name="txt_button", textId="BUTTON_CONTINUE"}
		})
	self.distanceTextLabel = self:addChild({class="Label", setup=setups.outline, anchor="right", textSize=90, textId="SCORE", alpha=1})
	self.distanceLabel = self:addChild({class="Label", setup=setups.outline, anchor="left", textSize=90, alpha=1})
	self.gameLogo = self:addChild({class="Sprite", image="logo:minigame", anchor="top", x= GH.getUnitWidth()*0.5, y=GH.getUnitHeight()*0.15})
	self.startGameLabel = self:addChild({class="Label", setup=setups.outline, anchor="bottom", textSize=60, textId="CLICK_TO_CONTINUE", alpha=1})

	-- debug
	--[[
	self.pixelsRanLabel = self:addChild({class="Label", setup=setups.outline, anchor="left", textSize=40, alpha=1})
	self.speedLabel = self:addChild({class="Label", setup=setups.outline, anchor="left", textSize=40, alpha=1})
	self.accLabel = self:addChild({class="Label", setup=setups.outline, anchor="left", textSize=40, alpha=1})
	self.stateLabel = self:addChild({class="Label", setup=setups.outline, anchor="left", textSize=40, alpha=1})
	self.actionLabel = self:addChild({class="Label", setup=setups.outline, anchor="left", textSize=40, alpha=1})
	--]]
	-- debug end

	self.trufflesOffset = {-512,0}
	self.trufflesAnimOffset = {x=0,y=42} -- new
	self.paigeOffset = {0, 0}
	self.paigeAnimOffset = {x=0,y=76} -- new
	self.pixelsMovedPerCycle = 400
	self.moveCycleFrameCount = 12
	self.pixelsMovedPerFrame = self.pixelsMovedPerCycle / self.moveCycleFrameCount

	self.dustParticleEmitter = "click_fix"
	self.blingParticleEmitter = "event_done_blast"
	self.dustParticleOffset = {-30, -330}

	self.isMouseDownTimer = 0
	self.maxSecretScores = 6
	self.maxScoreNameLength = 14

	self.sounds = {
		GameStart = "episode_start",
		GameEnd = "pinata",
		LoopRunGrass = "rest1_grab_apple",
		HitMud = "rest3_add_fruit_jam_to_jar",
		HitWater = "sfx_throw_bottle_in_ocean",
		HitHaybale = "travelpreperations_thud",
		JumpHaybale = "coin1",
		HitSmallPickup = "coin2",
		HitBigPickup = "coin3",
		Jump = "rest_6_grab_wreath",
		DoubleJump = "sfx_little_emily_find",
		DoubleJumpEnd = "remove_hat",
		JumpEnd = "rest3_grab_banana",
		SpeedBoost = "food_to_tray"
	}

	self:calculatePositions()
	self.gameStarting = false
    self:restartGame(true)
end

function SecretGame:playSound(sound_id)
	SpriteExt.playSample(self.truffles.anims.run, self.sounds[sound_id])
end

function SecretGame:layout()
	self:calculatePositions()

	self.backButton.x = 10
	self.backButton.y = 10

	self:updateLabelPositions()
end

function SecretGame:updateLabelPositions(forced)
	local ly = self.distanceTextLabel.height/2 + 150

	self.distanceTextLabel:relocateAnchor("right")
	self.distanceTextLabel.x = GH.getUnitWidth()*0.5 + 50
	self.distanceTextLabel.y = ly
	self.distanceTextLabel.alpha = 100

	self.distanceLabel.scale=1
	self.distanceLabel:relocateAnchor("left")
	self.distanceLabel.x = GH.getUnitWidth()*0.5 + 100
	self.distanceLabel.y = ly
	self.distanceLabel.alpha = 100

	self.startGameLabel.x = GH.getUnitWidth()*0.5 + 50
	self.startGameLabel.y = GH.getUnitHeight() - self.startGameLabel.height

	-- debug
	--[[
	self.pixelsRanLabel.x = 100
	self.pixelsRanLabel.y = 200

	self.speedLabel.x = 100
	self.speedLabel.y = self.pixelsRanLabel.y + 50

	self.accLabel.x = 100
	self.accLabel.y = self.speedLabel.y + 50

	self.stateLabel.x = 100
	self.stateLabel.y = self.accLabel.y + 50

	self.actionLabel.x = 100
	self.actionLabel.y = self.stateLabel.y + 50
	--]]
	-- debug end

	--self.coinsLabel.x = self.uw - 20
	--self.coinsLabel.y = 70
	--self.coinScoreSprite.x = self.coinsLabel.left - 100
	--self.coinScoreSprite.y = 70
end

function SecretGame:calculateJumpDurations()
	self.paigeJumpDuration = self.haybaleUnit*Tweakables.DoubleJumpDistanceUnits / (self.levelSpeed)
	self.trufflesJumpDuration = self.haybaleUnit*Tweakables.JumpDistanceUnits / (self.levelSpeed)
end

function SecretGame:restartGame(firstTime)
	self.playing = false
	self.died = false

	self.levelGenerateState = {
		floorAddPositionPointer = -128,
		lastFloorTypeCount = 0,
		lastFloorType = -1,
		currentGroup = "fillers",
		currentIndex = 1,
		currentSecondIndex = nil,
		currentColumn = 1,
	}


	-- show logo and start text
	self.gameLogo:animate(
		{y=GH.getUnitHeight()*0.15, alpha=1, duration=500, style="easeIn"},
		{call=function()
			self.gameStarting = false
		end})
	self.startGameLabel:animate({alpha=1, duration=500, style="easeIn"})

	self.distanceTextLabel.visible = false
	self.distanceLabel.visible = false

	self.gameTime = 0
	self.gamePoints = 0
	self.obstacleCatchPoints = 1
	self.fruitCatchPoints = 2
	self.truffleCatchPoints = 5

	self.metersRan = 0
	self.pixelsRan = 0

	self.acceleration = Tweakables.AccelerationStart
	self.levelSpeed = Tweakables.SpeedStart
	self.chunkChangeCount = 0
	self.chunkChangeCountLevel = 0

	self.paigeJumpDuration = self.haybaleUnit*Tweakables.DoubleJumpDistanceUnits
	self.paigeJumpHeight = self.haybaleUnit*Tweakables.DoubleJumpHeightUnits
	self.trufflesJumpDuration = self.haybaleUnit*Tweakables.JumpDistanceUnits
	self.trufflesJumpHeight = self.haybaleUnit*Tweakables.JumpHeightUnits

	self.verticalGroundOffset = Tweakables.VerticalGroundOffset

	self.difficultyLevel = 1

	self.timeSinceLastFrameChange_Run = 0
	self.positionSinceLastFrameChange_Run = 0
	self.obstacleMinInterval = 1200
	self.obstacleMaxInterval = 3000
	self.nextObstacle = math.Random(self.obstacleMinInterval, self.obstacleMaxInterval)

	--self.background = self:addComponent({class="Sprite", draw="color", color=0xffffffff, width=self.uw, height=self.uh, x=0, y=0, anchor="topLeft"})

	self.bgLayer = self:addComponent({class="GameNode"})
	self.midLayer0 = self:addComponent({class="GameNode"})
	self.midLayer1 = self:addComponent({class="GameNode"})
	self.midLayer2 = self:addComponent({class="GameNode"})
	self.level = self:addComponent({class="GameNode", x=0, y=0, anchor="topLeft"})
	self.floors = {}
	self.pixelSchedule = {}

	if (firstTime) then

	end

	self:undoOnce()
	self.onceDone = false
	self:doOnce()

	self.truffles.anims.run.currentFrame = 0
	self.truffles.anims.rundirty.currentFrame = 0
	self.truffles.anims.runpaigeless.currentFrame = 0
	self.truffles.anims.runpaigelessdirty.currentFrame = 0
	self.paige.anims.jump.currentFrame = 0

	self.truffles.setAnimationBasedOnState()
	self.paige.setAnimationBasedOnState()

	self:updateLabelPositions(true)
	--self:generateFloor()
	self:calculateJumpDurations()

end

function SecretGame:scheduleAt(at, f)
	self.pixelSchedule[math.floor(at)] = f
	-- print ("scheduled at " .. at)
end

function SecretGame:updateSchedule()
	for k, v in pairs(self.pixelSchedule) do
		if (tonumber(k) < tonumber(self.pixelsRan) and v ~= nil) then
			self.pixelSchedule[k]()
			self.pixelSchedule[k] = nil
			table.remove_item(self.pixelSchedule, k)
		end
	end
end

function SecretGame:getAvailableSpriteFromPool(type)
	for k, v in ipairs(self.spritePool) do
		if v.type == type and not v.isUsed then
			v.isUsed = true
			v.visible = true
			v.active = true
			return v
		end
	end

	return nil
end

local function inQuad(t, b, c, d)
  t = t / d
  return c * math.pow(t, 2) + b
end

local function outQuad(t, b, c, d)
  t = t / d
  return -c * t * (t - 2) + b
end

local function inQuart(t, b, c, d)
  t = t / d
  return c * math.pow(t, 4) + b
end

local function outQuart(t, b, c, d)
  t = t / d - 1
  return -c * (math.pow(t, 4) - 1) + b
end

function SecretGame:jumpEase(t)
	local b = 0
	local c = 1
	local d = 1

	if t < d / 2 then
    return outQuart (t * 2, b, c / 2, d)
  else
    return inQuad((t * 2) - d, b + c / 2, c / 2, d)
  end
end

function SecretGame:doOnce()
	if (not self.onceDone) then
		self.spritePool = {
			self.level:addChild({class="Sprite", image="bush_00:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_01:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_00:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_01:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_00:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_01:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_00:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),
			self.level:addChild({class="Sprite", image="bush_01:minigame", y=-300, x=0, anchor="center", isUsed=false, type=50, }),

			-- ground blocks should have anchor set to 'top'
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_grass:minigame", y=-300, x=0, anchor="top", isUsed=false, type=1, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_mud:minigame", y=-300, x=0, anchor="top", isUsed=false, type=2, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			self.level:addChild({class="Sprite", image="floor_water:minigame", y=-300, x=0, anchor="top", isUsed=false, type=3, }),
			-- other elements should have anchor to 'bottom'
			self.level:addChild({class="Sprite", image="obstacle_hay:minigame", y=-300, x=0, anchor="bottom", isUsed=false, type=10,}),
			self.level:addChild({class="Sprite", image="obstacle_hay:minigame", y=-300, x=0, anchor="bottom", isUsed=false, type=10,}),
			self.level:addChild({class="Sprite", image="obstacle_hay:minigame", y=-300, x=0, anchor="bottom", isUsed=false, type=10,}),
			self.level:addChild({class="Sprite", image="obstacle_hay:minigame", y=-300, x=0, anchor="bottom", isUsed=false, type=10,}),
			self.level:addChild({class="Sprite", image="obstacle_hay:minigame", y=-300, x=0, anchor="bottom", isUsed=false, type=10,}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#fruit3-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=20, active=false}),
			self.level:addChild({class="Sprite", image="button#truffle1-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=21, active=false}),
			self.level:addChild({class="Sprite", image="button#truffle1-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=21, active=false}),
			self.level:addChild({class="Sprite", image="button#truffle1-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=21, active=false}),
			self.level:addChild({class="Sprite", image="button#truffle1-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=21, active=false}),
			self.level:addChild({class="Sprite", image="button#truffle1-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=21, active=false}),
			self.level:addChild({class="Sprite", image="button#truffle1-b:room5_icons", y=-300, x=0, anchor="bottom", isUsed=false, type=21, active=false}),
		}

		self.background = {
			self.bgLayer:addChild({class="Sprite", image="background:minigame", x=0}),
			self.bgLayer:addChild({class="Sprite", image="background:minigame", x=2047})
		}

		-- self.backgrounds = {
		-- 	self.bgLayer:addChild({class="Sprite", image="background:minigame", x=-3000}),
		-- 	self.bgLayer:addChild({class="Sprite", image="background:minigame", x=-3000}),
		-- 	self.bgLayer:addChild({class="Sprite", image="background:minigame", x=-3000}),
		-- }



		self.midgrounds = {
			{
				self.midLayer0:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_3:minigame"}
					}}),
				self.midLayer0:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_3:minigame"}
					}}),
				self.midLayer0:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_3:minigame"}
					}})
			},
			{
				self.midLayer1:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_2:minigame"},
						{class="Sprite", image="house:minigame", x=1800, y=850, scale=1, anchor="center"}
					}}),
				self.midLayer1:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_2:minigame"},
						{class="Sprite", image="house:minigame", x=300, y=780, scale=1, anchor="center"}
					}}),
				self.midLayer1:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_2:minigame"}
					}})
			},
			{
				self.midLayer2:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_1:minigame", y=200},
						{class="Sprite", image="tree_00:minigame", x=530, y=1160, anchor="bottom", scale=1.0 + math.__old_random()*0.3 - 0.15},
					}}),
				self.midLayer2:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_1:minigame", y=200},
						{class="Sprite", image="tree_00:minigame", x=1024, y=1200, anchor="bottom", scale=1.0 + math.__old_random()*0.3 - 0.15}
					}}),
				self.midLayer2:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_1:minigame", y=200},
						{class="Sprite", image="bush_background:minigame", x=1424, y=1100, anchor="center", scale=1.0 + math.__old_random()*0.3 - 0.15}
					}}),
				self.midLayer2:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_1:minigame", y=200},
						{class="Sprite", image="tree_00:minigame", x=1530, y=1160, anchor="bottom", scale=1.0 + math.__old_random()*0.3 - 0.15},
						{class="Sprite", image="tree_00:minigame", x=1300, y=1180, anchor="bottom", scale=1.0 + math.__old_random()*0.3 - 0.15},
					}}),
				self.midLayer2:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_1:minigame", y=200},
						{class="Sprite", image="bush_background:minigame", x=1424, y=1050, anchor="center", scale=1.0 + math.__old_random()*0.3 - 0.15}
					}}),
				self.midLayer2:addChild({
					class="GameNode", isUsed=false, x=-3000, width=2048, children={
						{class="Sprite", image="middleground_1:minigame", y=200},
						{class="Sprite", image="tree_00:minigame", x=1800, y=1200, anchor="bottom", scale=1.0 + math.__old_random()*0.3 - 0.15},
						{class="Sprite", image="bush_background:minigame", x=500, y=950, anchor="center", scale=1.0 + math.__old_random()*0.3 - 0.15}
					}})
			},
			{

			}
		}

		self.truffles = self:addComponent({
			class="GameNode", anchor="bottom", x=self.screenCenter[1] + self.trufflesOffset[1], y = self.floorPosition + self.trufflesOffset[2],
			children = {
				{name="_run", class="SpriteExt", baseAnimation="truffles_run_paige_v2_c:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_run-paigeless", class="SpriteExt", baseAnimation="truffles_run_v2_c:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_run-dirty", class="SpriteExt", baseAnimation="truffles_run_paige_v2_d:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_run-paigeless-dirty", class="SpriteExt", baseAnimation="truffles_run_v2_d:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_jump", class="SpriteExt", baseAnimation="truffles_jump_paige_c_r2:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y + 30, currentFrame=0},
				{name="_jump-paigeless", class="SpriteExt", baseAnimation="truffles_jump_c_r2:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y + 30, currentFrame=0},
				{name="_jump-dirty", class="SpriteExt", baseAnimation="truffles_jump_paige_d_r2:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y + 30, currentFrame=0},
				{name="_jump-paigeless-dirty", class="SpriteExt", baseAnimation="truffles_jump_d_r2:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y + 30, currentFrame=0},
				{name="_slide", class="SpriteExt", baseAnimation="truffles_slide_paige:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_slide-paigeless", class="SpriteExt", baseAnimation="truffles_slide:truffles", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_slide-dirty", class="SpriteExt", baseAnimation="truffles_dirty_slide_paige:truffles_dirty", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
				{name="_slide-paigeless-dirty", class="SpriteExt", baseAnimation="truffles_dirty_slide:truffles_dirty", visible=false, anchor="bottom", x=self.trufflesAnimOffset.x, y=self.trufflesAnimOffset.y, currentFrame=0},
			}
		})

		self.truffles.anims = {
			run = self.truffles:getChild("_run"),
			runpaigeless = self.truffles:getChild("_run-paigeless"),
			rundirty = self.truffles:getChild("_run-dirty"),
			runpaigelessdirty = self.truffles:getChild("_run-paigeless-dirty"),
			jump = self.truffles:getChild("_jump"),
			jumppaigeless = self.truffles:getChild("_jump-paigeless"),
			jumpdirty = self.truffles:getChild("_jump-dirty"),
			jumppaigelessdirty = self.truffles:getChild("_jump-paigeless-dirty"),
			slide = self.truffles:getChild("_slide"),
			slidepaigeless = self.truffles:getChild("_slide-paigeless"),
			slidedirty = self.truffles:getChild("_slide-dirty"),
			slidepaigelessdirty = self.truffles:getChild("_slide-paigeless-dirty"),
		}


		self.truffles.state = {
			jumping = false,
			jumpStart = 0,
			jumpRatio = 0,
			sliding = false,
			paigeless = false,
			dirty = false
		}


		-- shadow
		self.trufflesShadow = self:addComponent({name="shadow", class="SpriteExt", baseAnimation="large_shadow:characters", anchor="center", x=self.screenCenter[1] + self.trufflesOffset[1] - 10, y = self.floorPosition + self.trufflesOffset[2]})

		-- splashes
		self.splashes = self:addComponent({
			class="GameNode", anchor="bottom", x=self.screenCenter[1] + self.trufflesOffset[1], y = self.floorPosition + 30,
			children = {
				{name="water_splash", class="SpriteExt", baseAnimation="water_splash:minigame", anchor="bottomRight", frameTime=50, visible=false, currentFrame=0},
				{name="mud_splash", class="SpriteExt", baseAnimation="mud_splash:minigame", anchor="bottomRight", frameTime=50, visible=false, currentFrame=0},
			}
		})

		self.splashes.trufflesWaterSplash = self.splashes:getChild("water_splash")
		self.splashes.trufflesMudSplash = self.splashes:getChild("mud_splash")

		self.truffles.setAnimationBasedOnState = function()
			local animName = ""

			if(self.truffles.state.jumping) then
				animName = "jump"
			elseif (self.truffles.state.sliding) then
				animName = "slide"
			else
				animName = "run"
			end

			if (self.truffles.state.paigeless) then
				animName = animName .. "paigeless"
			end
			if (self.truffles.state.dirty) then
				animName = animName .. "dirty"
			end

			-- comment: movement logic was separated from sprites logic
			if (self.truffles.state.jumping) then
				if (self.truffles.state.jumpRatio < 0.5) then
					self.truffles.anims[animName].currentFrame = 2
				else
					self.truffles.anims[animName].currentFrame = 3
				end

				--[[local halfJumpRatio = ((self.truffles.state.jumpRatio * 2.0) % 1.0)
				if (self.truffles.state.jumpRatio < 0.5) then
					--jumping up
					--self.truffles.anims[animName].y = halfJumpRatio * self.trufflesJumpHeight * -1
				else
					--jumping down
					--self.truffles.anims[animName].y = (1.0 - halfJumpRatio) * self.trufflesJumpHeight * -1
				end--]]
			end

			for k, v in pairs(self.truffles.anims) do
				if (animName == k) then
					v.visible = true
				else
					v.visible = false
					--v.y = 0 -- new; not needed anymore
				end
			end

		end

		self.truffles.setCurrentFrame = function(frame)
			self.truffles.anims.run.currentFrame = frame
			self.truffles.anims.rundirty.currentFrame = frame
			self.truffles.anims.runpaigeless.currentFrame = frame
			self.truffles.anims.runpaigelessdirty.currentFrame = frame
		end


		self.paige = self:addComponent({
			class="GameNode", anchor="bottom", x=self.truffles.x + self.paigeOffset[1], y = self.truffles.y - self.haybaleUnit*0.5,
			children = {
				{name="_jump", class="SpriteExt", baseAnimation="paige_jump:paige", visible=false, anchor="bottom", x=self.paigeAnimOffset.x, y=self.paigeAnimOffset.y},
				{name="_jump-dirty", class="SpriteExt", baseAnimation="paige_jump_dirty:truffles_dirty", visible=false, anchor="bottom", x=self.paigeAnimOffset.x, y=self.paigeAnimOffset.y},
				-- {name="run", class="SpriteExt", baseAnimation="run:minigame-characters-paige", vsisible=false, anchor="bottom"},
				-- {name="jump_up", class="SpriteExt", baseAnimation="jump_up:minigame-characters-paige", visible=false, anchor="bottom"},
				-- {name="jump_down", class="SpriteExt", baseAnimation="jump_down:minigame-characters-paige", visible=false, anchor="bottom"},
				-- {name="slide", class="SpriteExt", baseAnimation="slide:minigame-characters-paige", visible=false, anchor="bottom", y=50},
				-- {name="fly_up", class="SpriteExt", baseAnimation="fly_up:minigame-characters-paige", visible=false, anchor="bottom"},
				-- {name="fly_down", class="SpriteExt", baseAnimation="fly_down:minigame-characters-paige", visible=false, anchor="bottom"},
			}
		})

		self.midLayer3 = self:addComponent({class="GameNode"})
		table.insert(
			self.midgrounds[4],
			self.midLayer3:addChild({
				class="GameNode", isUsed=false, x=-3000, width=self.uw, y=self.uh + 50, children={
					{class="Sprite", image="bush__foreground_00:minigame", x=200, y=0, anchor="bottom"},
					{class="Sprite", image="bush__foreground_00:minigame", x=400, y=40, anchor="bottom"},
					{class="Sprite", image="bush__foreground_00:minigame", x=1200, y=10, anchor="bottom"},
					{class="Sprite", image="bush__foreground_00:minigame", x=1700, y=20, anchor="bottom"}
				}
			})
		)
		table.insert(
			self.midgrounds[4],
			self.midLayer3:addChild({
				class="GameNode", isUsed=false, x=-3000, width=self.uw, y=self.uh + 50, children={
					{class="Sprite", image="bush__foreground_00:minigame", x=200, y=50, anchor="bottom"}
				}
			})
		)
		table.insert(
			self.midgrounds[4],
			self.midLayer3:addChild({
				class="GameNode", isUsed=false, x=-3000, width=self.uw, y=self.uh + 50, children={
					{class="Sprite", image="bush__foreground_00:minigame", x=400, y=0, anchor="bottom"}
				}
			})
		)

		self.paige.anims = {
			jump = self.paige:getChild("_jump"),
		}

		-- self.paige.run = self.paige:getChild("run")
		-- self.paige.jump_up = self.paige:getChild("jump_up")
		-- self.paige.jump_down = self.paige:getChild("jump_down")
		-- self.paige.fly_up = self.paige:getChild("fly_up")
		-- self.paige.fly_down = self.paige:getChild("fly_down")
		-- self.paige.slide = self.paige:getChild("slide")
		-- self.paige.run.currentFrame = 0

		self.paige.state = {
			jumping = false,
			jumpStart = 0
		}

		self.truffles.control = {

			isTouchingGround = function()
				return math.floor(self.truffles.y + self.haybaleUnit*0.5,1) >= math.floor(self.floorPosition - self.trufflesOffset[2],1)
			end,

			jump = function()
				if (not self.truffles.state.jumping) then

					-- comment: setting jump height for Truffles depending on the dirty state
					-- new
					if (not self.truffles.state.dirty) then
						self.trufflesJumpHeight = self.haybaleUnit*Tweakables.JumpHeightUnits
					else
						self.trufflesJumpHeight = self.haybaleUnit*Tweakables.DirtyJumpHeightUnits
					end

					self.truffles.state.jumping = true
					self.truffles.state.jumpStart = self.gameTime
					self.truffles.state.jumpRatio = 0

					self:playSound("Jump")

				end
			end,

			update = function()
				if (self.truffles.state.jumping) then
					local jumpRatio = (self.gameTime - self.truffles.state.jumpStart) / self.trufflesJumpDuration
					jumpRatio = self:jumpEase(jumpRatio)

					if (jumpRatio >= 1) then
						jumpRatio = 1
						self.truffles.y = self.floorPosition + self.trufflesOffset[2]

						self.truffles.state.jumping = false

						self:playSound("DoubleJumpEnd")

						self.trufflesShadow.scale = 1.0
						self.trufflesShadow.alpha = 1.0

						self:dustAt(self.truffles.anims.run, 3.0)
					elseif (jumpRatio < 1) then
						self.truffles.state.jumpRatio = jumpRatio

						if (self.truffles.state.jumpRatio < 0.5) then
							--jumping up
							self.truffles.y = (self.floorPosition + self.trufflesOffset[2]) - (self.truffles.state.jumpRatio)*2 * self.trufflesJumpHeight
							-- update shadow size
							local scale = 1.0 - 0.7*(jumpRatio*2)
							self.trufflesShadow.scale = scale
							self.trufflesShadow.alpha = scale
						else
							--jumping down
							self.truffles.y = (self.floorPosition + self.trufflesOffset[2]) - (1.0 - (self.truffles.state.jumpRatio - 0.5)*2) * self.trufflesJumpHeight
							-- update shadow size
							local scale = (1.0 - 0.7) + 0.7*((jumpRatio - 0.5)*2)
							self.trufflesShadow.scale = scale
							self.trufflesShadow.alpha = scale
						end

						if ( self.truffles.control.isTouchingGround()) then
							jumpRatio = 1
						end
					end

					if(self.splashes.trufflesWaterSplash.currentFrame == 6) then
						self.splashes.visible = false
					end
				elseif(self.truffles.state.sliding) then
					self.splashes.visible = true
				end
			end,

			slide = function()
				self.truffles.state.sliding = true
			end,

			unslide = function()
				if (self.truffles.state.sliding) then
					self.truffles.state.sliding = false
					self.splashes.trufflesWaterSplash.visible = false
					self.splashes.trufflesMudSplash.visible = false
				end
			end,

			dirty = function()
				self.truffles.state.dirty = true
			end,

			wash = function()
				self.truffles.state.dirty = false
			end
		}


		self.paige.control = {
			jump = function()
				if (not self.paige.state.jumping) then
					self.paige.state.jumping = true
					self.paige.state.jumpStart = self.gameTime
					self.paige.state.jumpRatio = 0
					self.paige.state.jumpStartOffset = self.truffles.y  - self.truffles.anims.run.height*0.5 -- new
					self.paige.state.jumpFallOffset = 0 -- new

					self:playSound("DoubleJump")

					self.truffles.state.paigeless = true
				end
			end,

			update = function()
				if (self.paige.state.jumping) then
					local jumpRatio = (self.gameTime - self.paige.state.jumpStart) / self.paigeJumpDuration
					jumpRatio = self:jumpEase(jumpRatio)

					if (jumpRatio < 1) then
						self.paige.state.jumpRatio = jumpRatio

						-- new
						if (self.paige.state.jumpRatio < 0.5) then
							--jumping up
							--self.paige.y = (self.truffles.y - self.paige.state.jumpStartOffset) +  (self.paige.state.jumpRatio)*2 * (self.paigeJumpHeight - self.paige.state.jumpStartOffset) * -1
							self.paige.y = (self.paige.state.jumpStartOffset) - (self.paige.state.jumpRatio)*2 * (self.paigeJumpHeight )
							self.paige.state.jumpFallOffset = self.paige.y -- new
						else
							--jumping down
							--self.paige.y = (1 - (1.0 - self.paige.state.jumpRatio)*2)*(self.floorPosition - self.paige.state.jumpStartOffset)  + self.paige.state.jumpFallOffset*(1.0 - self.paige.state.jumpRatio)*2
							self.paige.y = (1 - (1.0 - self.paige.state.jumpRatio)*2)*(self.floorPosition)  + self.paige.state.jumpFallOffset*(1.0 - self.paige.state.jumpRatio)*2
						end
					end

					local belowTruffles = jumpRatio > 0.5 and self.paige.y > self.truffles.y - self.truffles.anims.run.height*0.5

					if (jumpRatio >= 1 or belowTruffles) then
						self.truffles.state.paigeless = false
						self.paige.state.jumping = false
						self.paige.y = self.paigeOffset[2]
						jumpRatio = 1
						self.paige.y = self.truffles.y - self.haybaleUnit*0.5

						self:playSound("DoubleJumpEnd")
					end

				else
					self.paige.y = self.truffles.y - self.haybaleUnit*0.5
				end
			end
		}

		-- comment: movement logic was separated from sprites logic
		self.paige.setAnimationBasedOnState = function()
			if (self.paige.state.jumping) then
				self.paige.anims.jump.visible = true

				if (self.paige.state.jumpRatio < 0.5) then
					--jumping up
					self.paige.anims.jump.currentFrame = math.floor(self.paige.state.jumpRatio*3/0.5) -- new
				else
					--jumping down
					self.paige.anims.jump.currentFrame = 4 -- new
				end
			else
				self.paige.anims.jump.visible = false
			end
		end

		self.onceDone = true
	end
end

function SecretGame:undoOnce()
	if (self.onceDone) then
		for i , v in ipairs(self.spritePool) do
			v:remove()
		end

		for i , v in ipairs(self.background) do
			v:remove()
		end

		for i , v in ipairs(self.midgrounds) do
			for j , w in ipairs(v) do
				w:remove()
			end
		end

		self.trufflesShadow:remove()
		self.splashes.trufflesWaterSplash:remove()
		self.splashes.trufflesMudSplash:remove()
		self.truffles:remove()
		self.paige:remove()
	end
end

function SecretGame:reclaimLevelSprites()
--remove old floors
	for k, v in ipairs(self.floors) do
		if v.x + v.width + self.level.x < 0 then
			--outside screen
			v.isUsed = false
			table.remove_item(self.floors, v)
		end
	end
end

function SecretGame:generateFloorRandom()
	self:reclaimLevelSprites()

	while true do
		if self.levelGenerateState.floorAddPositionPointer + self.level.x < self.uw then
			local floorType = math.Random(1,(self.pixelsRan < 3096 and 2) or 3)

			if (self.levelGenerateState.lastFloorType == 3 and self.levelGenerateState.lastFloorTypeCount < 3) then
				floorType = 3
			end

			local floor = self:getAvailableSpriteFromPool(floorType)

			if (floorType ~= 3 and self.levelGenerateState.lastFloorType == 3) then
				self:scheduleAt(self.levelGenerateState.floorAddPositionPointer - self.screenCenter[1] + self.trufflesOffset[1], function()
					self.truffles.control.unslide()
				end)
			end

			if (self.levelGenerateState.lastFloorType ~= floorType) then
				self.levelGenerateState.lastFloorType = floorType
				self.levelGenerateState.lastFloorTypeCount = 1
			else
				self.levelGenerateState.lastFloorTypeCount = self.levelGenerateState.lastFloorTypeCount + 1
			end

			if (floor ~= nil) then
				floor.x = self.levelGenerateState.floorAddPositionPointer
				floor.y = self.floorPosition
				self.levelGenerateState.floorAddPositionPointer = self.levelGenerateState.floorAddPositionPointer + floor.width
				table.insert(self.floors, floor)

				if (floorType == 3 and self.levelGenerateState.lastFloorTypeCount == 1) then
					self:scheduleAt(floor.x - self.screenCenter[1] + self.trufflesOffset[1], function()
						self.truffles.control.slide()
						print ("r slide")
					end)
				end
			else
				assert("Could not find a floor element! Increase pool size!")
				break
			end
		else
			break
		end
	end

	if (self.pixelsRan > self.nextObstacle) then
		self.nextObstacle = self.nextObstacle + math.Random(self.obstacleMinInterval, self.obstacleMaxInterval)

		local obstacle = self:getAvailableSpriteFromPool(10)
		if (obstacle ~= nil) then
			obstacle.x = math.abs(self.level.x) + self.uw + 1
			obstacle.y = self.floorPosition - (obstacle.height / 2.0)

			self:scheduleAt(obstacle.x - 400 - self.uw/2.0, function() self.truffles.control.jump() end)

			table.insert(self.floors, obstacle)
		end
	end
end

function SecretGame:generateFloorColumn(column)
	local data = self:getFloorColumn(column)
	local sprite = nil
	local floorType = nil

	for i=1,#data do
		if (data[i] == "=") then
			sprite = self:getAvailableSpriteFromPool(1)
			floorType = 1
		elseif (data[i] == "_") then
			sprite = self:getAvailableSpriteFromPool(2)
			floorType = 2
		elseif (data[i] == "~") then
			sprite = self:getAvailableSpriteFromPool(3)
			floorType = 3
		elseif (data[i] == "H") then
			sprite = self:getAvailableSpriteFromPool(10)
			self:scheduleAt(self.levelGenerateState.floorAddPositionPointer - self.screenCenter[1] - self.trufflesOffset[1] + self.haybaleUnit,
				function()
					self.gamePoints = self.gamePoints + self.obstacleCatchPoints
					self:playSound("JumpHaybale")
				end)
		elseif (data[i] == "C") then
			sprite = self:getAvailableSpriteFromPool(20)
		elseif (data[i] == "T") then
			sprite = self:getAvailableSpriteFromPool(21)
		elseif (data[i] == " ") then
			sprite = nil
		elseif (data[i] == "\n") then
			sprite = nil
		else
			print ("Unrecognized token: \"" .. data[i] .. "\"")
			break
		end

		if (sprite ~= nil) then
			sprite.x = self.levelGenerateState.floorAddPositionPointer
			--sprite.y = self.floorPosition + ((self.haybaleUnit / 2) * (i - 11)) + (self.haybaleUnit / 2)

			-- comment: placement of sprites have been separated for objects and ground blocks.
			-- ground blocks have the anchor set to top and they should be placed at the floorPosition
			-- new
			if (i < 11) then
				sprite.y = self.floorPosition + ((self.haybaleUnit / 2) * (i - 10))

				-- for hay bales we substract the shadow height
				if (sprite.type == 10) then
					--print("Hay pos " .. sprite.y .. " " .. Tweakables.HayBaleShadowHeight)
					sprite.y = sprite.y + Tweakables.HayBaleShadowHeight
				end
			else -- it's a ground sprite
				sprite.y = self.floorPosition + self.verticalGroundOffset
			end
			-- new end

			-- print ("sprite created: " .. sprite.x .. ", " .. sprite.y)

			table.insert(self.floors, sprite)
		end

	end

	if (floorType ~= nil) then
		if (floorType == 1 and self.levelGenerateState.lastFloorType ~= 1) then
			self:scheduleAt(self.levelGenerateState.floorAddPositionPointer - self.screenCenter[1] - self.trufflesOffset[1], function()
				self.truffles.control.unslide()
			end)
		end

		-- we check if it's the first block of a new floor
		if (self.levelGenerateState.lastFloorType ~= floorType) then
			self.levelGenerateState.lastFloorType = floorType
			self.levelGenerateState.lastFloorTypeCount = 1
		else
			self.levelGenerateState.lastFloorTypeCount = self.levelGenerateState.lastFloorTypeCount + 1
		end

		if ((floorType == 3 or floorType == 2)) then
			if(floorType == 3) then
				local checkWaterSlide =
					function()
						if (self.truffles.control.isTouchingGround() and not self.truffles.state.sliding) then
							self.truffles.control.slide()
							self.splashes.trufflesWaterSplash.currentFrame = 0
							self.splashes.trufflesWaterSplash.visible = true
							self:playSound("HitWater")

							if (self.truffles.state.dirty) then
								self.truffles.control.wash()

								-- debug
								--self.actionLabel.text = "Washed!"
								-- end debug
							else
								-- boost!
								self.levelSpeed = self.levelSpeed + Tweakables.CalculateSpeedBoostWater(self)
								self:playSound("SpeedBoost")

								-- debug
								--self.actionLabel.text = "Speed up!"
								-- end debug
							end
							--print("water hit!")
						end
					end
				self:scheduleAt(self.levelGenerateState.floorAddPositionPointer - self.screenCenter[1] - self.trufflesOffset[1], checkWaterSlide)
			elseif (floorType == 2) then
				local checkMudSlide =
					function()
						if (self.truffles.control.isTouchingGround() and not self.truffles.state.sliding) then
							self.truffles.control.dirty()
							self.truffles.control.slide()
							self.splashes.trufflesMudSplash.currentFrame = 0
							self.splashes.trufflesMudSplash.visible = true
							self:playSound("HitMud")
							-- decrease speed
							self.levelSpeed = self.levelSpeed - Tweakables.CalculateSpeedDecreaseDirt(self)
							-- debug
								--self.actionLabel.text = "Dirty!"
								--print("mud hit!")
							-- end debug
						end
					end
				self:scheduleAt(self.levelGenerateState.floorAddPositionPointer - self.screenCenter[1] - self.trufflesOffset[1], checkMudSlide)
			end
		else
			if (math.Random(0,100) < 33) then
				local bush = self:getAvailableSpriteFromPool(50)
				if (bush) then
					bush.x = self.levelGenerateState.floorAddPositionPointer + math.Random(-30, 30)
					bush.y = self.floorPosition + self.verticalGroundOffset + math.Random(10, 30)
					bush.scale = math.Random(0.8, 1.3)

					table.insert(self.floors, bush)
				end
			end
		end
	end

	self.levelGenerateState.floorAddPositionPointer = self.levelGenerateState.floorAddPositionPointer + self.haybaleUnit
end

function SecretGame:getFloorColumn(column)
	local chunk = self:getLevelChunk()

	if (chunk == nil) then
		print ("Chunk: ---\n" .. (chunk or "nil(" .. (self.levelGenerateState.currentGroup or "nil") .. ", " .. self.levelGenerateState.currentIndex .. ", " .. (self.levelGenerateState.currentSecondIndex or "nil") .. ")") .. "\n---")
	end

	local columnData = {}

	for row in string.gmatch(chunk, "([^\n]*)\n") do
		row = string.sub(row, 1, -1) --strip newline
		if (string.len(row) < column) then
			self:pickNewLevelChunk(self.levelGenerateState.currentGroup, self.levelGenerateState.currentIndex, self.levelGenerateState.currentSecondIndex)
			column = 1
			self.levelGenerateState.currentColumn = column
			if (self.playing) then
				self.chunkChangeCount = self.chunkChangeCount + 1
				self.chunkChangeCountLevel = self.chunkChangeCountLevel + 1
			end

			if (self.chunkChangeCountLevel > Tweakables.LevelupAfterXChunks) then
				self.difficultyLevel = self.difficultyLevel + 1
				self.difficultyLevel = math.min(self.difficultyLevel, Tweakables.LevelMax)
				self.chunkChangeCountLevel = 0
				self.acceleration = Tweakables.AccelerationStart + (Tweakables.AccelerationMax - Tweakables.AccelerationStart) * ((self.difficultyLevel - 1) / Tweakables.LevelMax)

				print ("difficultyLevel: " .. self.difficultyLevel)
			end

			return self:getFloorColumn(column)
		else
			local c = string.sub(row, column, column)
			-- print ("Colum #" .. column .. " = " .. c .. " (" .. row .. ")")
			table.insert(columnData, c)
		end
	end

	return columnData
end

function SecretGame:pickNewLevelChunk(groupName, firstIndex, secondIndex)
	if (groupName == "tutorials") then
		self.levelGenerateState.currentIndex = self.levelGenerateState.currentIndex + 1
		if (#self.levelChunks[self.levelGenerateState.currentGroup] < self.levelGenerateState.currentIndex) then
			self:pickNewLevelChunk("fillers", 1, nil)
			return
		end
	else
		if (groupName == "fillers" and self.playing) then
			self:pickNewLevelChunk("chunks", 1, nil)
			return
		elseif (groupName == "chunks") then
			local chanceRatio = (self.chunkChangeCountLevel / Tweakables.LevelupAfterXChunks) / 2
			if (math.__old_random() < chanceRatio) then
				local innerChanceRatio = self.difficultyLevel / Tweakables.LevelMax
				if (math.__old_random() < innerChanceRatio) then
					self:pickNewLevelChunk("rich", 1, nil)
				else
					self:pickNewLevelChunk("poor", 1, nil)
				end
				return
			else
			end
		elseif ((groupName == "poor" and self.levelGenerateState.currentGroup == "poor") or (groupName == "rich" and self.levelGenerateState.currentGroup == "rich")) then
			self:pickNewLevelChunk("chunks", 1, nil)
			return
		end

		self.levelGenerateState.currentGroup = self:pickNewGroupName(groupName)
		self.levelGenerateState.currentIndex = self:pickNewFirstIndex(firstIndex)
		self.levelGenerateState.currentSecondIndex = self:pickNewSecondIndex(secondIndex)

	end
	print ("picked new levelChunk: " .. self.levelGenerateState.currentGroup .. ", " .. self.levelGenerateState.currentIndex .. ", " .. (self.levelGenerateState.currentSecondIndex or "nil"))
end

function SecretGame:pickNewGroupName(oldGroupName)
	--add some heuristic here to change groupname
	return oldGroupName
end

function SecretGame:pickNewFirstIndex(oldFirstIndex)
	if (#self.levelChunks[self.levelGenerateState.currentGroup] > 1) then
		local newIndex = oldFirstIndex
		if (self.levelGenerateState.currentGroup == "chunks") then
			local radius = math.ceil(#self.levelChunks[self.levelGenerateState.currentGroup] / Tweakables.ChunkRandomSearchRadiusDivider)
			local chunkCenterIndex = math.floor((self.difficultyLevel / Tweakables.LevelMax) * #self.levelChunks[self.levelGenerateState.currentGroup])
			local startSearch = math.max(chunkCenterIndex - radius, 1)
			local endSearch = math.min(chunkCenterIndex + radius, #self.levelChunks[self.levelGenerateState.currentGroup])
			newIndex = math.Random(startSearch, endSearch);
		else
			newIndex = math.Random(1, #self.levelChunks[self.levelGenerateState.currentGroup]);
			while (newIndex == oldFirstIndex) do
				newIndex = math.Random(1, #self.levelChunks[self.levelGenerateState.currentGroup]);
			end
			-- print ("newIndex: " .. newIndex .. " max: " .. #self.levelChunks[self.levelGenerateState.currentGroup])
		end
		return newIndex;
	else
		return oldFirstIndex
	end
end

function SecretGame:pickNewSecondIndex(oldSecondIndex)
	if (type(self.levelChunks[self.levelGenerateState.currentGroup][self.levelGenerateState.currentIndex]) == "table") then
		if (#self.levelChunks[self.levelGnrenerateState.currentGroup][self.levelGenerateState.currentIndex] > 1) then
			local newIndex = math.Random(1, #self.levelChunks[self.levelGenerateState.currentGroup][self.levelGenerateState.currentIndex]);
			while (newIndex == oldFirstIndex) do
				newIndex = math.Random(1, #self.levelChunks[self.levelGenerateState.currentGroup][self.levelGenerateState.currentIndex]);
			end
			return newIndex
		else
			return oldSecondIndex
		end
	else
		return nil
	end
end

function SecretGame:getLevelChunk(doIterate)
	local chunk = nil

	if (type(self.levelChunks[self.levelGenerateState.currentGroup]) == "table") then
		if (self.levelGenerateState.currentSecondIndex == nil) then
			chunk = self.levelChunks[self.levelGenerateState.currentGroup][self.levelGenerateState.currentIndex]
			-- print ("LevelChunk: " .. self.levelGenerateState.currentGroup .. ", " .. self.levelGenerateState.currentIndex)
		else
			chunk = self.levelChunks[self.levelGenerateState.currentGroup][self.levelGenerateState.currentIndex][self.levelGenerateState.currentSecondIndex]
			-- print ("LevelChunk: " .. self.levelGenerateState.currentGroup .. ", " .. self.levelGenerateState.currentIndex .. ", " .. self.levelGenerateState.currentSecondIndex)
		end
	end

	return chunk
end

function SecretGame:generateFloor()
	self:reclaimLevelSprites()

	while true do
		if self.levelGenerateState.floorAddPositionPointer + self.level.x - self.haybaleUnit < self.uw then
			self:generateFloorColumn(self.levelGenerateState.currentColumn)
			self.levelGenerateState.currentColumn = self.levelGenerateState.currentColumn + 1
		else
			break
		end
	end
end

function SecretGame:onIntroAnimationFinished(firstTime)
end

function SecretGame:updateBackground()
	-- self.bgLayer.x = self.level.x * 0.05
	-- self.bgLayer.y = self.level.y * 0.05

	self.level.y = ((self.floorPosition + self.trufflesOffset[2]) - self.truffles.y) * 0.25
	self.trufflesShadow.y = (self.trufflesOffset[2]) + (self.level.y - self.trufflesOffset[2]) + self.floorPosition


	self.midLayer0.x = self.level.x * 0.05
	self.midLayer0.y = self.level.y * 0.05

	self.midLayer1.x = self.level.x * 0.2
	self.midLayer1.y = self.level.y * 0.2

	self.midLayer2.x = self.level.x * 0.4
	self.midLayer2.y = self.level.y * 0.4

	self.midLayer3.x = self.level.x * 2
	self.midLayer3.y = self.level.y * 2

	-- for _,v in ipairs(self.backgrounds) do
	-- 	if (v.x + v.width + self.bgLayer.x < 0) then
	-- 		v.x = self.backgrounds[#self.backgrounds].x + self.backgrounds[#self.backgrounds].width
	-- 		table.remove_item(self.backgrounds, v)
	-- 		table.push_back(self.backgrounds, v)
	-- 	end
	-- end

	for id,midground in ipairs(self.midgrounds) do
		for _,v in ipairs(midground) do
			local key = "midLayer" .. (id - 1)
			if (v.x + v.width + self[key].x < 0) then
				v.x = self.midgrounds[id][#self.midgrounds[id]].x + self.midgrounds[id][#self.midgrounds[id]].width
				table.remove_item(self.midgrounds[id], v)
				table.push_back(self.midgrounds[id], v)
			end
		end
	end

	-- while (true) do
	-- 	local prevRight = 0
	-- 	if (#self.backgrounds > 0) then
	-- 		prevRight = self.backgrounds[#self.backgrounds].x + self.backgrounds[#self.backgrounds].width
	-- 	end
	-- 	if (prevRight + self.bgLayer.x > self.uw) then
	-- 		break
	-- 	end
	-- end

	local breakstates = {false, false, false}
	while (true) do
		for id,midground in ipairs(self.midgrounds) do
			if (not breakstates[id]) then
				local prevRight = 0
				local key = "midLayer" .. (id - 1)
				if (#self.midgrounds[id] > 0) then
					prevRight = self.midgrounds[id][#self.midgrounds[id]].x + self.midgrounds[id][#self.midgrounds[id]].width
				end
				if (prevRight + self[key].x > self.uw) then
					breakstates[id] = true
				end
			end
		end
		if (breakstates[1] and breakstates[2] and breakstates[3]) then
			break;
		end
	end
end

function SecretGame:updateLevel(time)
	local pixelMoveDelta = self.levelSpeed * time -- This should take acceleration into account
	local pixelMoveDelta = 0.5*self.acceleration*time*time + self.levelSpeed*time

	self.level.x = self.level.x - pixelMoveDelta
	if (self.playing) then
		self.pixelsRan = math.abs(self.level.x)
		self.metersRan = self.pixelsRan/160 -- not needed
	end

	self.positionSinceLastFrameChange_Run = self.positionSinceLastFrameChange_Run + pixelMoveDelta

	if (self.positionSinceLastFrameChange_Run > self.pixelsMovedPerFrame) then
		self.positionSinceLastFrameChange_Run = self.positionSinceLastFrameChange_Run - self.pixelsMovedPerFrame
		local currentFrame = (self.truffles.anims.run.currentFrame + 1) % self.moveCycleFrameCount;
		self.truffles.setCurrentFrame(currentFrame);

		if (not self.truffles.state.jumping) then
			if (not self.truffles.state.sliding) then
				if (currentFrame == 1) then
					if (math.Random(1,2) == 1) then
						self:dustAt(self.truffles.anims.run, math.Random(1.3,1.8))
					end
				end
				if (currentFrame == 5) then
					self:dustAt(self.truffles.anims.run, math.Random(1.8,2.8))
				end
			else
				--self:dustAt(self.truffles.anims.run, math.Random(1.8,2.2))
			end
		end
	end

	self:updateSchedule()

	self:calculateJumpDurations()

	self.truffles.control.update()
	self.paige.control.update()

	self.truffles.setAnimationBasedOnState()
	self.paige.setAnimationBasedOnState()

	self:updateCollisions()

	self:updateBackground()

	self:generateFloor()

	if (self.playing) then
		self.levelSpeed = self.levelSpeed + (self.acceleration * time)
		self.levelSpeed = math.min(self.levelSpeed, Tweakables.SpeedMax)
		self.levelSpeed = math.max(self.levelSpeed, Tweakables.SpeedStart)
	end

	-- print ("a: " .. self.acceleration .. ", speed: " .. self.levelSpeed)
end

function SecretGame:updateCollisions()
	for k, v in ipairs(self.floors) do
		if (v.type < 10) then
			--do nothing

		else
			local object = {x = v.x, y = v.y, width = v.width, height = v.height,}

			if (v.type == 10) then
				object.x = object.x + 43 -- extra shadow space of the hay bale
				object.y = object.y - Tweakables.HayBaleShadowHeight
				object.width = self.haybaleUnit
				object.height = self.haybaleUnit*0.75
			end

			local paigeRel = {
				math.abs((self.paige.x - self.level.x) - object.x),
				math.abs((self.paige.y - self.level.y) - object.y),
			}

			local trufflesAnim = self.truffles.anims.run

			if(self.truffles.state.jumping) then
				trufflesAnim = self.truffles.anims.jumppaigeless
			end

			local trufflesRel = { -- new
				math.abs((self.truffles.x - self.level.x) - object.x ),
				math.abs((self.truffles.y - trufflesAnim.height*0.5 - self.level.y) - (object.y - object.height*0.5)),
			}

			-- we substract some y pos for jumping collision
			if(self.truffles.state.jumping) then
				trufflesRel[2] = trufflesRel[2] - 20
			end

			-- comment: pickups are being disabled in order to prevent grabbing them more than once
			if (paigeRel[1] < self.haybaleUnit/2 and paigeRel[2] < self.haybaleUnit/2) then
				--paige hit something
				if (v.type == 20 and v.active == true) then
					-- point caught
					self:blingAt(v)
					v.visible = false
					v.active = false

					self.gamePoints = self.gamePoints + self.fruitCatchPoints

					self:playSound("HitSmallPickup")
				elseif (v.type == 21 and v.active == true) then
					-- big points caught!
					self:blingAt(v)
					v.visible = false
					v.active = false

					self.gamePoints = self.gamePoints + self.truffleCatchPoints

					self:playSound("HitBigPickup")
				end
			end

			-- checks a radius
			if (trufflesRel[1] < trufflesAnim.width*0.25 + object.width*0.5 and trufflesRel[2] < trufflesAnim.height*0.4 + object.height*0.5) then
				--truffles hit something
				if (v.type == 10) then
					--HAYBALE!!
					self:particlesAt(v, math.Random(4,6), self.dustParticleEmitter, 8, {500, 500})

					if(not self.died) then
						self.died = true
						self.gameStarting = true
						self:createGameOverAnimation()
					end

					self:playSound("HitHaybale")

				elseif (v.type == 20 and v.active == true) then
					-- point caught
					self:blingAt(v)
					v.visible = false
					v.active = false

					print ("trufflesRel: " .. trufflesRel[1] .. ", " .. trufflesRel[2] .. " (" .. v.type .. ")")
					self.gamePoints = self.gamePoints + self.fruitCatchPoints

					self:playSound("HitSmallPickup")

				elseif (v.type == 21 and v.active == true) then
					-- big points caught!
					self:blingAt(v)
					v.visible = false
					v.active = false

					self.gamePoints = self.gamePoints + self.truffleCatchPoints

					self:playSound("HitBigPickup")
				end
			end

			if (v.type == 10) then
				--print ("trufflesRel: " .. trufflesRel[1] .. ", " .. trufflesRel[2] .. " (" .. v.type .. ")")
			end
		end
	end
end

function SecretGame:updateLayer(layer)
	local child = layer:child()
	if (child) then
		local min = 9999999
		local n = child
		while (n) do
			if (n.x < min) then
				min = n.x
			end
			n = n.sibling
		end
		if (min > 0) then
			n = child
			while (n) do
				n.x = n.x - min
				n = n.sibling
			end
			layer.x = layer.x + min
		end
	end
end

function SecretGame:onMouseLeftDown()
	if (not self.playing and not self.gameStarting) then
		self.levelGenerateState.currentGroup = "tutorials"
		self.playing = true
		-- hide logo and start text
		self.gameLogo:animate({y=-self.gameLogo.height, alpha=0, duration=500, style="easeOut"})
		self.startGameLabel:animate({alpha=0, duration=500, style="easeOut"})

		-- show score
		self.distanceTextLabel.visible = true
		self.distanceLabel.visible = true

		self:playSound("GameStart")
	end

	if (self.playing) then
		if (self.truffles.state.jumping) then
			if (not self.paige.state.jumping) then
				self.paige.control.jump()
			end
		else
			self.truffles.control.jump()
		end
	end
end

function SecretGame:onMouseLeftUp()
end

function SecretGame:onTick(time)
	self:tick(time)
	self.cummTime = (self.cummTime or 0) + time
	while (self.cummTime > 30) do
		self.cummTime = self.cummTime - 30
		self:onUpdate(30)
	end
end

function SecretGame:onUpdate(time)
	self.gameTime = self.gameTime + time;
	self:updateLabels()
	--self:updateLabelPositions()

	if (self.isMouseDownTimer > 0) then
		self.isMouseDownTimer = self.isMouseDownTimer - time
	end

	if (not self.died) then
		self:updateLevel(time)
	end
end

function SecretGame:dustAt(obj, scale)
	self:particlesAt(obj, scale, self.dustParticleEmitter, 2, {obj.parent.x + self.dustParticleOffset[1], obj.parent.y + obj.height + self.dustParticleOffset[2]})
end

function SecretGame:blingAt(obj, scale)
	self:particlesAt(obj, scale, self.blingParticleEmitter, 4)
end

function SecretGame:particlesAt(obj, scale, effect, repetitions, offset)
	if (repetitions == nil) then
		repetitions = 2
	end

	if (offset == nil) then
		offset = {0, 0}
	end

	for i=1,repetitions do
		local s = scale or math.Random(1.2, 2.5)
		local fx = self.level:addChild({class="ParticleEffect", x=math.abs(self.level.x) + obj.x + offset[1], y=obj.y + offset[2], library="effects:particles", emitter=effect, play=true, scale=s})
	end
end

function SecretGame:collisionDust(obj) -- TO DO check
	obj.parent:addChild({class="ParticleEffect", x=obj.x, y=obj.y, library="effects:particles", emitter="click_fix", play=true, scale=3})
	obj.parent:addChild({class="ParticleEffect", x=obj.x, y=obj.y, library="effects:particles", emitter="click_fix", play=true, scale=2})
	obj.parent:addChild({class="ParticleEffect", x=obj.x, y=obj.y, library="effects:particles", emitter="click_fix", play=true, scale=5, color=0xff999999})
end

function SecretGame:updateLabels()
	local distanceText = GH.getText("SECRET_METERS")
	self.distanceLabel.text = self.gamePoints--string.format(distanceText, GH.toNumberString(self.gamePoints, true))

	--local coinsText = GH.getText("SECRET_COINS")
	--self.coinsLabel.text = string.format(coinsText, GH.toNumberString(self.coinScore, true))

	-- debug
	--[[
	self.pixelsRanLabel.text = "Pixels: " .. tostring(self.pixelsRan)
	self.speedLabel.text = "Speed: " .. self.levelSpeed*1000 .. " px/s"
	self.accLabel.text = "Acc: " .. self.acceleration*1000000 .. " px/s2"
	self.stateLabel.text = "Dirty: " .. tostring(self.truffles.state.dirty)
	--]]
	-- debug end
end

function SecretGame:onCloseButtonClicked()
	local mapScene = GH.createScene("map")
	GH.setTransition("defaultTransition")
	GH.gotoScene(mapScene)
end

function SecretGame:createGameOverAnimation()
	self:onGameOverAnimationFinished()
end

function SecretGame:onGameOverAnimationFinished()
	self.secretScoresPath = GH.getSavedDataDir()
	if (#self.secretScoresPath > 0) then
		self.secretScoresPath = self.secretScoresPath.."/"
	end
	self.secretScoresPath = self.secretScoresPath.."secretscoresd13.dat"
	dofile(self.secretScoresPath, false)
	self.secretScores = _G.secretScores or {}
	_G.secretScores = nil

    self.scoreTable = {name="", points=self.gamePoints}--, score=self.coinScore}
	if (self.gamePoints > 0) then
		table.push_back(self.secretScores, self.scoreTable)
	end
	table.sort(self.secretScores, function(a,b) return a.points and (not b.points or a.points > b.points) end) -- Sort by descending "points"
	while (#self.secretScores > self.maxSecretScores) do
		table.pop_back(self.secretScores)
	end
	serializeTable("secretScores", self.secretScores, self.secretScoresPath)

	self:animate({delay=150}, {call=function() self:startGameOverScoreAnimation() end})
end

function SecretGame:startGameOverScoreAnimation()
	self.blackBackground = self:newChild({class="Sprite", draw="color", color="black", width=self.uw, height=self.uh, alpha=0})
	self.blackBackground:animate({alpha=0.75, duration=400})

	self:addChild(self.backButton)
	self:addChild(self.continueButton)

	self.continueButton.x = self.uw + 200
	self.continueButton.y = self.uh + 200

	self.distanceLabel:relocateAnchor("center")
	self:addChild(self.distanceLabel)
	self.distanceLabel:animate(
		{x=self.uw/2, y=self.uh/2, duration=500, style="easeInOut"},
        {delay=1500},
        {alpha=0,duration=500})
	self.distanceLabel:animate(
		{scale=0.8, duration=500/2, style="easeInOut"},
		{scale=3, duration=500/2, style="easeInOut"})

	self.distanceTextLabel:relocateAnchor("center")
	self:addChild(self.distanceTextLabel)
	self.distanceTextLabel:animate(
		{x=self.uw/2, y=self.uh/2 - self.distanceLabel.height*1.5, duration=500, style="easeInOut"},
        {delay=1500},
        {alpha=0,duration=500})
	self.distanceTextLabel:animate(
		{scale=0.5, duration=500/2, style="easeInOut"},
		{scale=1, duration=500/2, style="easeInOut"})

	--self.coinsLabel:animate({alpha=0,druation=100})
	--self.coinScoreSprite:animate({alpha=0,druation=100})

	self:animate(
		{delay=1500},
		{call=function() self:createEnormousCoinExplosion() end})
end

function SecretGame:createEnormousCoinExplosion()
	local numCoins =  self.gamePoints--math.min(7 + self.gamePoints, 200)

	if (numCoins > 0) then
		numCoins =  math.min(numCoins, 200)
		local arc = math.pi*2 / numCoins

		for i=1,numCoins do
			local coinImage = "button#truffle1-a:room5_icons"
			if(math.Random(2) == 2) then
				coinImage = "button#fruit3-b:room5_icons"
			end

			local coin = self:newChild({class="Sprite", image=coinImage, frameTime=80, scale=0.2, visible=false, x=self.uw/2, y=self.uh/2, anchor="center"})
			coin.frame = math.clamp(math.Random(coin.frameCount), 0, coin.frameCount-1)
			local angle = arc*i + math.Random(0, arc)
			local delay = math.Random(0, numCoins*12)
			coin:animate(
                {delay=delay},
                {visible=true},
                {x=self.uw*(math.sin(angle)+1)/2, y=self.uh*(math.cos(angle)+1)/2, scale=1.3, duration=500, style="easeOut"})
			coin:animate({delay=delay+300}, {alpha=0, duration=200}, {remove=true})
		end

		self:playSound("GameEnd")

		self:animate(
			{delay=200 + 8*numCoins},
			{call=function() self:showHighscoreList() end})
	else
		self:showHighscoreList()
	end
end

function SecretGame:showHighscoreList()
	local hasHighlightedLabel = false
	self.highscoreParent = self:newChild({class="Sprite"})
	if (#self.secretScores <= 0) then
		self.highscoreParent:newChild({class="Label", textSize=120, setup=setups.outline, textId="NO_HIGHSCORES", anchor="center", x=self.uw/2, y=self.uh/2 + 192})
	else
		self.scoreList = self.highscoreParent:newChild({class="GameNode", x=280, y=350})
		for k,v in ipairs(self.secretScores) do
			local i = k-1
            local delay = i*100
			local number = v.points or 1
			local coin = self.scoreList:newChild({class="Sprite", image="truffles_die:truffles", frameTime=0, alpha=0, anchor="center", scale=0.8, x=0, y=i*200})
			coin:animate({delay=delay},{alpha=1,duration=200})

			local labelS = self.scoreList:newChild({class="Label", alpha=0, textSize=100, setup=setups.outline, textId="SECRET_METERS", anchor="right", x=250, y=i*200})
			labelS.text = number
			labelS:animate({delay=delay},{alpha=1,duration=200})

			local label = self.scoreList:newChild({class="Label", alpha=0, textSize=labelS.textSize, setup=setups.outline, text=tostring(v.name or ""), anchor="left", x=300, y=i*200})
			label:animate({delay=delay},{alpha=1,duration=200})

			if (not hasHighlightedLabel and v == self.scoreTable) then
				hasHighlightedLabel = true
				local labelHLS = self.scoreList:newChild({class="Label", alpha=0, textSize=labelS.textSize, setup=setups.outline, text=labelS.text, anchor=labelS.anchor, x=labelS.x, y=labelS.y, color0=0x356eb9, color1=0x356eb9})
				labelHLS:animate({delay=delay},{blink={startAlpha=0, endAlpha=0.7,fadeIn=600,fadeOut=600}})

				local labelHL = self.scoreList:newChild({class="Label", alpha=0, textSize=labelS.textSize, setup=setups.outline, text=label.text, anchor=label.anchor, x=label.x, y=label.y, color0=0x356eb9, color1=0x356eb9})
				labelHL:animate({delay=delay},{blink={startAlpha=0, endAlpha=0.7,fadeIn=600,fadeOut=600}})

				self.underscore = self.scoreList:newChild({class="Label", alpha=0, textSize=100, setup=setups.outline, text="_", anchor="left", y=i*200})
				self.underscore:animate({delay=delay},{blink={startAlpha=0, endAlpha=1,fadeIn=100,fadeOut=100}})

				local keyboardWidth = 5
				local keyboardHeight = 10
				local kbw = 80
				local kbh = 80
				local space = 4
				self.keyboard = self.highscoreParent:newChild({class="Sprite", y=100})
				self.keyboard.layout = function()
					self.keyboard.scale = self.uh / (keyboardHeight*(kbh + space) + 70 + self.keyboard.y)
					self.keyboard.x = self.uw - self.keyboard.y/2 - keyboardWidth*(kbw + space)*self.keyboard.scaleX
				end
				self.keyboard.layout()

				local updateKeyboard = function()
					if (self.backspace) then self.backspace.enabled = true end
					if (self.scoreLabel) then self.scoreLabel.text = self.scoreTable.name end
					if (self.scoreLabelHL) then self.scoreLabelHL.text = self.scoreTable.name end
					if (self.underscore) then
						if (#self.scoreTable.name <= 0) then
							self.underscore.x = self.scoreLabel.x
						else
							self.underscore.x = self.scoreLabel.x + self.scoreLabel.width - 20
						end
						self.underscore.visible = (#self.scoreTable.name < self.maxScoreNameLength)
					end
				end

				local keyboardCharacters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ!?&@*$#+-0123456789_. "
				for c = 1,#keyboardCharacters do
					local kbx = (c-1) % keyboardWidth
					local kby = math.floor((c-1) / keyboardWidth)
					local char = string.sub(keyboardCharacters, c, c)
					local x = kbx*(kbw+space)
					local y = kby*(kbh+space)
					self.keyboard:newChild({class="Button", image="letter:minigame", x=x, y=y, downScale=0.9,
						onClick=function()
							if (#self.scoreTable.name < self.maxScoreNameLength) then
								self.scoreTable.name = self.scoreTable.name..char
							end
							updateKeyboard()
						end
					})
					self.keyboard:newChild({class="Label", setup=setups.txt, text=char, textSize=50, color0=0xffffff, x=x+kbw/2, y=y+kbh/2, anchor="center"})
				end
				self.backspace = self.keyboard:newChild({class="Button", image="backspace:minigame", x=(keyboardWidth-2)*(kbw+space), y=(keyboardHeight-1)*(kbh+space), downScale=0.9, enabled=false, onClick=function()
						if (#self.scoreTable.name > 0) then
							self.scoreTable.name = string.sub(self.scoreTable.name, 0, #self.scoreTable.name-1)
						end
						updateKeyboard()
					end
				})

				self.scoreLabel = label
				self.scoreLabelHL = labelHL
				updateKeyboard()
			end
		end
	end

	self.continueButton.enabled = true
	self.continueButton.visible = true
	self.continueButton.alpha = 0
	self.continueButton:animate(
		{delay=400},
		{x=self.uw-10, y=self.uh-10},
		{alpha=1, dutation=400},
		{enabled=true})
end

function SecretGame:onContinueButtonClicked()
	--print("ON BUTTON CLICKED")
	serializeTable("secretScores", self.secretScores, self.secretScoresPath)

	self.continueButton.enabled = false
	self.continueButton.x = self.uw + 200
	self.continueButton.y = self.uh + 200

	self.continueButton:animate({alpha=0, duration=100},{visible=false})
	self.blackBackground:animate({alpha=0.0, duration=100},{remove=true})
	self.highscoreParent:animate({alpha=0.0, duration=100},{remove=true})


	self.blackBackground = nil
	self.highscoreParent = nil
	self.backspace = nil
	self.scoreLabel = nil
	self.scoreLabelHL = nil
	self.underscore = nil
	self.keyboard = nil
	self.scoreList = nil

	self:animate(
		{delay=500},
		{call=function()
			self:restartGame(false)
		end})
end
